      program funpar1
c**********************************************************************
c*  Programa para calcular  la gran funcion de particion del modelo:
c*
c*  2\epsilon S_0 + \omega_b b^\dagger b 
c*        + V_1( vp*(S+^2 b  + S-^2 b^t) +
c*               vs*2*S-S-(b + b^t)      +
c*               vv*(S+^2 b^t  + S-^2 b)  )
c*
c*  y modelos bosonicos
c*   
c*   Requiere  que primero se corra funpar0.f que escribe los
c*   eigenvalores para todos los pseudoespines en el archivo:
c*    eva00.dat.
c*   y valores de expectacion (nq+nq-)/2, n_2g en vae00.dat
c+   Este programa es de doble precision
c**********************************************************************
c* Sergio Lerma 7 mayo 2002                                           *
c**********************************************************************
      implicit real*8 (A-H,O-Z)
      integer omega,ngmax
      common /temp/tmin,tmax,tdel
      common /poqui/vmin,vmax,vdel
      common /parametros/epsilon,omegab,v1,e0,pr
c ARCHIVOS
c  Variables de entrada
      open(unit=1,file="funpar.in")
c  Eigenenergias para todos los seudoespines
      open(unit=2,file="eva00.dat")
c Valores de expectacion: (nq+nq_)/2 y n_2g para todo pseudoespin 
      open(unit=9,file="vae00.dat")
c  Salida 
      open(unit=3,file="funpardp.dat")
c  mu vs T para Presion (energia)  fija
      open(unit=4,file="presiondp.dat")
c Lee variables de entrada.
      read(1,*) !epsilon,omegab,v1
      read(1,*) epsilon,omegab,v1
      read(1,*) !omega
      read(1,*) omega
      read(1,*) !ngmax
      read(1,*) ngmax
      read(1,*) ! usar todas los eigenvalores (0) o solo nrootx (1)
      read(1,*) npd
      read(1,*) !nrootx
      read(1,*) nrootx       
      read(1,*) !1 calcular valores de expect, otro no calcular
      read(1,*) nev
      read(1,*) ! 1 modelo bosonico, 2 con corte, otro diag. exacta
      read(1,*) nmb
      read(1,*) !Pesos de los terminos de interaccion
c               !Pair creation,Scattering,Vacuum corelations
      read(1,*) vp,vs,vv
c Hasta aqui mismas variables que para funpar0.f
      read(1,*) !tmin,tmax,tdel        (Temperatura)
      read(1,*) tmin,tmax,tdel
      read(1,*) !vmin,vmax,vdel        (Potencial quimico)
      read(1,*) vmin,vmax,vdel
      read(1,*) !                      (Presion ^1/4)
      read(1,*) p
c Energia correspondiente a la presion p**4
      pr=(p**4)*(12**3)
c Lee estado base 
      read(2,46) e0
46    format(1x,16(1x,f18.5))   
    
      call principal (ngmax,omega,nev)
      stop
      end
c**********************************************************************
       subroutine principal (ngmax,omega,nev)
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c+    Variables:
c+     Eignevalores:
c+      e(# eigenvalor, paridad 1=+ 2-, 2*pseudoespin)
c+     Numero de eigenvalores para cada paridad y pseudoespin 
c+      numeig( paridad 1=+ 2- , 2*pseudoespin) 
c+
c+      Z: funcion de particion
c+      vexe:   <E>
c+      vexec:  <E^2>
c+      vexn:   <nq-nq_>
c+      vexndt: <2*tau>
c+      vexns:  <nq+nq->
c+      vexg:   <n_2g>    
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      implicit real*8 (A-H,O-Z)
      integer omega,ngmax,nev
      real*8 fak(0:2*omega)                     ! factoriales
      real*8 e((omega+1)*(ngmax+1),2,0:2*omega) ! eigenvalores 
      integer numeig(2,0:2*omega)               ! # de eigenvalores
      real*8 xmom((omega+1)*(ngmax+1),2,0:2*omega)! (nq+nq-)/2=m+omega
      real*8 xglu((omega+1)*(ngmax+1),2,0:2*omega)! n_2g
      common /parametros/epsilon,omegab,v1,e0,pr
      common /temp/tmin,tmax,tdel
      common /poqui/vmin,vmax,vdel
c subrutina que calcula  factoriales 
      call fac (omega,fak)
c a leer  eigenvalores desde eva00.dat
        
      do ndt=2*omega,0,-1
        do  nep=1,2
         read(2,*) nrootx,nex,ndj !# de eigenvalores, P 0=+ y 2=-, 2J  

         if (nev.eq.1) then
                
            read(9,*) mu1,mu2,mu3
            
            if (mu1.ne.nrootx.or.(mu2.ne.nex .or. mu3.ne.ndj)) then
              Write(*,*) "ERROR leyendo valores de vae00.dat"
              stop
            end if  
         end if   
         if (ndj.ne.ndt.or. nex.ne.2*(nep/2)) then
            Write(*,*) "ERROR leyendo eigenvalores de eva00.dat"
            stop
         end if   
         numeig(nep,ndj)=nrootx
         do nco=1,nrootx
              read(2,560) ev 

              e(nco,nep,ndj)=ev
              
              if(nev.eq.1) then
                 read(9,560) xqq,xgg
                 
                 xmom(nco,nep,ndj)=xqq
                 xglu(nco,nep,ndj)=xgg
              end if   
         end do
        end do
      end do
560   format(1x,16(1x,f12.4))   
 
      if (vdel.eq.0) then
          vmax=vmin+1.0
          vdel=2.0
      end if
      if (tdel.eq.0) then
          tmax=tmin+1.0
          tdel=2.0
      end if
      numl=(int((vmax-vmin)/vdel)+1)*(int((tmax-tmin)/tdel)+1)
      write(*,*) " Total de pasos: ", numl
      write(*,*) "Avance: "
      do v=vmin,vmax,vdel  !loop potencial quimico
       do t=tmin,tmax,tdel  !loop temperatura   
         numh=(int((v-vmin)/vdel)+1)*(int((t-tmin)/tdel)+1) 
         write(*,*)  !numh," pasos de ",numl,"  "
     &               ,int(100.0*numh/numl)," %" 
c inicializando valores de expectacion 
         Z=0.0
         vexe=0.0
         vexec=0.0
         vexn=0.0
         vexndt=0.0
         vexns=0.0
         vexg=0.0
         do ndt=0,2*omega         !(loop 2*tau ver Kuriyama paper)
           if (ndt.eq.2*(ndt/2)) then
              nklim=ndt/2          !(para tau entero)
           else
              nklim = (ndt-1)/2    !(para tau semientero)
           end if
           call part(zj,vee,veec,vens,veg,
     &               t,ndt,ngmax,omega,e,xmom,xglu,numeig)
           sum1=Zj
           sum2=vee 
           sum3=veec
           sum4=vens
           sum5=veg
           do nk=1,nklim
                  g=exp(fak(ndt)-fak(nk)-fak(ndt-nk))-
     &              exp(fak(ndt)-fak(nk-1)-fak(ndt-nk+1)) 
           call part(zj,vee,veec,vens,veg,
     &               t,ndt-2*nk,ngmax,omega,e,xmom,xglu,numeig)
                  sum1=sum1+g*Zj
                  sum2=sum2+g*vee
                  sum3=sum3+g*veec
                  sum4=sum4+g*vens
                  sum5=sum5+g*veg
                 
           end do
           g2=exp(fak(2*omega)-fak(ndt)-fak(2*omega-ndt))
     &        *(exp(-v/t)/(1+exp(-2*v/t)) )**(ndt)  !POTENCIAL QUIMICO
           Z=Z+(g2*sum1)
           vexndt=vexndt+g2*ndt*sum1
           vexe=vexe+g2*sum2
           vexec=vexec+g2*sum3
           vexns=vexns+g2*sum4
           vexg=vexg+g2*sum5
c                write(*,*) ndt,g2,Z,vexe,vexe/Z,vexns,vexg
         end do      !ndt
c <nq-nqbar>         
         vexn=(4*omega)/(1+exp(-2*v/t))-
     &      ((1-exp(-2*v/t))/(1+exp(-2*v/t)))*(vexndt/Z) - (2*omega)
c Para encontrar mu vs t para P fijo.
         if (t.eq.tmin) then
            difm=abs((vexe/Z + e0)-Pr)
            tpf=t
            vpf=v
            go to 88
         end if   
         if (abs((vexe/Z + e0)-pr).lt. difm) then
            difm=abs((vexe/Z + e0)-pr)
            tpf=t
            vpf=v
         end if   
 88      continue
c----------------- SALIDA----------------------------------------------
c Temp,Potencial quimico,<E>,Calor especifico,
c  <nq-nq->,<nq+nq_>,<n_2g>,<ndt>
   
         write(3,56) t,v,(vexe/Z)+e0,(vexec-(vexe**2/Z))/(Z*(t**2)),
     &           vexn,vexns/Z,vexg/Z,vexndt/Z 
c         write(3,58)  Z,vexe
         
       end do
c Escribe mu vs t
       write(4,56) vpf,tpf
      end do
 56   format(1x,16(1x,f16.5))   
 58   format(1x,16(1x,f25.3))
      return
      end

      subroutine part(zj, vee,veec,vens,veg,
     &                t,ndj,ngmax,omega,e,xmom,xglu,numeig)
      implicit real*8 (A-H,O-Z)
      integer ndj,ngmax,omega
      real*8 e((omega+1)*(ngmax+1),2,0:2*omega)
      real*8 xmom((omega+1)*(ngmax+1),2,0:2*omega)
      real*8 xglu((omega+1)*(ngmax+1),2,0:2*omega)
      integer numeig(2,0:2*omega)
      
c      common /energias/ e,numeig
      zj  =0.0
      vee =0.0
      veec=0.0
      vens=0.0
      veg =0.0
      do neu=1,2
        do nraiz=1,numeig(neu,ndj)
          zj=zj+exp(-(1/t)* E(nraiz,neu,ndj))
          vee=vee+E(nraiz,neu,ndj)*exp(-(1/t)*E(nraiz,neu,ndj))
          veec=veec+(E(nraiz,neu,ndj)**2)*exp(-(1/t)*E(nraiz,neu,ndj))
          vens=vens+2*xmom(nraiz,neu,ndj)*exp(-(1/t)*E(nraiz,neu,ndj))
          veg=veg+xglu(nraiz,neu,ndj)*exp(-(1/t)*E(nraiz,neu,ndj))
        end do
      end do

      return
      end


        
      subroutine fac(omega,fak)
      implicit real*8 (A-H,O-Z)
      integer omega
      real*8 fak(0:2*omega)
c       common /fa/ fak 
      fak(0)=0
      fak(1)=0
      do nn=2,2*omega
          fak(nn)=fak(nn-1)+log(real(nn))
      end do
      return
      end

























