
      program gsh00
c
c   programa para diagonalizar 
c H= 2\epsilon S_0 + \omega_b b^\dagger b +V_1 (S_{+}^2 b + b^\dagger S_{-}^2)
c  Haciendo uso de las bandas de simetria PS=Nq/2 + Nb 
c la salida es Eigenvalores de H Vs PS (para diferentes V1's)
      
      parameter (nrootxa=15)
      real ee(nrootxa,0:1)
      real epsilon,omegab,v1
      real vmin,vmax,vdel
      integer omega,ngmax
      integer nx,nrootx,njx,omegaaux,npmax
      common /parametros/epsilon,omegab,v1
      common /topes/omega,npmax
      common /ener/ee
c MAIN
      open(unit=1,file="gsh00.in")
      open(unit=2,file="gsh00.out")
      open(unit=10,file="gs00.dat")
      open(unit=3,file="gs00p+.dat")
      open(unit=4,file="gs00p-.dat")
      open(unit=5,file="or00p+.dat")
      open(unit=7,file="or00p-.dat")
c lee archivo de entrada
      read(1,*) !epsilon,omegab
      read(1,*) epsilon,omegab
      read(1,*) !vmin,vmax,vdel
      read(1,*) vmin,vmax,vdel
      read(1,*) !omega
      read(1,*) omega
      read(1,*) !nrootx
      read(1,*) nrootx
      read(1,*) !2pmax
      read(1,*) npmax

      write(2,*) "epsilon,omegab,vmin,vmax,vdel"
      write(2,*) epsilon,omegab,vmin,vmax,vdel
      write(2,*) "omega"
      write(2,*) omega
      write(2,*) "nrootx"
      write(2,*) nrootx
      write(2,*) "psim max X 2"
      write(2,*) npmax
      if (nrootxa.lt.nrootx) then
         write(*,*) "!!!El n\'umero de eigenvalores pedidos: ",nrootx,
     &              "   es mayor que el m\'aximo permitido: ",nrootxa,
     &  "  Cambia el valor del par\'ametro nrootx  en gsh00.in", 
     &  "o nrootxa y el formato de salida  en el programa gsh00.f"
         
      end if
  
      if (vdel.ne.0) then
          nv=int((vmax-vmin)/vdel)
      else 
          nv=0
      end if
c      write(2,*) "Paridad + -> Sim P entero"
c      write(2,*) "Paridad - -> SIm P semientero"

      do nv1=0,nv
         v1=vmin+nv1*vdel
c         write(2,*) "v1 = ",v1
c       Para un v1 fijo...
c          write(2,*) "Sim P,Emin" 
       do mm=0,npmax
         if ((mm/2)*2 .eq. mm) njx=min((mm/2+1),omega+1)
         if ((mm/2)*2 .ne. mm) njx=min(((mm+1)/2),omega)
         nx=njx
         nrootx=min(nrootx,njx)
         call digs (njx,nx,nrootx,mm) 
       end do
      end do
      stop
      end
      
c**********************************************************      
      subroutine digs (njx,nx,nrootx,mm)
      parameter (nrootxa=15)
      real root(nrootx),vect(njx,nrootx)
      real e(nrootx),e0
      real ee(nrootxa,0:1)

      real  A(((njx+1)*njx)/2)
      real h,p

      real epsilon,omegab,v1
      integer omega,ngmax
      integer nx,nrootx,njx,mm,npmax

      common /parametros/epsilon,omegab,v1
      common /topes/omega,npmax
      common /ener/ee
      



c diagonalizando para un valor de P fijo...

c Construyendo la matriz 

      if ((mm/2)*2 .eq. mm) THEN
          NQIN=0
          NQSUP=MIN(MM,2*OMEGA)
      ELSE
          NQIN=1
          NQSUP=MIN(MM,2*OMEGA-1)
      END IF   
      
      I=0
      DO NQA=NQIN,NQSUP,2
       DO NQB=NQIN,NQA,2
             I=I+1
             h=0.0
         if (nQb.eq.nQa)  h=2.0*epsilon*nqa+omegab*((mm-nqa)/2)
c        if (nqb.eq.(nqa+2)) 
c     &    h=v1*sqrt(real((mm-nqa)/2))*sqrt(real(  (nqa+1)
c     &      *(nqa+2)
c     &      *(2*omega)**2      !!!!!MAPEO BOSONICO
c     &      *(2*omega-nqa)     !!!!EXACTO
c     &      *(2*omega-1-nqa)   !!!!EXACTO
c     &      )  )
         
         if (nqb.eq.(nqa-2) ) 
     &     h=v1*sqrt(real((mm-nqa+2)/2))*sqrt(real(  (nqa)
     &        *(nqa-1)
c     &        *(2*omega)**2     !!!!!! MAPEO BOSONICO
     &        *(2*omega-nqa+2)  !!!!!EXACTO
     &        *(2*omega+1-nqa)  !!!!!EXACTO
     &          ) )
      
          a(i)=h
c      if (mm.eq.2*600) then
c         open(unit=7,file="matrix.dat")
c         write(7,876) h
c 876     format(1x,f10.3)
c      end if
   
       END DO 
      END DO
      if (i.ne.(((njx+1)*njx)/2) ) then
         write(*,*) "error!!!, i=",i,"calculado",(((njx+1)*njx)/2)
         stop
      end if
      CALL  GIVENS (A,ROOT,VECT,NX,NROOTX,NJX)

c cambiando el orden
      do Nutria=1,nrootx
          e(Nutria)=root(nrootx+1-Nutria)
      end do   

c OUTPUT de loa E^0_PS
      p=mm/2.0
     
      write(10,22) p,e(1),e(2),e(3),v1
c      write(2,22)  p,e(1)
c Escribe en el archiv para paridad positiva nqin=0
c o escribe en el de par. negativa nqin=1
      write(3+nqin,22)  p,e(1),e(2),e(3),v1
 22   format(1x,f8.1,3(1x,f12.4),1x,f12.8)
c ORDENANDO LOS EIGENVALORES
c inicio
      if (mm.eq.0) then
          ee(1,0)=e(1)
          neigp=njx ! que es uno pero por seguridad
          go to 444
      end if   
      if (mm.eq.1) then 
          ee(1,1)=e(1)
          neign=njx ! tambien es uno
        go to 444
      end if

c comparanado valores para los siguientes       

c paridad positiva
       if (nqin.eq.0) then 
        do nip=1,nrootx
          nis=neigp+1
          men=1
          do while (men.eq.1)
             men=0
             nis=nis-1
             if (nis.eq.0) go to 890
             if (e(nip).lt.ee(nis,0)) men=1
 890         continue
          end do   
          do k=min(neigp+1,nrootxa),nis+2,-1
             ee(k,nqin)=ee(k-1,nqin)
          end do
   
          if (nis+1.le.nrootxa) then
             neigp=min(neigp+1,nrootxa)
             ee(nis+1,nqin)=e(nip)
          end if   
        end do  
        end if

c paridad negativa
        if (nqin.eq.1) then 
        do nip=1,nrootx
          nis=neign+1
          men=1
          do while (men.eq.1)
             men=0
             nis=nis-1
             if (nis.eq.0) go to 990
             if (e(nip).lt.ee(nis,nqin)) men=1
 990         continue
          end do   
          do k=min(neign+1,nrootxa),nis+2,-1
             ee(k,nqin)=ee(k-1,nqin)
          end do
   
          if (nis+1.le.nrootxa) then
             neign=min(neign+1,nrootxa)
             ee(nis+1,nqin)=e(nip)
          end if   
        end do  
        end if
        
 444    continue
        
c SALIDA DE LOS ORDENADOS

      if (mm.eq.npmax) then
           e0=ee(1,0)
      write(5,33) v1,e0,ee(1,0)-e0,ee(2,0)-e0,ee(3,0)-e0,ee(4,0)-e0,
     &ee(5,0)-e0,ee(6,0)-e0,ee(7,0)-e0,ee(8,0)-e0,ee(9,0)-e0,ee(10,
     &0)-e0,ee(11,0)-e0,ee(12,0)-e0,ee(13,0)-e0,
     & ee(14,0)-e0,ee(15,0)-e0
           
      write(7,33) v1,e0,ee(1,1)-e0,ee(2,1)-e0,ee(3,1)-e0,ee(4,1)-e0,
     &ee(5,1)-e0,ee(6,1)-e0,ee(7,1)-e0,ee(8,1)-e0,ee(9,1)-e0,ee(10,
     &1)-e0,ee(11,1)-e0,ee(12,1)-e0,ee(13,1)-e0,
     & ee(14,1)-e0,ee(15,1)-e0
           
        end if 
 33     format(1x,f10.5,16(1x,f13.4))
       end

c*************************************

















