      program ham00
c****************************************************************     
c* Programa que llama a subrutina diagon   (archivo diag00.f)
c*  para escribir en archivos 
c* los eigenvalores del Hamiltoniano
c 2\epsilon S_0 + \omega_b b^\dagger b + 
c*             V_1:(S_{+}+S_{-})^2:(b+ b^\dagger)
c* (y modelos bosonicos), 
c*  en funcion de la constante de interaccion V_1 .
c* Variables de entrada:
c*     -A leer desde archivo ham00.in
c*       Parametros del Hamiltoniano:
c*           epsilon,omegab
c*       Limite inferior, superior y pasos de la cons. de inter:
c*           vmin,vmax,vdel
c*       Degeneracion de los edos fermionicos: omega
c*       Numero maximo de pares de gluones:    ngmax
c*       Numero de eigenvalores por cada valor de V_1: nrootx
c*       Sim P max que aqui no se usa: ndp
c*       Variable para decidir que Hamitoniano usar: nmb
c*       Variable para decidir si calcular energias barionicas:  npb
c*       Variable para decidir si calcular o no  <nq> y <ng>: nev 
c*
c******************************************************************
c* 26 de abril 2002  AUTOR: Sergio  Lerma
c*****************************************************************    
      real epsilon,omegab,v1, vmin,vmax,vdel,e0,vp,vs,vv
      integer omega,ngmax
      integer nx,nrootx,njx,nqmax,omegaaux,nmb,npb,nev,ndj,nex
      common /parametros/epsilon,omegab,v1,e0
      common /topes/omega,ngmin,ngmax,ndj
c ARCHIVOS
      open(unit=1,file="ham00.in")
      open(unit=2,file="ham00.out")
c Archivos de Salida
      open(unit=7,file="hamp+.dat")
      open(unit=8,file="hamp-.dat")
      open(unit=9,file="hambp+.dat")
      open(unit=10,file="hambp-.dat")
      open(unit=11,file="valep+.dat")
      open(unit=12,file="valep-.dat")
      open(unit=13,file="valebp+.dat")
      open(unit=14,file="valebp-.dat")
c lee archivo de entrada
      read(1,*) !epsilon,omegab
      read(1,*) epsilon,omegab
      read(1,*) !vmin,vmax,vdel
      read(1,*) vmin,vmax,vdel
      read(1,*) !omega
      read(1,*) omega
      read(1,*) !nqmax
      read(1,*) nqmax
      read(1,*) !ngmin,ngmax
      read(1,*) ngmin,ngmax
      read(1,*) !nrootx
      read(1,*) nrootx
      read(1,*) ! 1: modelo bosonico,2: con corte, otro: modelo exacto
      read(1,*) nmb
      read(1,*) !1:calcular cantidadesbarionicas,otro: para no calcular
      read(1,*) npb
      read(1,*) !1 calcular valores de expectacion, otro no calcularlos
      read(1,*) nev
      read(1,*) !Pesos para los terminos de interaccion 
c                Pair creation,scattering, vacuum corelations
      read(1,*) vp,vs,vv

c Escribe variables de entrada
      write(2,*) "epsilon,omegab"
      write(2,*) epsilon,omegab
      write(2,*) "vmin,vmax,vdel" 
      write(2,*) vmin,vmax,vdel
      write(2,*) "omega"
      write(2,*) omega
      write(2,*) "nqmax"
      write(2,*) nqmax
      write(2,*) "ngmin,ngmax"
      write(2,*) ngmin,ngmax
      write(2,*) "nrootx"
      write(2,*) nrootx
      write(2,*) "1: modelo bosonico,2: con corte,otro: modelo exacto"
      write(2,*) nmb
      write(2,*) "pesos  de los terminos de interaccion:"
      write(2,*) "Creacion y aniquilacion",vp
      write(2,*) "Scattering",vs
      write(2,*) "Correlacion del vacio",vv 
      if (vdel.eq.0) then 
        vmax=vmin+1.0
        vdel=2.0
      end if
      write(*,*) "Avance:"
      do v1=vmin,vmax,vdel
       write(*,*) Int(100*(v1-vmin)/(vmax-vmin))," %"  
       ndjlim=2*omega
       if (npb.eq.1) ndjlim=2*omega-3!Calcular cantid. barionic.
       nf1=7 !numero de archivo para escribir energias
       nf2=11! numero de archivo para escribir val. de expec.
       do ndj=2*omega,ndjlim,-3
c----------Paridad positiva-----------------
c       if (ndj.eq.2*(ndj/2)) then  ! si J es entero
c          njx=(ndj/2)+1
c       else                        ! si J es semientero
c          njx=(ndj+1)/2
c       end if
        njx=0  
       do nco=-ndj,min(-2*omega+2*nqmax,ndj),4
         njx=njx+1
       end do    
       njx=njx*(ngmax-ngmin+1)           ! tamanio de la matriz
       nex=0
       nrootx=min(nrootx,njx)
      
       CALL  diagon (njx,nqmax,nrootx,nex,nmb,nev,nf1,nf2,0,vp,vs,vv)
      
       nf1=nf1+1!!cambia el numero del archivo donde escribir energias 
       nf2=nf2+1!!lo mismo para los valores de expectacion
c-----------Paridad negativa------------------------- 
c       if (ndj.eq.2*(ndj/2)) then  ! si J es entero
c          njx=(ndj/2)
c       else                        ! si J es semientero
c          njx=(ndj+1)/2
c       end if
       njx=0
       do nco=-ndj+2,min(-2*omega+2*nqmax,ndj),4
          njx=njx+1
       end do    
       njx=njx*(ngmax-ngmin+1) ! tamanio de la matriz
       nex=2
       nrootx=min(nrootx,njx)      
       CALL  diagon (njx,nqmax,nrootx,nex,nmb,nev,nf1,nf2,0,vp,vs,vv)
       nf1=nf1+1!!cambia el numero del archivo donde escribir energias 
       nf2=nf2+1!!lo mismo para los valores de expectacion
       end do   
      end do
      stop
      end






















