      SUBROUTINE BLOCKS
C     ------------------------------------------------------------------
C     MODIFIED VERSION (LOG FACTORIALS) OF MTS R3PACK---LSU (2/25/79)
C     ------------------------------------------------------------------
      IMPLICIT REAL*8(D)
      COMMON/BKDF/DLOGF(502)
      DLOGF(2)=0.D0
      DO 10 I=2,500,2
   10 DLOGF(I+2)=DLOGF(I)+DLOG(DFLOAT(I/2))
      RETURN
      END
      FUNCTION DWR3(J1T,J2T,J3T,M1T,M2T,M3T)
C     ------------------------------------------------------------------
C     WIGNER COEFFICIENTS FOR R3--TRIANGLE RELATIONS CHECKED IN DELTA
C     REFERENCES--ELEMENTARY THEORY OF ANGULAR MOMENTUM, M.E.ROSE, WILEY
C     ------------------------------------------------------------------
      IMPLICIT REAL*8(D)
      COMMON/BKDF/DLOGF(502)
      DWR3=0.D0
      IF(M1T+M2T-M3T.NE.0)GO TO 20
      DC=DELTA(J1T,J2T,J3T)
      IF(DC.EQ.0.D0)GO TO 20
      I1=J3T-J2T+M1T+2
      I2=J3T-J1T-M2T+2
      I3=J1T+J2T-J3T+2
      I4=J1T-M1T+2
      IF(2*(I4/2).NE.I4)GO TO 20
      I5=J2T+M2T+2
      IF(2*(I5/2).NE.I5)GO TO 20
      IITMIN=MAX0(0,2-I1,2-I2)+1
      IITMAX=MIN0(I3,I4,I5)-1
      IF(IITMIN.GT.IITMAX)GO TO 20
      DTOP=(DLOG(DFLOAT(J3T+1)*DC)+DLOGF(J1T+M1T+2)+DLOGF(J1T-M1T+2)+
     1DLOGF(J2T+M2T+2)+DLOGF(J2T-M2T+2)+DLOGF(J3T+M3T+2)+
     2DLOGF(J3T-M3T+2))/DFLOAT(2)
      IP=1-MOD(IITMIN+1,4)
      DO 10 IIT=IITMIN,IITMAX,2
      IP=-IP
      IT=IIT-1
      DBOT=DLOGF(I3-IT)+DLOGF(I4-IT)+DLOGF(I5-IT)+
     1DLOGF(2+IT)+DLOGF(I1+IT)+DLOGF(I2+IT)
   10 DWR3=DWR3+DFLOAT(IP)*DEXP(DTOP-DBOT)
   20 RETURN
      END
      FUNCTION DRR3(J1T,J2T,L2T,L1T,J3T,L3T)
C     ------------------------------------------------------------------
C     RACAH COEFFICIENTS FOR R3--TRIANGLE RELATION CHECKED IN DELTA
C     REFERENCES--THE 3-J AND 6-J SYMBOLS, M.ROTENBERG, R.BIVINS,
C                 N.METROPOLIS AND J.K.WOOTEN, MIT PRESS
C     ------------------------------------------------------------------
      IMPLICIT REAL*8(D)
      COMMON/BKDF/DLOGF(502)
      DRR3=0.D0
      DX=DELTA(J1T,J2T,J3T)
      IF(DX.EQ.0.D0)GO TO 20
      DC=DX
      DX=DELTA(L1T,L2T,J3T)
      IF(DX.EQ.0.D0)GO TO 20
      DC=DX*DC
      DX=DELTA(L1T,J2T,L3T)
      IF(DX.EQ.0.D0)GO TO 20
      DC=DX*DC
      DX=DELTA(J1T,L2T,L3T)
      IF(DX.EQ.0.D0)GO TO 20
      DC=DX*DC
      I1=J3T+L3T-J1T-L1T+2
      I2=J3T+L3T-J2T-L2T+2
      I3=J1T+J2T+L1T+L2T+4
      I4=J1T+J2T-J3T+2
      I5=L1T+L2T-J3T+2
      I6=J1T+L2T-L3T+2
      I7=L1T+J2T-L3T+2
      IITMIN=MAX0(0,2-I1,2-I2)+1
      IITMAX=MIN0(I3,I4,I5,I6,I7)-1
      IF(IITMIN.GT.IITMAX)GO TO 20
      IP=1-MOD(IITMIN+1,4)
      DO 10 IIT=IITMIN,IITMAX,2
      IP=-IP
      IT=IIT-1
   10 DRR3=DRR3+DFLOAT(IP)*DEXP(DLOGF(I3-IT)-(DLOGF(I4-IT)+
     1DLOGF(I5-IT)+DLOGF(I6-IT)+DLOGF(I7-IT)+DLOGF(2+IT)+DLOGF(I1+IT)+
     2DLOGF(I2+IT)))
      DRR3=DSQRT(DC)*DRR3
   20 RETURN
      END
      FUNCTION DJHR3(J1T,J2T,J3T,J4T,J5T,J6T,J7T,J8T,J9T)
C     ------------------------------------------------------------------
C     JAHN-HOPE COEFFICIENTS FOR R3--TRIANGLE RELATIONS CHECKED IN DELTA
C     REFERENCES--ANGULAR MOMENTUM IN QUANTUM MECHANICS, A.R.EDMONDS,
C                 PRINCETON
C     ------------------------------------------------------------------
      IMPLICIT REAL*8(D)
      DJHR3=0.E0
      IITMIN=MAX0(IABS(J1T-J9T),IABS(J2T-J6T),IABS(J4T-J8T))+1
      IITMAX=MIN0(J1T+J9T,J2T+J6T,J4T+J8T)+1
      IF(IITMIN.GT.IITMAX)RETURN
      DO 10 IIT=IITMIN,IITMAX,2
      IT=IIT-1
   10 DJHR3=DJHR3+(IT+1)*DRR3(J1T,J9T,J4T,J8T,IT,J7T)*
     1DRR3(J2T,J6T,J8T,J4T,IT,J5T)*DRR3(J1T,J9T,J2T,J6T,IT,J3T)
      DJHR3=DSQRT(DFLOAT((J3T+1)*(J6T+1)*(J7T+1)*(J8T+1)))*DJHR3
      RETURN
      END
      FUNCTION D3JR3(J1T,J2T,J3T,M1T,M2T,M3T)
C     ------------------------------------------------------------------
C     3J COEFFICIENTS FOR R3--TRIANGLE RELATIONS CHECKED IN DELTA
C     REFERENCES--ELEMENTARY THEORY OF ANGULAR MOMENTUM, M.E.ROSE, WILEY
C     ------------------------------------------------------------------
      IMPLICIT REAL*8(D)
      COMMON/BKDF/DLOGF(502)
      D3JR3=0.D0
      IF(M1T+M2T-M3T.NE.0)GO TO 20
      DC=DELTA(J1T,J2T,J3T)
      IF(DC.EQ.0.D0)GO TO 20
      I1=J3T-J2T+M1T+2
      I2=J3T-J1T-M2T+2
      I3=J1T+J2T-J3T+2
      I4=J1T-M1T+2
      IF(2*(I4/2).NE.I4)GO TO 20
      I5=J2T+M2T+2
      IF(2*(I5/2).NE.I5)GO TO 20
      IITMIN=MAX0(0,2-I1,2-I2)+1
      IITMAX=MIN0(I3,I4,I5)-1
      IF(IITMIN.GT.IITMAX)GO TO 20
      DTOP=(DLOG(DC)+DLOGF(J1T+M1T+2)+DLOGF(J1T-M1T+2)+
     1DLOGF(J2T+M2T+2)+DLOGF(J2T-M2T+2)+DLOGF(J3T+M3T+2)+
     2DLOGF(J3T-M3T+2))/DFLOAT(2)
      IP=1-MOD(IITMIN+1,4)
      DO 10 IIT=IITMIN,IITMAX,2
      IP=-IP
      IT=IIT-1
      DBOT=DLOGF(I3-IT)+DLOGF(I4-IT)+DLOGF(I5-IT)+
     1DLOGF(2+IT)+DLOGF(I1+IT)+DLOGF(I2+IT)
   10 D3JR3=D3JR3+DFLOAT(IP)*DEXP(DTOP-DBOT)
      IF(MOD(I1-I2,4).NE.0)D3JR3=-D3JR3
   20 RETURN
      END
      FUNCTION D6JR3(J1T,J2T,J3T,L1T,L2T,L3T)
C     ------------------------------------------------------------------
C     6J COEFFICIENTS FOR R3--TRIANGLE RELATION CHECKED IN DELTA
C     REFERENCES--THE 3-J AND 6-J SYMBOLS, M.ROTENBERG, R.BIVINS,
C                 N.METROPOLIS AND J.K.WOOTEN, MIT PRESS
C     ------------------------------------------------------------------
      IMPLICIT REAL*8(D)
      COMMON/BKDF/DLOGF(502)
      D6JR3=0.D0
      DX=DELTA(J1T,J2T,J3T)
      IF(DX.EQ.0.D0)GO TO 20
      DC=DX
      DX=DELTA(L1T,L2T,J3T)
      IF(DX.EQ.0.D0)GO TO 20
      DC=DX*DC
      DX=DELTA(L1T,J2T,L3T)
      IF(DX.EQ.0.D0)GO TO 20
      DC=DX*DC
      DX=DELTA(J1T,L2T,L3T)
      IF(DX.EQ.0.D0)GO TO 20
      DC=DX*DC
      I1=J3T+L3T-J1T-L1T+2
      I2=J3T+L3T-J2T-L2T+2
      I3=J1T+J2T+L1T+L2T+4
      I4=J1T+J2T-J3T+2
      I5=L1T+L2T-J3T+2
      I6=J1T+L2T-L3T+2
      I7=L1T+J2T-L3T+2
      IITMIN=MAX0(0,2-I1,2-I2)+1
      IITMAX=MIN0(I3,I4,I5,I6,I7)-1
      IF(IITMIN.GT.IITMAX)GO TO 20
      IP=1-MOD(IITMIN+1,4)
      DO 10 IIT=IITMIN,IITMAX,2
      IP=-IP
      IT=IIT-1
   10 D6JR3=D6JR3+DFLOAT(IP)*DEXP(DLOGF(I3-IT)-(DLOGF(I4-IT)+
     1DLOGF(I5-IT)+DLOGF(I6-IT)+DLOGF(I7-IT)+DLOGF(2+IT)+DLOGF(I1+IT)+
     2DLOGF(I2+IT)))
      D6JR3=DSQRT(DC)*D6JR3
      IF(4*(I3/4).NE.I3)D6JR3=-D6JR3
   20 RETURN
      END
      FUNCTION D9JR3(J1T,J2T,J3T,J4T,J5T,J6T,J7T,J8T,J9T)
C     ------------------------------------------------------------------
C     9J COEFFICIENTS FOR R3--TRIANGLE RELATIONS CHECKED IN DELTA
C     REFERENCES--ANGULAR MOMENTUM, D.M.BRINK AND G.R.SATCHLER, OXFORD
C     ------------------------------------------------------------------
      IMPLICIT REAL*8(D)
      D9JR3=0.E0
      IITMIN=MAX0(IABS(J1T-J9T),IABS(J2T-J6T),IABS(J4T-J8T))+1
      IITMAX=MIN0(J1T+J9T,J2T+J6T,J4T+J8T)+1
      IF(IITMIN.GT.IITMAX)RETURN
      DO 10 IIT=IITMIN,IITMAX,2
      IT=IIT-1
   10 D9JR3=D9JR3+(IT+1)*DRR3(J1T,J9T,J4T,J8T,IT,J7T)*
     1DRR3(J2T,J6T,J8T,J4T,IT,J5T)*DRR3(J1T,J9T,J2T,J6T,IT,J3T)
      RETURN
      END
      FUNCTION DELTA(J1T,J2T,J3T)
C     ------------------------------------------------------------------
C     DELTA FOR R3 ROUTINES--TRIANGLE RELATIONS CHECKED
C     ------------------------------------------------------------------
      IMPLICIT REAL*8(D)
      COMMON/BKDF/DLOGF(502)
      DELTA=0.D0
      I1=J1T+J2T-J3T
      IF(2*(I1/2).NE.I1)GO TO 10
      IF(I1.LT.0)GO TO 10
      I2=J2T+J3T-J1T
      IF(I2.LT.0)GO TO 10
      I3=J3T+J1T-J2T
      IF(I3.LT.0)GO TO 10
      DELTA=DLOGF(I1+2)+DLOGF(I2+2)+DLOGF(I3+2)-DLOGF(J1T+J2T+J3T+4)
      DELTA=DEXP(DELTA)
   10 RETURN
      END

**************************************************************************
*                                   |                                    *
* Jerry P. Draayer                  | V-mail: 504-766-0893 (Home)        *
*                                   |                                    *
* Program Director, LA-EPSCoR       |                                    *
* Louisiana Board of Regents        | V-mail: 504-342-4253               *
* 150 Third Street, Suite 129       | Fax:    504-342-9318               *
* Baton Rouge, LA 70801-1389        | E-mail: draayer@regents.state.la.u *
*                                   |                                    *
* Professor of Physics              |                                    *
* Department of Physics & Astronomy | V-mail: 504-388-6844               *
* Louisiana State University        | Fax:    504-388-5855               *
* Baton Rouge, Louisiana 70803-4001 | E-mail: draayer@rouge.phys.lsu.edu *
*                                   |                                    *
**************************************************************************


