C                                                                       00029200
C *********************************************************             00029300
C GIVENS                                                                00029400
C                                                                       00029500
C                                                                       00029600
C * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *     00029700
C UNTERPROGRAMM ZUR DIAGONALISIERUNG DER MATRIX H(I,IS)                 00029800
C                                                                       00029900
      SUBROUTINE GIVENS(A,ROOT,VECT,NX,NROOTX,NJX)                      00030000
      DIMENSION         A(1),ROOT(NROOTX),VECT(NJX,NROOTX)              00030100
      DIMENSION B(1202,1202) !!!!!!!CAMBIO                              00030200
      N1=NJX                                                            00030300
      ETA=5.E-7                                                         00030400
      THETA=1.E37                                                       00030500
C ** * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *00030600
C                                                                       00030700
       DEL1 = ETA/100.                                                  00030800
       DELTA = ETA**2*100.                                              00030900
       SMALL = ETA**2/100.                                              00031000
       DELBIG = THETA*DELTA/1000.                                       00031100
       THETA1 = 1000./THETA                                             00031200
       TOLER = ETA*100.                                                 00031300
C                                                                       00031400
C      INITIAL VALUE FOR PSEUDORANDOM NUMBER GENERATOR... (2**23)-3     00031500
       RPOWER = 8388608.                                                00031600
       RPOW1 = RPOWER/2.                                                00031700
       RAND1 = RPOWER - 3.                                              00031800
C                                                                       00031900
      N = NX                                                            00032000
      NROOT = IABS(NROOTX)                                              00032100
      IF (NROOT.EQ.0) GO TO 1001                                        00032200
      IF (N-1) 1001,1003,105                                            00032300
1003  ROOT(1) = A(1)                                                    00032400
      IF (NROOTX.GT.0) VECT(1,1) = 1.0                                  00032500
      GO TO 1001                                                        00032600
105   CONTINUE                                                          00032700
C     NSIZE    NUMBER OF ELEMENTS IN THE PACKED ARRAY                   00032800
      NSIZE = (N*(N+1))/2                                               00032900
      NM1 = N-1                                                         00033000
      NM2 = N-2                                                         00033100
C                                                                       00033200
C     SCALE MATRIX TO EUCLIDEAN NORM OF 1.  SCALE FACTOR IS ANORM.      00033300
      FACTOR = 0.                                                       00033400
      DO 70 I=1,NSIZE                                                   00033500
70    FACTOR = AMAX1(FACTOR,ABS(A(I)))                                  00033600
C     IF (FACTOR.NE.0.) GO TO 72                                        00033700
      IF(ABS(FACTOR).GT.0) GO TO 72                                     00033800
C     NULL MATRIX.  FIX UP ROOTS AND VECTORS, THEN EXIT.                00033900
      DO 78 I=1,NROOT                                                   00034000
      IF (NROOTX.LT.0) GO TO 78                                         00034100
      DO 77 J=1,N                                                       00034200
77    VECT(J,I) = 0.                                                    00034300
      VECT(I,I) = 1.0                                                   00034400
78    ROOT(I) = 0.                                                      00034500
      GO TO 1001                                                        00034600
C                                                                       00034700
72    ANORM = 0.                                                        00034800
      J = 1                                                             00034900
      K = 1                                                             00035000
86    DO 80 I=1,NSIZE                                                   00035100
      IF (I.NE.J) GO TO 81                                              00035200
      ANORM = ANORM + (A(I)/FACTOR)**2/2.                               00035300
      K = K+1                                                           00035400
      J = J+K                                                           00035500
      GO TO 80                                                          00035600
81    ANORM = ANORM + (A(I)/FACTOR)**2                                  00035700
80    CONTINUE                                                          00035800
83    ANORM = SQRT(ANORM*2.)*FACTOR                                     00035900
      DO 91 I=1,NSIZE                                                   00036000
91    A(I) = A(I)/ANORM                                                 00036100
      ALIMIT = 1.0                                                      00036200
C                                                                       00036300
C      TRIDIA SECTION.                                                  00036400
C      TRIDIAGONALIZATION OF SYMMETRIC MATRIX                           00036500
       ID = 0                                                           00036600
       IA = 1                                                           00036700
       IF (NM2.EQ.0) GO TO 201                                          00036800
       DO 200  J=1,NM2                                                  00036900
C      J       COUNTS ROW  OF A-MATRIX TO BE DIAGONALIZED               00037000
C      IA      START OF NON-CODIAGONAL ELEMENTS IN THE ROW              00037100
C      ID      INDEX OF CODIAGONAL ELEMENT ON ROW BEING CODIAGONALIZED. 00037200
       IA = IA+J+2                                                      00037300
       ID = ID + J + 1                                                  00037400
       JP2 = J+2                                                        00037500
C      SUM SQUARES OF NON-CODIAGONAL ELEMENTS IN ROW J                  00037600
       II = IA                                                          00037700
       SUM = 0.0                                                        00037800
       DO 100 I=JP2,N                                                   00037900
       SUM = SUM + A(II)**2                                             00038000
100    II = II + I                                                      00038100
       TEMP = A(ID)                                                     00038200
       IF (SUM.GT.SMALL) GO TO 110                                      00038300
C      NO TRANSFORMATION NECESSARY IF ALL THE NON-CODIAGONAL            00038400
C      ELEMENTS ARE TINY.                                               00038500
120    B(J,1) = TEMP                                                    00038600
       A(ID) = 0.                                                       00038700
       GO TO 200                                                        00038800
C      NOW COMPLETE THE SUM OF OFF-DIAGONAL SQUARES                     00038900
110    SUM = SQRT(SUM + TEMP**2)                                        00039000
C      NEW CODIAGONAL ELEMENT                                           00039100
       B(J,1) = -SIGN(SUM,TEMP)                                         00039200
C      FIRST NON-ZERO ELEMENT OF THIS W-VECTOR                          00039300
       B(J+1,2) = SQRT((1.0 + ABS(TEMP)/SUM)/2.0)                       00039400
C      FORM REST OF THE W-VECTOR ELEMENTS                               00039500
       TEMP = SIGN(0.5/(B(J+1,2)*SUM),TEMP)                             00039600
       II = IA                                                          00039700
       DO 130 I=JP2,N                                                   00039800
       B(I,2) = A(II)*TEMP                                              00039900
130    II = II + I                                                      00040000
C      FORM P-VECTOR AND SCALAR.  P-VECTOR = A-MATRIX*W-VECTOR.         00040100
C      SCALAR = W-VECTOR*P-VECTOR.                                      00040200
       AK = 0.0                                                         00040300
C      IC      LOCATION OF NEXT DIAGONAL ELEMENT                        00040400
       IC = ID + 1                                                      00040500
       J1 = J + 1                                                       00040600
       DO 190  I=J1,N                                                   00040700
       JJ = IC                                                          00040800
       TEMP = 0.                                                        00040900
       DO 180  II=J1,N                                                  00041000
C      I       RUNS OVER THE NON-ZERO P-ELEMENTS                        00041100
C      II      RUNS OVER ELEMENTS OF W-VECTOR                           00041200
       TEMP = TEMP + B(II,2)*A(JJ)                                      00041300
C      CHANGE INCREMENTING MODE AT THE DIAGONAL ELEMENTS.               00041400
       IF (II.LT.I) GO TO 210                                           00041500
140    JJ = JJ + II                                                     00041600
       GO TO 180                                                        00041700
210    JJ = JJ + 1                                                      00041800
180    CONTINUE                                                         00041900
C      BUILD UP THE K-SCALAR (AK)                                       00042000
       AK = AK + TEMP*B(I,2)                                            00042100
       B(I,1) = TEMP                                                    00042200
C      MOVE IC TO TOP OF NEXT A-MATRIX 'ROW'                            00042300
190    IC = IC + I                                                      00042400
C      FORM THE Q-VECTOR                                                00042500
       DO 150  I=J1,N                                                   00042600
150    B(I,1) = B(I,1) - AK*B(I,2)                                      00042700
C      TRANSFORM THE REST OF THE A-MATRIX                               00042800
C      JJ      START-1 OF THE REST OF THE A-MATRIX                      00042900
       JJ = ID                                                          00043000
C      MOVE W-VECTOR INTO THE OLD A-MATRIX LOCATIONS TO SAVE SPACE      00043100
C      I       RUNS OVER THE SIGNIFICANT ELEMENTS OF THE W-VECTOR       00043200
       DO 160  I=J1,N                                                   00043300
       A(JJ) = B(I,2)                                                   00043400
       DO 170  II=J1,I                                                  00043500
       JJ = JJ + 1                                                      00043600
170    A(JJ) = A(JJ) - 2.0*(B(I,1)*B(II,2) + B(I,2)*B(II,1))            00043700
160    JJ = JJ + J                                                      00043800
200    CONTINUE                                                         00043900
C      MOVE LAST CODIAGONAL ELEMENT OUT INTO ITS PROPER PLACE           00044000
201    CONTINUE                                                         00044100
       B(NM1,1) = A(NSIZE-1)                                            00044200
       A(NSIZE-1) = 0.                                                  00044300
       B(N,1)=0.                                                        00044400
      JUMP=1                                                            00044500
      DO 320 J=1,N                                                      00044600
      B(J,2)=A(JUMP)                                                    00044700
      B(J,3) = B(J,1)**2                                                00044800
320   JUMP = JUMP+J+1                                                   00044900
      DO 310 I=1,NROOT                                                  00045000
310   ROOT(I) = +ALIMIT                                                 00045100
      ROOTL = -ALIMIT                                                   00045200
C     ISOLATE THE ROOTS.  THE NROOT LOWEST ROOTS ARE FOUND, LOWEST FIRST00045300
      DO 330 I=1,NROOT                                                  00045400
C     FIND CURRENT 'BEST' UPPER BOUND                                   00045500
      ROOTX = +ALIMIT                                                   00045600
      DO 335 J=I,NROOT                                                  00045700
335   ROOTX = AMIN1(ROOTX,ROOT(J))                                      00045800
      ROOT(I) = ROOTX                                                   00045900
C     GET IMPROVED TRIAL ROOT                                           00046000
500   TRIAL = (ROOTL + ROOT(I))*0.5                                     00046100
C     IF (TRIAL.EQ.ROOTL.OR.TRIAL.EQ.ROOT(I)) GO TO 330                 00046200
      IF(.NOT.ABS(TRIAL-ROOTL).GT.0.OR..NOT.ABS(TRIAL-ROOT(I)).GT.0)    00046300
     1 GO TO 330                                                        00046400
C     FORM STURM SEQUENCE RATIOS, USING ORTEGA'S ALGORITHM (MODIFIED).  00046500
C     NOMTCH IS THE NUMBER OF ROOTS LESS THAN THE TRIAL VALUE.          00046600
350   CONTINUE                                                          00046700
      NOMTCH = N                                                        00046800
      J = 1                                                             00046900
360   F0 = B(J,2) - TRIAL                                               00047000
370   CONTINUE                                                          00047100
      IF (ABS(F0).LT.THETA1) GO TO 380                                  00047200
      IF (F0.GE.0.) NOMTCH = NOMTCH - 1                                 00047300
      J = J + 1                                                         00047400
      IF (J.GT.N) GO TO 390                                             00047500
C     SINCE MATRIX IS NORMED TO UNITY, MAGNITUDE OF B(J,3) IS LESS THAN 00047600
C     ONE, SO OVERFLOW IS NOT POSSIBLE AT THE DIVISION STEP, SINCE      00047700
C     F0 IS GREATER THAN THETA1.                                        00047800
C     F0 = B(J,2) - TRIAL - B(J-1,3)/F0                                 00047900
      BB = B(J-1,3)/F0                                                  00048000
C     IF (F0.EQ.0) BB=0.                                                00048100
      IF(.NOT.ABS(F0).GT.0) BB=0.                                       00048200
      F0=B(J,2)-TRIAL-BB                                                00048300
      GO TO 370                                                         00048400
380   J = J + 2                                                         00048500
      NOMTCH = NOMTCH - 1                                               00048600
      IF (J.LE.N) GO TO 360                                             00048700
390   CONTINUE                                                          00048800
C     FIX NEW BOUNDS ON ROOTS                                           00048900
      IF (NOMTCH.GE.I) GO TO 540                                        00049000
      ROOTL = TRIAL                                                     00049100
      GO TO 500                                                         00049200
540   ROOT(I) = TRIAL                                                   00049300
      NOM = MIN0(NROOT,NOMTCH)                                          00049400
      ROOT(NOM) = TRIAL                                                 00049500
      GO TO 500                                                         00049600
330   CONTINUE                                                          00049700
C     REVERSE THE ORDER OF THE EIGENVALUES, SINCE CUSTOM DICTATES       00049800
C     'LARGEST FIRST'.  THIS SECTION MAY BE REMOVED IF DESIRED WITHOUT  00049900
C     AFFECTING THE REMAINDER OF THE ROUTINE.                           00050000
      NRT = NROOT/2                                                     00050100
      DO 10 I=1,NRT                                                     00050200
      SAVE = ROOT(I)                                                    00050300
      NMIP1 = NROOT - I + 1                                             00050400
      ROOT(I) = ROOT(NMIP1)                                             00050500
  10  ROOT(NMIP1) = SAVE                                                00050600
C                                                                       00050700
C     TRIVEC SECTION.                                                   00050800
C     EIGENVECTORS OF CODIAGONAL FORM                                   00050900
807   CONTINUE                                                          00051000
C     QUIT NOW IF NO VECTORS WERE REQUESTED.                            00051100
      IF (NROOTX.LT.0) GO TO 1002                                       00051200
C     INITIALIZE VECTOR ARRAY.                                          00051300
      DO 15 I=1,N                                                       00051400
      DO 15 J=1,NROOT                                                   00051500
15    VECT(I,J) = 1.0                                                   00051600
      DO 700 I=1,NROOT                                                  00051700
      AROOT = ROOT(I)                                                   00051800
C     ORTHOGONALIZE IF ROOTS ARE CLOSE.                                 00051900
      IF (I.EQ.1) GO TO 710                                             00052000
C     THE ABSOLUTE VALUE IN THE NEXT TEST IS TO ASSURE THAT THE TRIVEC  00052100
C     SECTION IS INDEPENDENT OF THE ORDER OF THE EIGENVALUES.           00052200
715   IF (ABS(ROOT(I-1)-AROOT).LT.TOLER) GO TO 720                      00052300
710   IA = -1                                                           00052400
720   IA = IA + 1                                                       00052500
      ELIM1 = A(1) - AROOT                                              00052600
      ELIM2 = B(1,1)                                                    00052700
      JUMP = 1                                                          00052800
      DO 750  J=1,NM1                                                   00052900
      JUMP = JUMP+J+1                                                   00053000
C     GET THE CORRECT PIVOT EQUATION FOR THIS STEP.                     00053100
      IF (ABS(ELIM1).LE.ABS(B(J,1))) GO TO 760                          00053200
C     FIRST (ELIM1) EQUATION IS THE PIVOT THIS TIME.  CASE 1.           00053300
      B(J,2) = ELIM1                                                    00053400
      B(J,3) = ELIM2                                                    00053500
      B(J,4) = 0.                                                       00053600
      TEMP = B(J,1)/ELIM1                                               00053700
      ELIM1 = A(JUMP) - AROOT - TEMP*ELIM2                              00053800
      ELIM2 = B(J+1,1)                                                  00053900
      GO TO 755                                                         00054000
C     SECOND EQUATION IS THE PIVOT THIS TIME.  CASE 2.                  00054100
760   B(J,2) = B(J,1)                                                   00054200
      B(J,3) = A(JUMP) - AROOT                                          00054300
      B(J,4) = B(J+1,1)                                                 00054400
      TEMP = 1.0                                                        00054500
      IF (ABS(B(J,1)).GT.THETA1) TEMP = ELIM1/B(J,1)                    00054600
      ELIM1 = ELIM2 - TEMP*B(J,3)                                       00054700
      ELIM2 = -TEMP*B(J+1,1)                                            00054800
C     SAVE FACTOR FOR THE SECOND ITERATION.                             00054900
755   B(J,5) = TEMP                                                     00055000
750   CONTINUE                                                          00055100
      B(N,2) = ELIM1                                                    00055200
      B(N,3) = 0.                                                       00055300
      B(N,4) = 0.                                                       00055400
      B(NM1,4) = 0.                                                     00055500
      ITER = 1                                                          00055600
      IF (IA.NE.0) GO TO 801                                            00055700
C     BACK SUBSTITUTE TO GET THIS VECTOR.                               00055800
790   L = N + 1                                                         00055900
      DO 780 J=1,N                                                      00056000
      L = L - 1                                                         00056100
786   CONTINUE                                                          00056200
      IF (L-NM1) 787,788,789                                            00056300
789   ELIM1=VECT(L,I)                                                   00056400
      GO TO 785                                                         00056500
788   ELIM1=VECT(L,I)-VECT(L+1,I)*B(L,3)                                00056600
      GO TO 785                                                         00056700
787   ELIM1=VECT(L,I)-VECT(L+1,I)*B(L,3)-VECT(L+2,I)*B(L,4)             00056800
785   CONTINUE                                                          00056900
C     IF OVERFLOW IS CONCEIVABLE, SCALE THE VECTOR DOWN.                00057000
C     THIS APPROACH IS USED TO AVOID MACHINE-DEPENDENT AND SYSTEM-      00057100
C     DEPENDENT CALLS TO OVERFLOW ROUTINES.                             00057200
      IF (ABS(ELIM1).GT.DELBIG) GO TO 782                               00057300
      TEMP = B(L,2)                                                     00057400
      IF (ABS(B(L,2)).LT.DELTA) TEMP = DELTA                            00057500
      VECT(L,I) = ELIM1/TEMP                                            00057600
      GO TO 780                                                         00057700
C     VECTOR IS TOO BIG.  SCALE IT DOWN.                                00057800
 782  DO 784 K=1,N                                                      00057900
784   VECT(K,I) = VECT(K,I)/DELBIG                                      00058000
      GO TO 786                                                         00058100
780   CONTINUE                                                          00058200
      GO TO (820,800), ITER                                             00058300
C     SECOND ITERATION.  (BOTH ITERATIONS FOR REPEATED-ROOT VECTORS).   00058400
820   ITER = ITER + 1                                                   00058500
890   ELIM1 = VECT(1,I)                                                 00058600
      DO 830 J=1,NM1                                                    00058700
C     IF (B(J,2).EQ.B(J,1)) GO TO 840                                   00058800
      IF(.NOT.ABS(B(J,2)-B(J,1)).GT.0) GO TO 840                        00058900
C     CASE ONE.                                                         00059000
850   VECT(J,I) = ELIM1                                                 00059100
      ELIM1 = VECT(J+1,I) - ELIM1*B(J,5)                                00059200
      GO TO 830                                                         00059300
C     CASE TWO.                                                         00059400
840   VECT(J,I) = VECT(J+1,I)                                           00059500
      ELIM1 = ELIM1 - VECT(J+1,I)*TEMP                                  00059600
830   CONTINUE                                                          00059700
      VECT(N,I) = ELIM1                                                 00059800
      GO TO 790                                                         00059900
C     PRODUCE A RANDOM VECTOR                                           00060000
801   CONTINUE                                                          00060100
      DO 802 J=1,N                                                      00060200
C     GENERATE PSEUDORANDOM NUMBERS WITH UNIFORM DISTRIBUTION IN (-1,1).00060300
C     THIS RANDOM NUMBER SCHEME IS OF THE FORM...                       00060400
C     RAND1 = AMOD((2**12+3)*RAND1,2**23)                               00060500
C     IT HAS A PERIOD OF 2**21 NUMBERS.                                 00060600
      RAND1 = AMOD(4099.*RAND1,RPOWER)                                  00060700
802   VECT(J,I) = RAND1/RPOW1 - 1.                                      00060800
      GO TO 790                                                         00060900
C                                                                       00061000
C     ORTHOGONALIZE THIS REPEATED-ROOT VECTOR TO OTHERS WITH THIS ROOT. 00061100
800   IF (IA.EQ.0) GO TO 885                                            00061200
      DO 860 J1=1,IA                                                    00061300
      K = I - J1                                                        00061400
      TEMP = 0.                                                         00061500
      DO 870 J=1,N                                                      00061600
870   TEMP = TEMP + VECT(J,I)*VECT(J,K)                                 00061700
      DO 880 J=1,N                                                      00061800
880   VECT(J,I) = VECT(J,I) - TEMP*VECT(J,K)                            00061900
860   CONTINUE                                                          00062000
885   GO TO (890,900), ITER                                             00062100
C     NORMALIZE THE VECTOR                                              00062200
900   ELIM1 = 0.                                                        00062300
      DO 904 J=1,N                                                      00062400
904   ELIM1 = AMAX1(ABS(VECT(J,I)),ELIM1)                               00062500
      TEMP=0.                                                           00062600
      DO 910 J=1,N                                                      00062700
      ELIM2=VECT(J,I)/ELIM1                                             00062800
910   TEMP = TEMP + ELIM2**2                                            00062900
      TEMP=1.0/(SQRT(TEMP)*ELIM1)                                       00063000
      DO 920 J=1,N                                                      00063100
      VECT(J,I) = VECT(J,I)*TEMP                                        00063200
      IF (ABS(VECT(J,I)).LT.DEL1) VECT(J,I) = 0.                        00063300
920   CONTINUE                                                          00063400
700   CONTINUE                                                          00063500
C                                                                       00063600
C      SIMVEC SECTION.                                                  00063700
C      ROTATE CODIAGONAL VECTORS INTO VECTORS OF ORIGINAL ARRAY         00063800
C      LOOP OVER ALL THE TRANSFORMATION VECTORS                         00063900
       IF (NM2.EQ.0) GO TO 1002                                         00064000
       JUMP = NSIZE - (N+1)                                             00064100
       IM = NM1                                                         00064200
       DO 950  I=1,NM2                                                  00064300
       J1 = JUMP                                                        00064400
C      MOVE A TRANSFORMATION VECTOR OUT INTO BETTER INDEXING POSITION.  00064500
       DO 955  J=IM,N                                                   00064600
       B(J,2) = A(J1)                                                   00064700
955    J1 = J1 + J                                                      00064800
C      MODIFY ALL REQUESTED VECTORS.                                    00064900
       DO 960  K=1,NROOT                                                00065000
       TEMP = 0.                                                        00065100
C      FORM SCALAR PRODUCT OF TRANSFORMATION VECTOR WITH EIGENVECTOR    00065200
       DO 970  J=IM,N                                                   00065300
970    TEMP = TEMP + B(J,2)*VECT(J,K)                                   00065400
       TEMP = TEMP + TEMP                                               00065500
       DO 980  J=IM,N                                                   00065600
980    VECT(J,K) = VECT(J,K) - TEMP*B(J,2)                              00065700
960    CONTINUE                                                         00065800
       JUMP = JUMP - IM                                                 00065900
950    IM = IM - 1                                                      00066000
1002   CONTINUE                                                         00066100
C      RESTORE ROOTS TO THEIR PROPER SIZE.                              00066200
       DO 95 I=1,NROOT                                                  00066300
95     ROOT(I) = ROOT(I)*ANORM                                          00066400
1001   RETURN                                                           00066500
       END                                                              00066600
