      program ham10
c**********************************************************************
c*                                                                    *
c*    Programa para diagonalizar el Hamiltoniano                      *
c*                                                                    *
c*    H=2*epsilon*N_f + omegab N_b + (b+b^t)*                         *
c*      (V1*:(B_0 + B_0^t)^2: +                                       *
c*       V2*:(B_1 + B_1^t)_0 ^2: )                                    *
c*     y  modelos bosonicos:                                          *
c*                                                                    *
c*    H=2*epsilon*N_f + omega N_b  +                                  *
c*        sum_{L} V_L ( :(b_f+b_f^t)^2: (1-nf/2Om) b+                 *
c*                      b^t (1-nf/2Om)  :(b_f+b_f^t)^2:)              *
c*                                                                    *
c*    El corte sencillo para el espacio bosonico es:
c*      N_f=N_{00}+N_{01}<= 2 Omega
c*      N_{01}<= Omega
c*
c*
c**********************************************************************
c* Sergio Lerma, 11 de julio 2003                                       *
c**********************************************************************
      real  epsilon,omegab,v1,v2, v1min,v1max,v1del,v2min,v2max,vdel,
     &      e0, F1,F2,nsr 
      real*8 D9JR3
      integer  omega,ngmax,nmb,jmin,jmax,J,jaux, nx,nrootx,njx,
     &         omegaaux,nev
c ATENCION!!! La dimension de nesp debe ser 2*omega, asi que si omega es
c mayor que veinte cambiar la dimension de nesp
      integer nesp(0:40,0:40,0:40,0:20),nee
      common /parametros/epsilon,omegab,v1,v2,e0,J
      common /topes/omega,ngmax
c Archivos 
      open(unit=1,file="ham10.in")
      open(unit=2,file="ham10.out")
c Archivos de salida (solo para J=0 y J=1)
c   energias
      open(unit=3,file="0+.dat")
      open(unit=4,file="0-.dat")
      open(unit=7,file="1+.dat")
      open(unit=8,file="1-.dat")
c   valores de expectacion
      open(unit=9,file="ex0+.dat")
      open(unit=10,file="ex0-.dat")
      open(unit=13,file="ex1+.dat")
      open(unit=14,file="ex1-.dat")
c lee archivo de entrada
      read(1,*) !epsilon,omegab
      read(1,*) epsilon,omegab
      read(1,*) !v1min,v1max,v1del
      read(1,*) v1min,v1max,v1del
      read(1,*) !v2min,v2max,v2del
      read(1,*) v2min,v2max,v2del
      read(1,*) !jmin,jmax
      read(1,*) jmin,jmax
      read(1,*) !omega
      read(1,*) omega
      read(1,*) !ngmax
      read(1,*) ngmax
      read(1,*) !nrootx
      read(1,*) nrootx
      read(1,*) !1 mapeo bosonico, 2 con corte,cualquier otro exacto 
      read(1,*) nmb
cc !!! EL calculo de los valores de expectacion NO ha sido implementado en los 
cc   modelos bosonicos!!!
      read(1,*) !1 calcular valores de expectacion, otro NO Calcular
      read(1,*) nev
ccc !! Revisar que la eliminacion funciona para el nuevo corte!!!
      read(1,*) ! 1 ->Eliminar estados espurios,otro-> no eliminar 
      read(1,*) nee 
cc COLOCACION DEL TERMINO DE CORTE
      read(1,*) !1 orden factorizable, otro orden del  paper)
      read(1,*) npc
      if ((nmb.eq.1.or. nmb.eq.2).and. nev.eq.1) then
         write(*,*) " El calculo de lo valores de expectacion NO
     & ha sido implementado para los modelos bosonicos,
     & es sencillo, pero requiere una media hora que 
     & no tengo ahora"
         nev=0
      end if   
c Escribe variables leidas
      write(2,*) "epsilo!,omegab"
      write(2,*) epsilon,omegab
      write(2,*) "v1min,v1max,v1del"
      write(2,*) v1min,v1max,v1del
      write(2,*) "v2min,v2max,v2del"
      write(2,*) v2min,v2max,v2del
      write(2,*) "jmin,jmax"
      write(2,*) jmin,jmax
      write(2,*) "omega"
      write(2,*) omega
      write(2,*) "ngmax"
      write(2,*) ngmax
      write(2,*) "nrootx"
      write(2,*) nrootx
      write(2,*) "1 mapeo bosonico, 2 con corte,cualquier otro exacto"
      write(2,*) nmb
      write(2,*) "1 ->Eliminar estados espurios, otro-> no eliminar" 
      write(2,*) nee
      write(2,*)"CORTE:1->posicion factorizable,otro->posiciondelpaper"
      write(2,*) npc
c Llama a subrutina de coeficientes de Wigner
      if (nmb.ne.1 .and. nmb.ne.2) CALL BLOCKS
c Llama a subrutina que marca a los estados espurios
      if ((nmb.eq.1.or.nmb.eq.2).and. nee.eq.1) 
     &    CALL espurios(jmin,jmax,omega,nesp)
c Para eliminar problemas con vdel=0.0:
      if (v1del.eq.0) then
        v1max=v1min+1.0
        v1del=2.0
      end if  
      if (v2del.eq.0) then
        v2max=v2min+1.0
        v2del=2.0
      end if
      numl=(int((v1max-v1min)/v1del)+1)*(int((v2max-v2min)/v2del)+1)
      write(*,*) " Total de pasos: ", numl
      write(*,*) "Tamanios de matrices a diagonalizar en cada paso"

c Inicio de loops para constantes de interaccion
      do v1=v1min,v1max,v1del
       do v2=v2min,v2max,v2del
        
    
c Loop para j
         do j=jmin,jmax
c------------PARIDAD POSITIVA----------------------------------------- 
          nc=0      
c Calcula tamanio de matriz para...         
          jaux=(2*((j+1)/2))      !j si j par, j+1 si j impar
          if ((nmb.eq.1 .or. nmb.eq. 2).and.nee.ne.1) then !(Modelo bosonico
                                                           ! con edos espurios)
           do   nc3=(jaux-j),2*omega-j,2               
           do   nc1=0,omega-j
c  Defincion del corte bosonico: N_f<= 2Omega y N_{01}<= Omega
            if ((nc3+2*nc1).le.(2*omega-j) .and. (2*nc1+j).le.omega) 
     &           nc=nc+1 
           end do
           end do

          else               !(diag exacta o modelo bosonico sin edos espurios)
           do nc1=jaux,omega,2
           do nc2=nc1,2*omega-nc1,2
            nc=nc+1
           end do 
           end do   
          end if
          njx=nc*(ngmax+1)
          if (v1.eq.v1min.and.v2.eq.v2min) 
     &    write(*,*) "para J^P= ",j,"+   :",njx
c Llama a subrutina de diagonalizacion
          call diagon(njx,nrootx,jaux,nmb,nev,nee,nesp,npc)
c------------PARIDAD NEGATIVA-----------------------------------------
          nc=0
          if (j.eq. 2*(j/2)) then           !j si j impar,j+1 si j par
           jaux=j+1
          else
           jaux=j
          end if    
c Calcula tamanio de matriz para...      
          if ((nmb.eq.1 .or. nmb.eq. 2).and.nee.ne.1) then !(modelo bosonico
                                                           !con edoc espurios) 
           do   nc3=(jaux-j),2*omega-j,2               
           do   nc1=0,omega-j
c  Defincion del corte bosonico: N_f<= 2Omega y N_{01}<= Omega
            if ((nc3+2*nc1).le.(2*omega-j) .and. (2*nc1+j).le.omega) 
     &           nc=nc+1
           end do
           end do
          else      !(diag exacta o modelo bosonico sin edos espurios)
           do nc1=jaux,OMEGA,2
           do nc2=nc1,2*omega-nc1,2
            nc=nc+1
           end do
           end do
          end if
          njx=nc*(ngmax+1)
          if (v1.eq.v1min.and.v2.eq.v2min) 
     &    write(*,*) "para J^P= ",j,"-   :",njx
          if ((v1.eq.v1min.and.v2.eq.v2min).and.j.eq.jmax)
     &    write(*,*) "Avance :"
c Llama a subrutina de diagonalizacion        
          call diagon(njx,nrootx,jaux,nmb,nev,nee,nesp,npc)
         end do
         numh=(int((v1-v1min)/v1del)+1)*(int((v2-v2min)/v2del)+1) 
         
         write(*,*)  !numh," pasos de ",numl,"  "
     &               ,int(100.0*numh/numl)," %"   
       end do
      end do
      stop
      end
c**********************************************************************

c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine diagon (njx,nrootx,jaux,nmb,nev,nee,nesp,npc)
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      integer njx,nrootx,jaux,nmb,nev,nee, nesp(0:40,0:40,0:40,0:20),
     & npc,npc3,npc1
      real e(nrootx),e0,root(nrootx),vect(njx,nrootx)
     &     ,A(((njx+1)*njx)/2),h,nq00,ng0,xnq00(nrootx),xng0(nrootx)
     &     ,epsilon,omegab,v1,v2,vc
      integer J,omega,ngmax
      common /parametros/epsilon,omegab,v1,v2,e0,J
      common /topes/omega,ngmax
      i=0
c CONSTRUYE LA MATRIZ PARA...
      if (nmb .eq.1 .or. nmb .eq.2) then 
c=================Modelo bosonico======================================
       if (nmb.eq.1) vc=0.0           ! (Mod bosonico)
       if (nmb.eq.2) vc=1.0           ! (Con corte)
       do nga=0,ngmax  
       do n3a=(jaux-j),2*omega-j,2
       do n1a=0,omega-j
c  Defincion del corte bosonico: N_f<= 2Omega y N_{01}<= Omega
        if ((n3a+2*n1a).le.(2*omega-j) .and. (2*n1a+j).le.omega) then
        if( (nee.eq.1 .and. nesp(n3a,2*n1a,n3a+2*n1a+j,j).eq.1)
     &      .or. nee.ne.1)       then        !Edos espurios 
          do ngb=0,nga
          n3blim=2*omega-j
          if (ngb.eq.nga) n3blim=n3a
          do n3b=(jaux-j),n3blim,2
          n1blim=omega-j
          if (ngb.eq.nga. and. n3b.eq.n3a) n1blim=n1a
          do n1b=0,n1blim
c  Defincion del corte bosonico: N_f<= 2Omega y N_{01}<= Omega
          if ((n3b+2*n1b).le.(2*omega-j) .and. (2*n1b+j).le.omega) then
          if( (nee.eq.1.and.nesp(n3b,2*n1b,n3b+2*n1b+j,j).eq.1)
     &           .or. nee.ne.1)   then      !Edos espurios

            i=i+1
            h=0.0
c Elementos de matriz en aprox bosonica             
c-------------------Diagonal------------------------------------------ 
            if (nga.eq.ngb.and. (n1a.eq.n1b .and. n3a.eq.n3b)) 
     &      h=omegab*1.0*nga + 2.0*epsilon*(n3a+j+2*n1a)
c-------------------Interaction terms---------------------------------
            if (ngb.eq.(nga-1)) then  !(terminos b^t no contribuyen)   
c-------------------Pair Creation and annihilation-------------------- 
           
             if (npc.eq.1) then   ! posicion del corte
                npc3=n3b
                npc1=n1b
             else
                npc3=n3a
                npc1=n1a
             end if   

c B_0^t^2 b
             if (n3b.eq.(n3a+2).and. n1b.eq.n1a)
     &       h=2*omega*v1*sqrt(1.0*nga*(n3a+1)*(n3a+2))  !BOSONICO
     &          * (1.0-vc*(n3a+j+2*n1a)/(2*omega))       !CORTE     

c B_1^t^2 b
             if (n3b.eq.n3a .and. n1b.eq.(n1a+1))
     & h=2*omega*(v2/3.0)*sqrt(1.0*nga*(n3a+2*n1a+2)*(2*n1a+n3a+2*j+3))
     &          * (1.0-vc*(n3a+j+2*n1a)/(2*omega))  !CORTE 

c-------------------Scattering-----------------------------------------
c (V1*B_0^t B_0 + V2*B_1^t B_1 ) b 
             if (n3b.eq.n3a .and. n1b.eq.n1a)
     &       h=4.0*omega*sqrt(1.0*nga)*(v1*n3a+(v2/3.0)*(j+2*n1a))!BOSONICO  
     &            * (1.0-vc*(n3a+j+2*n1a)/(2*omega))        !CORTE     

c-------------------Vacuum corelations---------------------------------
c B_0^2 b    
             if (n3a.eq.(n3b+2).and. n1b.eq.n1a)
     &       h=2*omega*v1*sqrt(1.0*nga*(n3b+1)*(n3b+2))     !BOSONICO
     &          * (1.0-vc*(npc3+j+2*npc1)/(2*omega))     !CORTE  !Cambia a variables "b" para ( (bf^t)^2 (1-nf/2J) + (1-nf/2J) (bf) ^2)

c B_1^2 b
             if (n3b.eq.n3a .and. n1a.eq.(n1b+1))
     & h=2*omega*(v2/3.0)*sqrt(1.0*nga*(n3b+2*n1b+2)*(2*n1b+n3b+2*j+3))
     &     * (1.0-vc*(npc3+j+2*npc1)/(2*omega))          !CORTE  !Cambia a variables "b" para ( (bf^t)^2 (1-nf/2J) + (1-nf/2J) (bf) ^2)
            end if  
c----------------------------------------------------------------------
c Asigna valor de elemento de matriz a arreglo A()
            a(i)=h

           end if 
           end if
          end do
          end do
          end do
        end if  
        end if
       end do
       end do
       end do
      else 
c================Diagonalizacion  Exacta===============================
       do na=0,ngmax
       do ndsqa=jaux,OMEGA,2
       do nqa=ndsqa,2*omega-ndsqa,2
          do nb=0,na
          ndsqblim=OMEGA   
          if (nb.eq.na) ndsqblim=ndsqa
          do ndsqb=jaux,ndsqblim,2
          nqblim=2*omega-ndsqb
          if (nb.eq.na .and. ndsqb.eq.ndsqa) nqblim=nqa
          do nqb=ndsqb,nqblim,2
           i=i+1
           h=0.0
c Elementos de matriz exactos           
c-------------------Diagonal-------------------------------------------
           if ((na.eq.nb .and. ndsqa.eq.ndsqb).and. nqa.eq.nqb) 
     &     h=2.0*epsilon*nqa+omegab*na
c-------------------Interaction terms---------------------------------
           if (nb.eq.(na-1)) then   !(terminos b^t no contribuyen)
c-------------------Pair Creation and annihilation-------------------- 
c (V1*B_0^t^2 + V2*B_1^t^2) b     
             if (nqb.eq.(nqa+2).and.( (ndsqb.eq.ndsqa.or.
     &           ndsqb.eq.(ndsqa-2)).or. ndsqb.eq.(ndsqa+2))) 
     &       h=sqrt(1.0*na)*( 2.0*v1*F1(omega,0,nqa,ndsqa,ndsqb,J)
     &                     +      v2*F1(omega,1,nqa,ndsqa,ndsqb,J) )
c-------------------Scattering-----------------------------------------
c (V1*B_0^t B_0 + V2*B_1^t B_1 ) b 
             if ((nqb.eq.nqa).and.( (ndsqb.eq.ndsqa.or.ndsqb.eq.
     &           (ndsqa-2)).or. ndsqb.eq.(ndsqa+2)) ) 
     &       h=2.0*sqrt(1.0*na)*(2.0*v1*F2(omega,0,nqa,ndsqa,ndsqb,J)
     &                         +     v2*F2(omega,1,nqa,ndsqa,ndsqb,J) )
c-------------------Vacuum corelations---------------------------------
c (V1*B_0^2  +  V2*B_1^2) b  
             if (nqb.eq.(nqa-2) .and.( (ndsqb.eq.ndsqa.or.
     &           ndsqb.eq.(ndsqa-2)).or. ndsqb.eq.(ndsqa+2))) 
     &       h=sqrt(1.0*na)*( 2.0*v1*F1(omega,0,nqb,ndsqb,ndsqa,J) 
     &                     +      v2*F1(omega,1,nqb,ndsqb,ndsqa,J) )
           end if  
c----------------------------------------------------------------------
c Asigna valor de elemento de matriz a arreglo A() 
           a(i)=h
          end do
          end do
          end do
       end do
       end do
       end do
      end if
      if (i.ne.(((njx+1)*njx)/2) ) then
        write(*,*) "error!!!, tamanio de arreglo (",i,") no concuerda",
     &              " con tamanio declarado (",((njx+1)*njx)/2,")"  
        stop
      end if
c      write(*,*) "Diagonalizando matriz de tamanio:",njx
      CALL  GIVENS(A,ROOT,VECT,NJX,NROOTX,NJX)
c      write(*,*) "Diagonalizada"
c   CALCULO DE LOS VALORES DE EXPECTACION
      if (nev.eq. 1) then  !Solo si se se quieren calcular
       do mn=nrootx,1,-1
         i=0
         nq00=0.0
         ng0=0.0
         do na=0,ngmax
          do ndsqa=jaux,OMEGA,2
           do nqa=ndsqa,2*omega-ndsqa,2
            i=i+1
            nq00=nq00+real(nqa)*(vect(i,mn)**2) 
            ng0 =ng0 +real(na)*(vect(i,mn)**2) 
           end do
          end do
         end do
         xnq00(nrootx+1-mn)=nq00
         xng0(nrootx+1-mn)=ng0
       end do
      end if 
c_________________________SALIDA_______________________________________
c solo para J=0 y J=1
      if (J.eq.0 .and. jaux .eq.0 ) e0=root(nrootx)
      nag=1
      if ( jaux.eq.(2*((j+1)/2))) nag=0
      nf=3+4*j+nag
      do nn=nrootx,1,-1
         e(nrootx+1-nn)=root(nn)-e0
      end do
c Escribe energias (maximo 10)          
      write(nf,560) v1,v2,e0,e(1),e(2),e(3)
     &,e(4),e(5),e(6),e(7)
     &              ,e(8),e(9),e(10)         
c Escribe valores de expectacion
      if (nev.eq.1) 
     & write(nf+6,560) v1,v2,xnq00(1),xnq00(2),xnq00(3),xnq00(4),
     &xnq00(5),xnq00(6),xnq00(7),xng0(1),xng0(2),xng0(3),xng0(4),
     &xng0(5),xng0(6),xng0(7) 
      
560   format(1x,25(1x,f18.7))
      return
      end
c**********************************************************************
c FIN DE SUBRUTINA DIAGON                                             *
c**********************************************************************

c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine espurios(jmin,jmax,omega,nesp)
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c Subrutina para elminar los estados espurios, a los estados a eliminar
c les asigna nesp(n0,2*n2,N,j)=0 y a los restantes
c les asigna nesp(n0,2*n2,N,j)=1
c donde n0 es el numero de pares espin 0
c       n2 el numero de (b1Xb1)_00 
c       j el espin total
c       N el numero total de pares (N=n0+2*n2+j) 

      integer jmin,jmax,omega,nesp(0:40,0:40,0:40,0:20)
      do j=jmin,jmax
        do  N=0,2*omega-j              
         if (N+j.eq. 2*((N+j)/2)) then  !si N+j es par
            nin=0
            nca=( (2*omega-(N+j))/2 ) + 1
         else
            nin=1
            nca=(2*omega-(N+j)+1)/2
         end if
         i=0
c CRITERIOS: 0,N-j-nin,2  QUITAR EDOS CON MENOR NUMERO DE PARES B_00^t
c            N-j-nin,0,-2 QUITAR EDOS CON MENOR NUMERO DE PARES B_11^t

         do ndn1=N-j-nin,0,-2! 0,N-j-nin,2 ! 
            n0=(N-j)-ndn1
            i=i+1
            if (i.le.nca.or. N.le. omega) then             
                nesp(n0,ndn1,N,j)=1             
            else
                nesp(n0,ndn1,N,j)=0
            end if
         end do   
        end do 
      end do   
      return
      end 

c**********************************************************************
c FUNCIONES:                                                          *
c**********************************************************************
c-------F1--------------
      real function F1(om,L,nq,dsq,dsqp,J)
      real nsr
      integer om,L,nq,dsq,dsqp,J,sbp
      real fm,sum
      real *8 D9JR3
      F1=0.0
      if (nq.eq.2*om .or. nq.eq.(2*om-1)) go to 10
      fm=(-1)**((dsq-dsqp+2)/2)*sqrt(real((2*L+1)*(dsq+1)*(dsqp+1)))
      fm=fm*nsr(om,dsq,(nq-dsq)/2,dsqp,(nq+2-dsqp)/2)
      sum=0.0
      do asbp=abs(dsq-1),dsq+1,2 ! min(dsq+1,min(nq+1,2*om-nq-1)),2
         sbp=asbp
         do jbp=abs(J-L),J+L !min(J+L,sbp),2
            sum=sum+(sbp+1)*(2*jbp+1)
     &          *D9JR3(dsqp,dsqp,2*J,sbp,sbp,2*jbp,1,1,2*L)
     &          *D9JR3(dsq,dsq,2*J,sbp,sbp,2*jbp,1,1,2*L)
         end do
      end do
      F1=sum*fm
 10   return
      end
c-------F2--------------
      real function F2(om,L,nq,dsq,dsqp,J)
      real nsr
      integer om,L,nq,dsq,dsqp,J,sbp
      real fm,sum
      real *8 D9JR3
      F2=0.0
      if (nq.eq.0) go to 80
      fm=(-1)**(L-(dsq+dsqp-2)/2)*sqrt(real((2*L+1)*(dsq+1)*(dsqp+1)))
      sum=0.0
      do asbp=abs(dsq-1),dsq+1,2  !min(dsq+1,min(nq+1,2*om-nq-1)),2
         sbp=asbp
         do jbp=abs(J-L),J+L !min(J+L,sbp),2
            sum=sum+((-1)**(sbp))*(sbp+1)*(2*jbp+1)
     &          *D9JR3(dsqp,dsqp,2*J,sbp,sbp,2*jbp,1,1,2*L)
     &          *D9JR3(dsq,dsq,2*J,sbp,sbp,2*jbp,1,1,2*L)
     &          *NSR(om,sbp,(nq-1-sbp)/2,dsqp,(nq-dsqp)/2)
     &          *NSR(om,sbp,(nq-1-sbp)/2,dsq,(nq-dsq)/2)   
         end do
      end do
      F2=sum*fm       
 80   return 
      end
c-------NSR-------------
      real function nsr(om,n1,n2,m1,m2)
      integer om,n1,n2,m1,m2
      integer nmi
      nmi=1
      do i=n2+1,m2
         nmi=nmi*i
      end do
      do i=(n1+n2+2),(m1+m2+1)
         nmi=nmi*i
      end do
      do i=(om-m1-m2+1),(om-n1-n2)
         nmi=nmi*i
      end do
      do i=(om-m2+2),(om-n2+1)
         nmi=nmi*i
      end do
      nsr=sqrt(real(nmi))
      return 
      end

