C THIS PROGRAM fits spectrum of the model hamiltonian of QCD
c to the experimental spectrum. Care has to be taken, because
c the fit inlcudes only the center of energy of each
c Meson flavour irrep ( (0,0) and (1,1) only ).
C the Gell'man-Okubo mass formula has to be added afterwards,
c in order to descibe the fine structure.
c
c 22/10/2001 by S. Lerma and P. O. Hess
c Last modification: 17/09/2002
c
c The minimization routine MINUIT from CERN is used.
c
c The interaction is b-->fermionpair, B -->gluonpair
c
c  C1  boot^2 Boo + Boot boo^2
c  C2  boot boo (Bt + B)
C  C3  b(00)1t^2 Boo + Boot b(00)1^2
C  C4  b(00)1t b(00)1 (Bt + B)
C  C5  b(11)o^t b(11)o^t Boo + Boo^t b(11)o b(11)o
C  C6  (b(11)o^t b(11)o) (Boo^t + Boo)
C  C7  b(11)1^t b(11)1^t Boo + Boo^t b(11)1 b(11)1
C  C8  (b(11)1^t b(11)1) (Boo^t + Boo)

C***************************************************************
c Parameters:
c
c v_1, v_2, v_3, v_4, v_5, v_6, v_7, v_8: Interaction parameters
c mq = effective mass of the quarks, antiquarks
c mg0= effective mass for spin 0 gluons pairs
c
c RECOMENDATION: Fix mg0. For example, the parameters
c                mg0 can be taken from
c                P.O.Hess et al., Eur. Phys. Jour. C9 (1999), 121
c                Equation (40).
C
C***************************************************************
C As the fitting routine we use MINUIT from the CERN-library.
c If others are used, one has to change the part of the Main program
c which is related to this fitting routine. One can chose between
c a random search with a final gradient procedure or ONLY the
c gradient procedure. The last one takes less time.
C***************************************************************
      IMPLICIT REAL*8 (A-H,O-Z)
      integer fnjx,fnjxp,omega
      external fcn,energycut,energypru,fnjx
      real*8  argpmin(2) 
      parameter(maxe=10, ! max number of states considered
     &          maxs=8, ! max spin
     &          maxdat=20, ! max. numb. of exp. data 
     &          lamu=20, ! max. value of lamda,mu
     &          lmax=20, !max. valor de spin
     &          maxind=900) ! max. number of states N=seniority
     

      real*8 mq,mqmin,mqmax,mqdel,mqstart
      real*8 mg0,mg0min,mg0max,mg0del,mg0start
c parametros de corte
      real*8 mqest00,mqest01,mqest10,mqest11,mg0est,etop

      dimension xnq00(maxe,0:maxs,0:1,0:1),xnq01(maxe,0:maxs,0:1,0:1)
      dimension xnq10(maxe,0:maxs,0:1,0:1),xnq11(maxe,0:maxs,0:1,0:1)
      dimension xng0(maxe,0:maxs,0:1,0:1)
c Seniorities----------
      integer nv00(maxe,0:maxs,0:1,0:1),nv01(maxe,0:maxs,0:1,0:1)
     & ,nv10(maxe,0:maxs,0:1,0:1),nv11(maxe,0:maxs,0:1,0:1)
     & ,ndeg(maxe,0:maxs,0:1,0:1) 
c----------------------
      integer smin,smax
      dimension ee(maxe,0:maxs,0:1,0:1),xpp(maxe,0:maxs,0:1,0:1)
      integer ninxu(0:maxs,0:1,0:1)  !!NUEVO
      
      dimension exval(maxdat),weight(maxdat)
      dimension ipar(maxdat),ifla(maxdat)
      dimension ijj(maxdat)

      dimension ipafla00(0:maxs),ipafla01(0:maxs),ipafla10(0:maxs)
      dimension ipafla11(0:maxs)
      character*9 energy
c para MiNUIT      
      character*10 pnam(10)
      dimension bnd1(10),bnd2(10),pmin(10),perr(10)
     


      dimension jl1(maxind,0:lamu,0:1,0:lmax),
     &jv110(maxind,0:lamu,0:1,0:lmax)
      dimension jla1(maxind,0:lamu,0:1,0:lmax)
      dimension jn000(maxind,0:lamu,0:1,0:lmax)
      dimension jv111(maxind,0:lamu,0:1,0:lmax)
      dimension jla2(maxind,0:lamu,0:1,0:lmax),
     &jmu2(maxind,0:lamu,0:1,0:lmax)
      dimension jl2(maxind,0:lamu,0:1,0:lmax)
      dimension jmultot(maxind,0:lamu,0:1,0:lmax)
      dimension jindex(0:lamu,0:1,0:lmax)

      common /senior/jl1,jv110,jla1,jn000,jv111,jla2,jmu2,jl2,
     &               jmultot,jindex
      common /dat/ndj,ndomega
      common /data2/mq,mg0,c1,c2,c3,c4,c5,c6,c7,c8,xc,ifit0
      common /dataex/exval,weight,ndat,ipar,ifla,ijj
      common /datain/smin,smax,ng0max,nqmax,neigw,ne0
      common /corte/mqest00,mqest01,mqest10,mqest11,mg0est,etop
      common/tipodecor/npcor
c      common /datmax/maxe,maxs
c    Inicializando las variables
      numdata=maxe*(maxs+1)*4
      data ee /360*0.0/
      data xnq00 /360*0.0/
      data xnq01 /360*0.0/
      data xnq10 /360*0.0/
      data xnq11 /360*0.0/
      data xng0 /360*0.0/
      
      numdata2=(maxs+1)*4
      data ninxu /36*0/


       OPEN (UNIT=5,FILE='fit.in')
       OPEN (UNIT=4,FILE='fit.out')
       OPEN (UNIT=7,FILE='save.out')
       OPEN (UNIT=8,FILE='fitinput.dat')
       OPEN (UNIT=50,FILE='nv-space.dat')

c
c CHECK IF NEEDED REALLY!!!!!!!!!!!!!!:
c
c For initializing calculation for coupling and recoupling
c coefficients of SU(2):
c
c call the subroutine, which prepares data for
c the calculation of SU(2) coupling and recoupling
c coefficients
c      call blocks1
c
c      WRITE(4,*)' before read statements'
      read(5,*)
      read(5,*) mqmin,mqmax,mqdel
      read(5,*)
      read(5,*) mg0min,mg0max,mg0del
      read(5,*)
      read(5,*) c1min,c1max,c1del
      read(5,*)
      read(5,*) c2min,c2max,c2del
      read(5,*)
      read(5,*) c3min,c3max,c3del
      read(5,*)
      read(5,*) c4min,c4max,c4del
      read(5,*)
      read(5,*) c5min,c5max,c5del
      read(5,*)
      read(5,*) c6min,c6max,c6del
      read(5,*)
      read(5,*) c7min,c7max,c7del
      read(5,*)
      read(5,*) c8min,c8max,c8del
      read(5,*)
      read(5,*) omega,ndj
      read(5,*)
      read(5,*) mqest00,mqest01,mqest10,mqest11,mg0est,etop

c reading further data
      read(5,*)
      read(5,*) ng0max
      read(5,*)
      read(5,*) nqmax
      read(5,*)
      read(5,*) smin,smax
      read(5,*)
      read(5,*) neigw
      read(5,*)
      read(5,*) ne0
      read(5,*) 
      read(5,*) xc
      read(5,*) 
      read(5,*) npcor
      ndomega=2*omega
      if (ndj.gt.ndomega) then
         write(*,*) "Pseudoespin (2*j=",ndj,")  greater than allowed ",
     &  "(2*Omega=",ndomega,")"
         write(*,*) "change 2*j or omega"
         stop
      end if

      if (neigw.gt.maxe) then
         write(*,*) "Number of wanted eigenvalues (",neigw,") greater",
     & " than allowed (",maxe,")"
         write(*,*) "decrease number of wanted eigenvalues"
         write(*,*) " or increase internal parameter maxe in fit.f"
         stop
      end if   
      

      write(4,*)' mqmin,mqmax,mqdel:'
      write(4,*) mqmin,mqmax,mqdel
      write(4,*)' mg0min,mg0max,mg0del:'
      write(4,*) mg0min,mg0max,mg0del
      write(4,*)' c1min,c1max,c1del:'
      write(4,*) c1min,c1max,c1del
      write(4,*)' c2min,c2max,c2del:'
      write(4,*) c2min,c2max,c2del
      write(4,*)' c3min,c3max,c3del:'
      write(4,*) c3min,c3max,c3del
      write(4,*)' c4min,c4max,c4del:'
      write(4,*) c4min,c4max,c4del
      write(4,*)' c5min,c5max,c5del:'
      write(4,*) c5min,c5max,c5del
      write(4,*)' c6min,c6max,c6del:'
      write(4,*) c6min,c6max,c6del
      write(4,*)' c7min,c7max,c7del:'
      write(4,*) c7min,c7max,c7del
      write(4,*)' c8min,c8max,c8del:'
      write(4,*) c8min,c8max,c8del
      WRITE(4,*)' OMEGA, ndj'
      WRITE(4,*)  OMEGA,"   ",ndj
     
      write(4,*) 'mqest00,mqest01,mqest10,mqest11,mg0est ,   etop'
      write(4,895) mqest00,mqest01,mqest10,mqest11,mg0est,etop
 895  format (5(1x,f5.1,2x),2x,f7.1)
      write(4,*)' ng0max:'
      write(4,*)' ', ng0max
      write(4,*)' nqmax:'
      write(4,*)' ', nqmax
      write(4,*)' smin,smax:'
      write(4,896) smin,smax
      write(4,*) "number of wanted eigenvalues for each (lam,mu)J^P",
     &           " sector"
      write(4,*) neigw
      write(4,*) "0->newcut,any other->oldcut : ",npcor
      write(4,*)

 896  format(2(1x,i3))

      if (npcor.eq.0) then
       nbbb=FNJX(0,0,0,0,NG0MAX,
     &           min(NQMAX,ndj),ndj,mqest00,mqest01,mqest10,mqest11
     &           ,mg0est,etop)
       energy="energycut"
      else
       nbbb= FNJXP(0,0,0,0,NG0MAX,
     &             min(NQMAX,ndj),mqest00,mqest01,mqest10,mqest11
     &             ,mg0est,etop)
       energy="energypru"
      end if 
      write(4,*) "greatest matrix size (row's number): ",nbbb
      write(*,*) "greatest matrix size (row's number): ",nbbb
c
c read indices for the q-part: no. of pairs=seniority
      read (50,*) nmfnv,nsfnv
      if (nsfnv.lt.smax) then
       write(*,*)"smax (",smax," ) greater than spin from seniorities."
       write(*,*) " run nv.exe again  with greater spin"
       write(*,*) " or decrease  smax less or equal than ",nsfnv
       stop
      end if   
      do 90 L0=0,smax 

      do 91 iparity=0,1

      do 92 la0=0,1
      read(50,*) inmax
      jindex(la0,iparity,l0)=inmax
            do 93 index=1,inmax
            read(50,*) n000,l1,iv110,la1,iv111,la2,mu2,l2,multot
            jn000(index,la0,iparity,L0)=n000
            jl1(index,la0,iparity,L0)=l1
            jv110(index,la0,iparity,L0)=iv110
            jla1(index,la0,iparity,L0)=la1
            jv111(index,la0,iparity,L0)=iv111
            jla2(index,la0,iparity,L0)=la2
            jmu2(index,la0,iparity,L0)=mu2
            jl2(index,la0,iparity,L0)=l2
            jmultot(index,la0,iparity,L0)=multot

 93    continue
 92    continue
 91    continue
 90    continue
       write(4,*)
       write(4,*) "number max of quarks in  seniorities: ",nmfnv
       write(4,*)
       write(4,*) "maximum spin in seniorities: ",nsfnv
       write(4,*) 
c --------------------------------------------------------
c decide wether to apply a fit (ifit0=1) or not (ifit0=0)

      read(5,*)
      read(5,*) ifit0
      if(ifit0.ne.0.and.ifit0.ne.1) then
      write(4,*)' please use values 0 or 1 only for ifit0!!!'
      stop
      endif

      if(ifit0.eq.0) then
      mq=mqmin
      mg0=mg0min
      c1=c1min
      c2=c2min
      c3=c3min
      c4=c4min
      c5=c5min
      c6=c6min
      c7=c7min
      c8=c8min
      go to 1234
      endif

      read(5,*)
      read(5,*) mqstart,mg0start
      write(4,*)' mqstart,mg0start:'
      write(4,782) mqstart,mg0start
 782  format (2(1x,f7.4))
      read(5,*)
      read(5,*) c1start,c2start,c3start,c4start,c5start,
     &          c6start,c7start,c8start
      write(4,*)' c1start,c2start,c3start,c4start:'
      write(4,783) c1start,c2start,c3start,c4start
 783  format(4(1x,f7.4))
c if ifitm=1: only gradient fit is used
c if ifitm=2: random search plus gradient fit are used
      read(5,*)
      read(5,*) ifitm
      if(ifitm.ne.1.and.ifitm.ne.2) then
      write(4,*)' please use values 1 or 2 only for ifitm!!!'
      stop
      endif
c (1)  The optional argument [maxcalls](argpmin(1)) specifies the (approximate)
c  maximum number of function (FCN) calls after which the calculation 
c  will be stopped   even if it has not yet  converged.

c (2)  The optional argument [tolerance](argpmin(2)) specifies required 
c  tolerance on the function  value at the minimum.
c  The default tolerance is 0.1, and the minimization  will stop when the
c  estimated vertical distance to the minimum (EDM) is less than
c   0.001*[tolerance]*UP (UP=1.0).

c  numar - indica cuantas  de las 2 variables anteriores son asignadas
c  por el usuario (0,1 o 2) 

      read(5,*)
      read(5,*) argpmin(1),argpmin(2),numar


      write(4,*)"maximum of calls, tolerance, specified(0,1,2)"
      write(4,408) argpmin(1),argpmin(2),numar
 408  format(5x,f6.1,8x,f8.5,7x,i1)
c --------------------------------------------------------
c reading experimental data:
c ndat: number of experimental data
c exval: experimental energy
c weight: weight given to this data
c ipar: parity (0--->+, 1---> -)
c ifla: flavour ( 0--->(0,0), 1---> (1,1) )
c

      read(8,*)
      read(8,*) ndat
      read(8,*)
      read(8,*)

      do 100 ii=1,ndat
      read(8,*) ipar(ii),ifla(ii),ijj(ii),exval(ii),weight(ii)
 100  continue
      write(4,*)
      write(4,*)' Experimental input data:'
      write(4,*)' total number = ',ndat
      write(4,*)' parity, flavour, total spin, exp. value(GeV), weight'
      write(4,930)
 930  format(80('_'))
c      write(4,*)' (total spin is 2*real spin!!!)'

      do 101 ii=1,ndat

      if(ifla(ii).eq.0) then
      write(4,931) (-1)**ipar(ii),ifla(ii),ifla(ii),ijj(ii),exval(ii),
     & weight(ii)
      endif

      if(ifla(ii).eq.1) then
      write(4,931) (-1)**ipar(ii),ifla(ii),ifla(ii),ijj(ii),exval(ii),
     & weight(ii)
      endif
 931  format(3x,i2,6x,'(',i1,',',i1,')',7x,i1,9x,f5.3,9x,f5.1)
 101  continue
      write(4,930)
      write(4,*)
      write(4,*)
c --------------------------------------------------------
c
c declaration to minuit of the data files:
c
      ird=5
      iwr=4  !CAMBIO!!!!!!!!!!!!!!!
      isav=7
c
c      write(4,*)' before mninit'
      call mninit(ird,iwr,isav)
c      write(4,*)' after mninit'
c
c define the parameters for minuit and their range:
c num = number of parameters
c ierfl = error flag
c
c     write(4,*)' before mnparm: no 1'
      num=1
      xy1=mqstart
      if(mqdel.eq.0.d0) xy1=mqmin
      call mnparm(num,'mq',xy1,mqdel,mqmin,mqmax,ierfl)
      if(ierfl.ne.0) then
      write(4,*)' unable to define parameter mq',ierfl
      stop
      endif

c     write(4,*)' before mnparm: no 2'
      num=2
      xy2=mg0start
      if(mg0del.eq.0.d0) xy2=mg0min
      call mnparm(num,'mg0',xy2,mg0del,mg0min,mg0max,ierfl)
      if(ierfl.ne.0) then
      write(4,*)' unable to define parameter mg0',ierfl
      stop
      endif

c     write(4,*)' before mnparm: no 3'
      num=3
      xy3=c1start
      if(c1del.eq.0.d0) xy3=c1min
      call mnparm(num,'c1',xy3,c1del,c1min,c1max,ierfl)
      if(ierfl.ne.0) then
      write(4,*)' unable to define parameter c1',ierfl
      stop
      endif

c     write(4,*)' before mnparm: no 4'
      num=4
      xy4=c2start
      if(c2del.eq.0.d0) xy4=c2min
      call mnparm(num,'c2',xy4,c2del,c2min,c2max,ierfl)
      if(ierfl.ne.0) then
      write(4,*)' unable to define parameter c2',ierfl
      stop
      endif

c     write(4,*)' before mnparm: no 5'
      num=5
      xy5=c3start
      if(c3del.eq.0.d0) xy5=c3min
      call mnparm(num,'c3',xy5,c3del,c3min,c3max,ierfl)
      if(ierfl.ne.0) then
      write(4,*)' unable to define parameter c3',ierfl
      stop
      endif

c     write(4,*)' before mnparm: no 6'
      num=6
      xy6=c4start
      if(c4del.eq.0.d0) xy6=c4min
      call mnparm(num,'c4',xy6,c4del,c4min,c4max,ierfl)
      if(ierfl.ne.0) then
      write(4,*)' unable to define parameter c4',ierfl
      stop
      endif

c      write(4,*)' before mnparm: no 7'
      num=7
      xy7=c5start
      if(c5del.eq.0.d0) xy7=c5min
      call mnparm(num,'c5',xy7,c5del,c5min,c5max,ierfl)
      if(ierfl.ne.0) then
      write(4,*)' unable to define parameter c5',ierfl
      stop
      endif

      num=8
      xy8=c6start
      if(c6del.eq.0.d0) xy8=c6min
      call mnparm(num,'c6',xy8,c6del,c6min,c6max,ierfl)
      if(ierfl.ne.0) then
      write(4,*)' unable to define parameter c6',ierfl
      stop
      endif

      num=9
      xy9=c7start
      if(c7del.eq.0.d0) xy9=c7min
      call mnparm(num,'c7',xy9,c7del,c7min,c7max,ierfl)
      if(ierfl.ne.0) then
      write(4,*)' unable to define parameter c7',ierfl
      stop
      endif

      num=10
      xy10=c8start
      if(c8del.eq.0.d0) xy10=c8min
      call mnparm(num,'c8',xy10,c8del,c8min,c8max,ierfl)
      if(ierfl.ne.0) then
      write(4,*)' unable to define parameter c8',ierfl
      stop
      endif
c
c actual minimization
c
c      write(4,*)' before mnexcm'
      if(ifitm.eq.1) then
      call mnexcm(fcn,'migrad',argpmin,numar,ierfl,energy)
      endif

      if(ifitm.eq.2) then
      call mnexcm(fcn,'minimize',argpmin,numar,ierfl,energy)
      endif
      write(4,*)' after mnexcm, ierfl = ',ierfl

c getting results of minimization:
c
c pmin(k) = field of optimal parameter values
c perr(k) = field of parameter errors
c bnd1(k) = lower bound of parameter
c bnd2(k) = upper bound of parameter
c ivarbl = set by minuit
c

c
c 1) parameters
c
      num=1
      bnd1(1)=mqmin
      bnd2(1)=mqmax
      call mnpout(num,pnam(1),pmin(1),perr(1),bnd1(1),bnd2(1),ivarbl1)
      mq=pmin(1)

      num=2
      bnd1(2)=mg0min
      bnd2(2)=mg0max
      call mnpout(num,pnam(2),pmin(2),perr(2),bnd1(2),bnd2(2),ivarbl2)
      mg0=pmin(2)

      num=3
      bnd1(3)=c1min
      bnd2(3)=c1max
      call mnpout(num,pnam(3),pmin(3),perr(3),bnd1(3),bnd2(3),ivarbl3)
      C1=pmin(3)

      num=4
      bnd1(4)=c2min
      bnd2(4)=c2max
      call mnpout(num,pnam(4),pmin(4),perr(4),bnd1(4),bnd2(4),ivarbl4)
      C2=pmin(4)

      num=5
      bnd1(5)=c3min
      bnd2(5)=c3max
      call mnpout(num,pnam(5),pmin(5),perr(5),bnd1(5),bnd2(5),ivarbl5)
      C3=pmin(5)

      num=6
      bnd1(6)=c4min
      bnd2(6)=c4max
      call mnpout(num,pnam(6),pmin(6),perr(6),bnd1(6),bnd2(6),ivarbl6)
      C4=pmin(6)

      num=7
      bnd1(7)=c5min
      bnd2(7)=c5max
      call mnpout(num,pnam(7),pmin(7),perr(7),bnd1(7),bnd2(7),ivarbl7)
      C5=pmin(7)

      num=8
      bnd1(8)=c6min
      bnd2(8)=c6max
      call mnpout(num,pnam(8),pmin(8),perr(8),bnd1(8),bnd2(8),ivarbl8)
      C6=pmin(8)

      num=9
      bnd1(9)=c7min
      bnd2(9)=c7max
      call mnpout(num,pnam(9),pmin(9),perr(9),bnd1(9),bnd2(9),ivarbl9)
      C7=pmin(9)

      num=10
      bnd1(10)=c8min
      bnd2(10)=c8max
      call mnpout(num,pnam(10),pmin(10),perr(10),bnd1(10),bnd2(10),
     &            ivarbl10)
      C8=pmin(10)
c
c 2) function value:
c
c fmin = minimal value for energy encountered
c fedm = the estimated vertical distance remaining to the minimum
c errdef = the value of up defining parameter uncertainties
c istat = a status integer indicating how good is the
c         covariance matrix
c         (0 : not calculated at all,
c          1 : diagonal approximation only, not accurate,
c          2 : full matrix, but forced positive definite
c          3 : full accurate covariance matrix (after migrad this is
c              indication of normal covariance)
c npx = set by minuit
c
      call mnstat(fmin,fedm,errdef,npari,npx,istat)
 1234 continue
      ifit0=0
      write(4,*) "fcn min: ", fmin
      
      if(npcor.eq.0) then
        call energycut(ee,maxe,maxs,
     &xnq00,xnq01,xnq10,xnq11,xng0,! valores de expectacion
     &nv00,nv01,nv10,nv11,ndeg,         !Seniorities 
     &e0,ninxu)
      else
        call energypru(ee,maxe,maxs,
     &xnq00,xnq01,xnq10,xnq11,xng0,! valores de expectacion
     &nv00,nv01,nv10,nv11,ndeg,         !Seniorities 
     &e0,ninxu) 
      end if

      write(4,*) 
       write(4,*)
       write(4,774)
 774   format(6x,'mq',7x,'mg0',8x,'c1',8x,'c2',8x,'c3',8x,'c4')
       write(4,775)  mq,mg0,c1,c2,c3,c4
 775   format (6(1x,f9.6))
       write(4,*)
       write(4,*)' Groundstate energy E_0 =',e0
       write(4,*) 

c         write(4,*)' after energy; num, spin, fla, iparity:'
c         write(4,*) ij,ifla,iparity
c         write(4,*)' ee(i,spin,fla,pa):'
c         do ii1=0,1
c         do ii2=0,1
c         do ii3=smin,smax
c         do ii4=1,5
c         write(4,*) ii4,ii3,ii2,ii1,ee(ii4,ii3,ii2,ii1)
c         end do
c         end do
c         end do
c         end do

      do ij=0,maxs  !cambie smin,smax
      ipafla00(ij)=0
      ipafla01(ij)=0
      ipafla10(ij)=0
      ipafla11(ij)=0
      end do
      write(4,*)' J^P (l,m)    v00,v01,v10,v11   Energies (th and exp)'
      write(4,779)
 779  format(80('_'))
      do 300 ii=1,ndat
      ij=ijj(ii)  !spin

c      write(4,*)' in do 300, ii,ij = ',ii,ij
c      write(4,*)' ipar(ii),ifla(ii),exval(ii):'
c      write(4,*) ipar(ii),ifla(ii),exval(ii)

      if(ipar(ii).eq.0.and.ifla(ii).eq.0) then
      ipafla00(ij)=ipafla00(ij)+1
      write(4,691) ij,nv00(ipafla00(ij),ij,0,0),
     & nv01(ipafla00(ij),ij,0,0),nv10(ipafla00(ij),ij,0,0),
     &  nv11(ipafla00(ij),ij,0,0),ee(ipafla00(ij),ij,0,0),exval(ii)
 691  format(1x,i2,'^+ (0,0) ',1x,4(i4),3x,' E_th =',f7.3,2x,
     &'E_exp =',f7.3)
      endif

      if(ipar(ii).eq.0.and.ifla(ii).eq.1) then
      ipafla01(ij)=ipafla01(ij)+1
      write(4,692) ij,nv00(ipafla01(ij),ij,1,0),
     & nv01(ipafla01(ij),ij,1,0),nv10(ipafla01(ij),ij,1,0),
     &  nv11(ipafla01(ij),ij,1,0),ee(ipafla01(ij),ij,1,0),exval(ii)
 692  format(1x,i2,'^+ (1,1) ',1x,4(i4),3x,' E_th =',f7.3,2x,
     &'E_exp =',f7.3)
      endif

      if(ipar(ii).eq.1.and.ifla(ii).eq.0) then
      ipafla10(ij)=ipafla10(ij)+1
      write(4,693) ij,nv00(ipafla10(ij),ij,0,1),
     & nv01(ipafla10(ij),ij,0,1),nv10(ipafla10(ij),ij,0,1),
     &  nv11(ipafla10(ij),ij,0,1),ee(ipafla10(ij),ij,0,1),exval(ii)
 693  format(1x,i2,'^- (0,0) ',1x,4(i4),3x,' E_th =',f7.3,2x,
     &'E_exp =',f7.3)
      endif

      if(ipar(ii).eq.1.and.ifla(ii).eq.1) then
      ipafla11(ij)=ipafla11(ij)+1
      write(4,694) ij,nv00(ipafla11(ij),ij,1,1),
     & nv01(ipafla11(ij),ij,1,1),nv10(ipafla11(ij),ij,1,1),
     &  nv11(ipafla11(ij),ij,1,1),ee(ipafla11(ij),ij,1,1),exval(ii)
 694  format(1x,i2,'^- (1,1) ',1x,4(i4),3x,' E_th =',f7.3,2x,
     &'E_exp =',f7.3)
      endif


 300  continue
      write(4,448)
 448  format(80('_'))
c --------------------------------------------------
c Print information on ng0, ng2, nq, pp
c
      write(4,*)
      write(4,695)
 695  format( / /T25,'Spectrum'/1x,80('*'))

      do iparity=0,1
c      write(4,*)' ************************************'
c      write(4,*)' Parity: (0--->+, 1--->-):',iparity
c      write(4,*)
c      write(4,*)
      do ifl=0,1
c      write(4,*)' flavour: 0--->(0,0), 1--->(1,1):',ifl
c      write(4,*)
c      write(4,*)
      do ij=0,smax 
c      write(4,*)' total-spin:',ij
c      write(4,*)
c      write(4,*)' n0. of state,,P
c     &:'
       write(4,696) ij,(-1)**iparity,ifl,ifl  
 696   format( /2x,'J^P (l,m): ',i1,'^(',i2,")",1x,'(',i1,',',i1,')'/
     & 16x,  "Seniorities"/
     & " #  energy deg  00 01 10 11  <nq00>  <nq01>  <nq10>  <nq11>",
     & "  <nq>    <ng0>    P"/ 82('_'))
         do kk=1,ninxu(ij,ifl,iparity)
c      write(4,*)' energy = ',ee(kk,ij,ifl,iparity)

      xqpi= xnq00(kk,ij,ifl,iparity)+
     & xnq01(kk,ij,ifl,iparity)+
     & xnq10(kk,ij,ifl,iparity)+
     & xnq11(kk,ij,ifl,iparity)

      write(4,697) kk,ee(kk,ij,ifl,iparity),
     &ndeg(kk,ij,ifl,iparity), nv00(kk,ij,ifl,iparity),
     &nv01(kk,ij,ifl,iparity),nv10(kk,ij,ifl,iparity),
     &nv11(kk,ij,ifl,iparity),xnq00(kk,ij,ifl,iparity),
     & xnq01(kk,ij,ifl,iparity),xnq10(kk,ij,ifl,iparity),
     & xnq11(kk,ij,ifl,iparity),xqpi,
     & xng0(kk,ij,ifl,iparity),xng0(kk,ij,ifl,iparity)-xqpi 

 697  format(i2,1x,f7.3,1x,i2,1x,4(1x,i2),7(1x,f7.3))

c      write(4,601) kk,xnq00(kk,ij,ifl,iparity),
c     & xnq01(kk,ij,ifl,iparity),xnq10(kk,ij,ifl,iparity),
c     & xnq11(kk,ij,ifl,iparity),xqpi,
c     & xng0(kk,ij,ifl,iparity),xng0(kk,ij,ifl,iparity)-xqpi
         end do
     
       write(4,698)
 698   format(82('+')) 
       write(4,*)
       write(4,*)
c 601  format(1x,i2,6(1x,f14.5))
      end do
      end do
      end do

c
c *************************************************
C
c close statements
c
      CLOSE (UNIT=5,STATUS='KEEP')
      CLOSE (UNIT=6,STATUS='KEEP')
      CLOSE (UNIT=7,STATUS='KEEP')
      CLOSE (UNIT=8,STATUS='KEEP')
      CLOSE (UNIT=50,STATUS='KEEP')
C
      STOP
      END
c
c **************************************************
c subroutines
c **************************************************
c FCN
c
      subroutine fcn(npar,grad,chsq,xval,iflag)
      parameter(maxe=10, ! max number of states considered
     &          maxs=8, ! max spin
     &          maxdat=20, ! max. numb. of exp. data 
     &          lamu=20, ! max. value of lamda,mu
     &          lmax=20, !max valor de espin
     &          maxind=900) ! max. number of states N=seniority
     
      implicit real*8 (a-h,o-z)
      external energycut,energypru
      dimension grad(*),xval(*)
      real*8 mq,mg0,mqest00,mqest01,mqest10,mqest11,mg0est,etop
      integer omega
      integer smin,smax
      real*8 ee(maxe,0:maxs,0:1,0:1),xng2(maxe,0:maxs,0:1,0:1)
      real*8 xng0(maxe,0:maxs,0:1,0:1),xnq(maxe,0:maxs,0:1,0:1)
      real*8 xnq0(maxe,0:maxs,0:1,0:1),xnq1(maxe,0:maxs,0:1,0:1)
      real*8 xpp(maxe,0:maxs,0:1,0:1)
      integer ninxu(0:maxs,0:1,0:1)

      dimension ipar(maxdat),ifla(maxdat),ijj(maxdat)
      real*8 exval(maxdat),weight(maxdat)

      dimension ipafla00(0:maxs),ipafla01(0:maxs),ipafla10(0:maxs)
      dimension ipafla11(0:maxs)

C NECESARIO???
      dimension jl1(maxind,0:lamu,0:1,0:lmax),
     & jv110(maxind,0:lamu,0:1,0:lmax)
      dimension jla1(maxind,0:lamu,0:1,0:lmax)
      dimension jn000(maxind,0:lamu,0:1,0:lmax)
      dimension jv111(maxind,0:lamu,0:1,0:lmax)
      dimension jla2(maxind,0:lamu,0:1,0:lmax),
     & jmu2(maxind,0:lamu,0:1,0:lmax)
      dimension jl2(maxind,0:lamu,0:1,0:lmax)
      dimension jmultot(maxind,0:lamu,0:1,0:lmax)
      dimension jindex(0:lamu,0:1,0:lmax)
      common /dat/ndj,ndomega
      common /senior/jl1,jv110,jla1,jn000,jv111,jla2,jmu2,jl2,
     &               jmultot,jindex
      common/corte/mqest00,mqest01,mqest10,mqest11,mg0est,etop

      common /data2/mq,mg0,c1,c2,c3,c4,c5,c6,c7,c8,xc,ifit0
      common /dataex/exval,weight,ndat,ipar,ifla,ijj
      common /datain/smin,smax,ng0max,nqmax,neigw,ne0
      common/tipodecor/npcor
c      common /datmax/maxe,maxs
c
c      in=in+1
c      write(4,*)' in fcn',in, "veces"
      mq=xval(1)
      mg0=xval(2)
      c1=xval(3)
      c2=xval(4)
      c3=xval(5)
      c4=xval(6)
      c5=xval(7)
      c6=xval(8)
      c7=xval(9)
      c8=xval(10)
c
c      write(4,*)' before call energy'
c      write(4,*)' mq,mg0,mg2,c1,c2,c3,c4,c5,c6,c7,c8,c9='
c      write(4,*) mq,mg0,mg2,c1,c2,c3,c4,c5,c6,c7,c8,c9

      if (npcor.eq.0) then
          call energycut(ee,maxe,maxs,
     &xnq00,xnq01,xnq10,xnq11,xng0,! valores de expectacion
     &nv00,nv01,nv10,nv11,ndeg,         !Seniorities 
     &e0,ninxu)   
      else
          call energypru(ee,maxe,maxs,
     &xnq00,xnq01,xnq10,xnq11,xng0,! valores de expectacion
     &nv00,nv01,nv10,nv11,ndeg,         !Seniorities 
     &e0,ninxu)
      end if    
c      write(4,*)' after call energy'
c      write(4,*)' mq,mg0,mg2,c1,c2,c3,c4,c5,c6,c7,c8,c9='
c      write(4,*) mq,mg0,mg2,c1,c2,c3,c4,c5,c6,c7,c8,c9
c         write(4,*)' ee(i,spin,fla,pa):'
c         do ii1=0,1
c         do ii2=0,1
c         do ii3=0,1
c          write(4,*) "hay(s,f,p) :",ninxu(ii3,ii2,ii1)
c         do ii4=1,5
c         write(4,*) ii4,ii3,ii2,ii1,ee(ii4,ii3,ii2,ii1)
c         end do
c         end do
cc         end do
c         end do

      chsq=0.0

      do ij=0,maxs !cambie smin,smax
      ipafla00(ij)=0
      ipafla01(ij)=0
      ipafla10(ij)=0
      ipafla11(ij)=0
      end do

      do 1 ii=1,ndat
c      if(exval(ii).ne.0.) then 
      ij=ijj(ii)

      if(ipar(ii).eq.0.and.ifla(ii).eq.0) then
      ipafla00(ij)=ipafla00(ij)+1
       if (ipafla00(ij).gt. ninxu(ij,0,0)) then
          write(4,*) "not enough theoretical values"
          stop
       end if   
	if (ii.ne.1) then !in order to avoid a zero division 
      chsq=chsq +weight(ii)*(ee(ipafla00(ij),ij,0,0)-exval(ii))**2
     & /exval(ii)**2
        end if
	
c      write(4,*)' ipafla00(ij)=',ipafla00(ij)
c      write(4,*)' ij,ii,ipar(ii),ifla(ii),exval,weight,ee,chsq:'
c      write(4,*) ij,ii,ipar(ii),ifla(ii),exval(ii),weight(ii),
c     &           ee(ipafla00(ij),ij,0,0),chsq
      endif


      if(ipar(ii).eq.0.and.ifla(ii).eq.1) then
      ipafla01(ij)=ipafla01(ij)+1
       if (ipafla01(ij).gt.ninxu(ij,1,0)) then
          write(4,*) "not enough theoretical values"
          stop
       end if   
      chsq=chsq +weight(ii)*(ee(ipafla01(ij),ij,1,0)-exval(ii))**2
     & /exval(ii)**2
c      write(4,*)' ipafla01(ij)=',ipafla01(ij)
c      write(4,*)' ij,ii,ipar(ii),ifla(ii),exval,weight,ee,chsq:'
c      write(4,*) ij,ii,ipar(ii),ifla(ii),exval(ii),weight(ii),
c     &           ee(ipafla01(ij),ij,1,0),chsq
      endif

      if(ipar(ii).eq.1.and.ifla(ii).eq.0) then
      ipafla10(ij)=ipafla10(ij)+1
       if (ipafla10(ij).gt.ninxu(ij,0,1)) then
          write(4,*) "not enough theoretical values"
          stop
       end if   
      chsq=chsq +weight(ii)*(ee(ipafla10(ij),ij,0,1)-exval(ii))**2
     & /exval(ii)**2
c      write(4,*)' ipafla10(ij)=',ipafla10(ij)
c      write(4,*)' ij,ii,ipar(ii),ifla(ii),exval,weight,ee,chsq:'
c      write(4,*) ij,ii,ipar(ii),ifla(ii),exval(ii),weight(ii),
c     &           ee(ipafla10(ij),ij,0,1),chsq
      endif

      if(ipar(ii).eq.1.and.ifla(ii).eq.1) then
      ipafla11(ij)=ipafla11(ij)+1
       if (ipafla11(ij).gt.ninxu(ij,1,1)) then
          write(4,*) "not enough theoretical values"
          stop
       end if   
      chsq=chsq +weight(ii)*(ee(ipafla11(ij),ij,1,1)-exval(ii))**2
     & /exval(ii)**2
c      write(4,*)' ipafla11(ij)=',ipafla11(ij)
c      write(4,*)' ij,ii,ipar(ii),ifla(ii),exval,weight,ee,chsq:'
c      write(4,*) ij,ii,ipar(ii),ifla(ii),exval(ii),weight(ii),
c     &           ee(ipafla11(ij),ij,1,1),chsq
      endif

c      endif

 1    continue


c
c      write(4,*)' out of fcn'
c      iout=1
c      if(iout.eq.1) stop

      return
      end

