c
c In a first step,
c this program determines the SU(3) and spin content of
c a system of many bosons with flavour (1,1) and spin 1
c
c Then it takes into account all other bosons (0,0),1;
c (1,1),1 ( the (0,0),0 are excluded) and combines them
c with the bsosons (1,1),1 to a complete state, where
c seniority = number of bosons. The (0,0),0 bosons where excluded
c because seniority there is always 0. They will be included
c later on in the Hamiltonian program.
c
c written by: P.O. Hess, october 15, 2001
c
      parameter (lamu=20, ! max value of lambda, mu
     &           im=10,   ! max. number of U(8) irreps for a given N
     &           maxdim1=200, ! max. number of irreps SU(3)
     &           lmax=60,   ! max. number of spin L
     &           maxind=900, !max. number of states
     &           maxl=20,   ! max. spin allowed
     &           nm=10)   ! max. number of N

      dimension mult(0:lamu,0:lamu,0:lmax,0:nm)
      dimension hh1(im,0:nm),hh2(im,0:nm),hh3(im,0:nm)
      dimension IN(0:nm)
      INTEGER NP(3)
      dimension lambda(maxdim1),mue(maxdim1),multlamu(maxdim1)
      dimension mult110(0:lamu,0:nm)
      dimension jl1(maxind,0:lamu,0:1,0:maxl)
      dimension jv110(maxind,0:lamu,0:1,0:maxl)
      dimension jla1(maxind,0:lamu,0:1,0:maxl)
      dimension jn000(maxind,0:lamu,0:1,0:maxl)
      dimension jv111(maxind,0:lamu,0:1,0:maxl)
      dimension jla2(maxind,0:lamu,0:1,0:maxl)
      dimension jmu2(maxind,0:lamu,0:1,0:maxl)
      dimension jl2(maxind,0:lamu,0:1,0:maxl)
      dimension jmultot(maxind,0:lamu,0:1,0:maxl)
      dimension jindex(0:lamu,0:1,0:maxl)

      common /lamu/imaxsu3,lambda,mue,multlamu

c funtion to determine the multiple occurence of spin l in
c SU(3) irrep (lm,mu):
      multo3(lm,mu,ll)=max0(0,(lm+mu+2-ll)/2)-max0(0,(lm+1-ll)/2)
     &                 -max0(0,(mu+1-ll)/2)

      data mult /295911*0./
      data mult110 /231*0./
      data hh1,hh2,hh3 /330*0./
      data in /11*0./

c
c the file "u8h1h1h3.dat" contains the possible values
c for [h1,h2,h3] from total number of bosons 0 to 6
c
      open(unit=50,file='u8h1h2h3.dat')
      open(unit=60,file='nv-space.out')
      open(unit=61,file='nv-space.dat')

c
c numirrep= number of U(8) irreps, nmax = max number of bosons
c IN(k) number of U(8) irreps in each N, starting from N=0
c N= number of bosons
c hhk(i)= number of boxes in row no. k
c

      read(50,*)
      read(50,*) numirrep,nmax
      read(50,*)
      read(50,*) (IN(k),k=0,nmax)
      read(50,*)
      do nn=1,numirrep
      read(50,*) N,i,hh1(i,N),hh2(i,N),hh3(i,N) 
      end do

      write(6,*)' nmax , spinmax = ??'
      read(5,*) nmax,ispinmax

c
c initialize the multiplicity mult(la,mu, N):
c

      write(60,*)' N,  L,    lambda,      mue,       multiplicity'
      N=0
      la=0
      mu=0
      L=0
      mult(0,0,0,0)=1
      write(60,*) N,L,la,mu,mult(la,mu,l,N)

      write(60,*)' N,  L,     lambda,      mue,       multiplicity'
      N=1
      la=1
      mu=1
      L=1
      mult(1,1,1,1)=1
      write(60,*) N,L,la,mu,mult(la,mu,l,N)

c do loop over number of bosons

      do 1 N=2,nmax
c      do 1 N=2,2

        do 2 i=1,IN(N)
c
c identifying the U(8) irrep
c
        np(1)=hh1(i,N)
        np(2)=hh2(i,N)
        np(3)=hh3(i,N)

        lap=np(1)-np(2)
        mup=np(2)-np(3)
        iminl=0
        imaxl=lap+mup

c        write(60,*)' in do 2 and Do 1 (i,N):'
c        write(60,*)' n,i,np(1),np(2),np(3),lap,mup,iminl,imaxl:'
c        write(60,*) n,i,np(1),np(2),np(3),lap,mup,iminl,imaxl

c
c u8su3 determines the irreps (la,mu) and their multiplicity
c for a given number of bosons N. This program was written by
c Ramon Lopez, beginning of the 90's and by Peter O. Hess
c

      call u8su3(np)

c
c storing the multiplicities and summing them up, taking into
c account all U(8) irreps for a given N.
c
c           write(60,*)' storing the multiplicities for N:'
           do 3 ii=1,imaxsu3
           do 31 IL=iminl,imaxl
           kmax=multo3(lap,mup,IL)
           if(kmax.ne.0) then
           mult(lambda(ii),mue(ii),IL,N)=multlamu(ii)*kmax
     &                   +  mult(lambda(ii),mue(ii),IL,N)
c           write(60,*)' imaxsu3, lambda(ii),mue(ii),il,N:'
c           write(60,*) imaxsu3, lambda(ii),mue(ii),il,N
c           write(60,*)' mult(lambda,mue,IL,N),multlamu,kmax:'
c           write(60,*) mult(lambda(ii),mue(ii),IL,N),multlamu(ii),kmax
           endif
 31        continue
 3         continue

 2      continue

c
c subtracting for a given N all irreps apearing at lower N, with
c steps in 2. The result obtained are all irreps (la,mu) which
c are contained in the state with seniority = N
c Thius was done the same for the lower N ---> recursive procedure.
c
c           write(60,*)' substracting results for N=nold-2, etc.:'
           do 4 nold=N-2,0,-2
           do 41 laold=0,2*N
           do 42 mueold=0,2*N
           do 43 ilold=0,4*N
           if(mult(laold,mueold,ilold,N).ne.0) then
           mult(laold,mueold,ilold,N)=mult(laold,mueold,ilold,N)-
     &                          mult(laold,mueold,ilold,nold)
c           write(60,*)' laold,mueold,ilold,nold,N:'
c           write(60,*) laold,mueold,ilold,nold,N
c           write(60,*)' mult(laold,mueold,ilold,nold):'
c           write(60,*) mult(laold,mueold,ilold,nold)
c           write(60,*)' mult(laold,mueold,ilold,N):'
c           write(60,*) mult(laold,mueold,ilold,N)
           endif
 43        continue
 42        continue
 41        continue
 4         continue

c
c printout of data
c
      write(60,*)' N,  L,     lambda,      mue,       multiplicity'
      do 11 la=0,2*N
      do 12 mu=0,2*N
      do 13 il=0,4*N
      if(mult(la,mu,il,N).ne.0) then
      write(60,*) N,il,la,mu,mult(la,mu,il,N)
      endif
 13   continue
 12   continue
 11   continue
c
 1    continue
c
c ***********************************************************
c determining the content of the (1,1)0 boson part:
c The states with seniority equal to number of bosons, are
c given by (3 bosons coupled to (0,0))**n3 *
c          (2 bosons coupled to (1,1))**n2 *
c          (1 boson  with       (1,1))**n1 |0>
c

          write(60,*)' la1,        v1,        mult110(la1,v1):'


      do 5 iv1=0,nmax
      do 6 la1=0,iv1
c      write(60,*)' la1,iv1=',la1,iv1

          ind=0
          do 61 n1=0,nmax
          do 62 n2=0,nmax/2
          do 63 n3=0,nmax/3
          las=n1+n2
          iv1s=3*n3+2*n2+n1
c          write(60,*)' n1,n2,n3,las,iv1s=',n1,n2,n3,las,iv1s
          if(las.eq.la1.and.iv1s.eq.iv1) then
          ind=ind+1
c          write(60,*)' ind=',ind
          endif
 63       continue
 62       continue
 61       continue
           
          mult110(la1,iv1)=ind
          if(ind.ne.0) then
          write(60,*) la1,iv1,mult110(la1,iv1)
          endif

 6        continue
 5        continue

c
c ***********************************************************
c constructing the total state (not including the (0,0),0 bosons:
c L0 = total spin of the system
c iparity = parity of the system
c la0 = total flavour irrep = (la0,la0)=(0,0) or (1,1) only,
c       higher irreps are not considered, for the moment
c
c notation: sequence of numbers refer to: la mu spin of the boson
c           iv = seniority
c  


      do 70 L0=0,ispinmax

      do 71 iparity=0,1

      do 72 la0=0,1

      index=0

c inner do loops, needed to construct states with a given
c L0, iparity and (la0,la0)
c L1 = iv001 !

            do 79 n000=0,1
            do 80 L1=0,nmax

            do 81 iv110=0,nmax
            do 82 la1=0,nmax
            if(mult110(la1,iv110).ne.0) then

               do 83 iv111=0,nmax
               iv=n000+L1+iv110+iv111
               xx=iv/2.-iv/2
               ipcheck=0
               if(xx.gt.0.2) ipcheck=1
               if(iv.le.nmax.and.ipcheck.eq.iparity) then
               do 84 la2=0,2*iv111
               do 85 mu2=0,2*iv111
               do 86 l2=0,4*iv111
                  if(mult(la2,mu2,l2,iv111).ne.0) then
                  multot=mult110(la1,iv110)*mult(la2,mu2,l2,iv111)
                  ismin=l1-l2
                  if(ismin.lt.0) ismin=-ismin
                  ismax=l1+l2
                    if(ismin.le.L0.and.ismax.ge.L0) then
                    iromax=multu3(la1,la1,la2,mu2,la0,la0)
                    if(iromax.ne.0) then
                    multot=multot*iromax
      index=index+1
      jn000(index,la0,iparity,L0)=n000
      jl1(index,la0,iparity,L0)=l1
      jv110(index,la0,iparity,L0)=iv110
      jla1(index,la0,iparity,L0)=la1
      jv111(index,la0,iparity,L0)=iv111
      jla2(index,la0,iparity,L0)=la2
      jmu2(index,la0,iparity,L0)=mu2
      jl2(index,la0,iparity,L0)=l2
      jmultot(index,la0,iparity,L0)=multot

                    endif
                    endif
                  endif

 86            continue
 85            continue
 84            continue

               endif

 83            continue

            endif

 82         continue
 81         continue
 80         continue
 79         continue

         jindex(la0,iparity,L0)=index

 72      continue
 71      continue
 70      continue

c
c print out of final results:
c
      write(61,*)  nmax,ispinmax   
      do 90 L0=0,ispinmax

      do 91 iparity=0,1

      do 92 la0=0,1
      write(60,*)
      write(60,*)
      write(60,*)' spin    parity (0=+, 1=-)       la0 : '
      write(60,*) L0, iparity, la0
      write(60,*)
      inmax=jindex(la0,iparity,L0)
      write(60,*)' inmax = ',inmax
      write(61,*) inmax,la0,iparity,l0
            write(60,*)' n000,l1,iv110,la1,iv111,la2,mu2,l2,mult:'
            do 93 index=1,inmax
            n000=jn000(index,la0,iparity,L0)
            l1=jl1(index,la0,iparity,L0)
            iv110=jv110(index,la0,iparity,L0)
            la1=jla1(index,la0,iparity,L0)
            iv111=jv111(index,la0,iparity,L0)
            la2=jla2(index,la0,iparity,L0)
            mu2=jmu2(index,la0,iparity,L0)
            l2=jl2(index,la0,iparity,L0)
            multot=jmultot(index,la0,iparity,L0)
            write(60,*) n000,l1,iv110,la1,iv111,la2,mu2,l2,multot
            write(61,*) n000,l1,iv110,la1,iv111,la2,mu2,l2,multot
 93         continue
 92         continue
 91         continue
 90         continue

c
c close statements
c
      close(unit=50,status='keep')
      close(unit=60,status='keep')
      close(unit=61,status='keep')

      stop
      end
c
c *********************************************************
c SUBROUTINES
c *********************************************************
c U8SU3
c
      subroutine u8su3(np)
      PARAMETER (MXREP=30000)                                          
      INTEGER NP(3),IRREP(MXREP,2)
c      data irrep /60000*0./
      CALL SU8SU3(NP,IRREP,MXREP,NREP)
      RETURN
      END                                                               EF 00100
C                                                                       EF 00110
      SUBROUTINE SU8SU3(NP,IRREP,MXREP,NREP)                            EF 00120
C --- REDUCTION FROM SU(8) TO SU(3) FOR THREE ROWED IRREPS -------------EF 00130
      DIMENSION LABEL(2),NP(3),IRREP(MXREP,2)                           EF 00140
      PARAMETER (MXREP1=30000,
     &           maxdim1=200) !put in by P.O.Hess (cpoh)
C     UP TO 30000 IRREPS CAN BE STORED IN TREE                          EF 00160
      DIMENSION IBTREE(-9:6*MXREP1)                                     EF 00170
cpoh
      dimension lambda(maxdim1),mue(maxdim1),multlamu(maxdim1)
cpoh
      INTEGER MP(3),LP(8),NSUBST(3,6)                                   EF 00180
      IC2SU3(LM,MU)=LM*LM+LM*MU+MU*MU+3*LM+3*MU                         EF 00190
      IDIM(LM,MU)=(LM+1)*(MU+1)*(LM+MU+2)/2                             EF 00200
cpoh
      common /lamu/imaxsu3,lambda,mue,multlamu
cpoh
      DATA NSUBST/0,0,0,+1,-1,0,+2,-1,-1,0,+1,-1,+1,+1,-2,+2,0,-2/      EF 00210
      DATA IBIT16/Z'FFFF'/
C                                                                       EF 00230
      CALL TSET(IBTREE,30000,2,1)                                       EF 00240
      NODES=0                                                           EF 00250
      DO 110 I=1,6                                                      EF 00260
         DO 120 J=1,3                                                   EF 00270
            MP(J)=NP(J)+NSUBST(J,I)                                     EF 00280
  120       IF(MP(J).LT.0) GO TO 110                                    EF 00290
         CALL PRDSU8(MP,IRREP,MXREP,NREP)                               EF 00300
C        INSERTION IN TREE (CAN BE ADDITION OR SUBSTRACTION)            EF 00310
         DO 130 NCON=1,NREP                                             EF 00320
            LMU=IRREP(NCON,1)                                           EF 00330
            MULT=IRREP(NCON,2)                                          EF 00340
            LM=ISHFT(LMU,-16)                                           EF 00350
            MU=IAND(LMU,IBIT16)                                         EF 00360
            LABEL(1)=IC2SU3(LM,MU)                                      EF 00370
            LABEL(2)=LMU                                                EF 00380
            CALL TREE(1,LABEL,IBTREE,*140,*980)                         EF 00390
            NODES=NODES+1                                               EF 00400
  140       ILOC=IBTREE(-5)+3                                           EF 00410
C           FOR I ODD SUBSTRACTION AND FOR I EVEN ADDITION              EF 00420
            IF(BTEST(I,0))THEN                                          EF 00430
               IBTREE(ILOC)=IBTREE(ILOC)+MULT                           EF 00440
             ELSE                                                       EF 00450
               IBTREE(ILOC)=IBTREE(ILOC)-MULT                           EF 00460
            END IF                                                      EF 00470
  130       CONTINUE                                                    EF 00480
  110    CONTINUE                                                       EF 00490
C     STORING DECOMPOSITION FOR {NP1,NP2,NP3} IN OUTPUT ARRAY           EF 00500
c      WRITE(16,7100) (NP(I),I=1,3)                                      EF 00510
c      WRITE(16,7200)                                                    EF 00520
      NDIM=0                                                            EF 00530
      NREP=0                                                            EF 00540
cpoh
      iii=0
cpoh
      DO 150 NCON=1,NODES                                               EF 00550
         CALL TOUT(0,0,NCON,NCON,0,IBTREE)                              EF 00560
         ILOC=IBTREE(-5)+1                                              EF 00570
         MULT=IBTREE(ILOC+2)                                            EF 00580
         IF(MULT.EQ.0) GO TO 150                                        EF 00590
         NREP=NREP+1                                                    EF 00600
         ICSMIR=IBTREE(ILOC)                                            EF 00610
         LMU=IBTREE(ILOC+1)                                             EF 00620
         IRREP(NCON,1)=LMU                                              EF 00630
         IRREP(NCON,2)=MULT                                             EF 00640
         LM=ISHFT(LMU,-16)                                              EF 00650
         MU=IAND(LMU,IBIT16)                                            EF 00660
         LMDIM=IDIM(LM,MU)                                              EF 00670
         NDIM=NDIM+MULT*LMDIM                                           EF 00680
cpoh         WRITE(16,7300) ICSMIR,LM,MU,MULT,LMDIM                         EF 00690
         iii=iii+1
         lambda(iii)=lm
         mue(iii)=mu
         multlamu(iii)=mult
cpoh
  150    CONTINUE
cpoh
         imaxsu3=iii
cpoh
C     DIMENSIONAL CHECK                                                 EF 00710
      DO 210 I=1,3                                                      EF 00720
  210    LP(I)=NP(I)                                                    EF 00730
      DO 220 I=4,8                                                      EF 00740
  220    LP(I)=0                                                        EF 00750
      MDIM=IDIMUN(LP,8)                                                 EF 00760
      IF(NDIM.NE.MDIM)THEN                                              EF 00770
         WRITE(16,7500) NDIM,MDIM                                       EF 00780
       ELSE                                                             EF 00790
         WRITE(16,7600) NDIM                                            EF 00800
      END IF                                                            EF 00810
      RETURN                                                            EF 00820
  980 WRITE(6,7400)                                                     EF 00830
      STOP                                                              EF 00840
 7100 FORMAT(' ','DECOMPOSITION FOR {',I4,',',I4,',',I4,'}',/)          EF 00850
 7200 FORMAT(' ',/T9,'CASIMIR',T26,'LM',T41,'MU',T54,'MULT / DIM'/)     EF 00860
 7300 FORMAT(' ',T3,I10,T18,I10,T33,I10,T49,I10,2X,I7)                  EF 00870
 7400 FORMAT(' ','OVERFLOW IN BINARY TREE')                             EF 00880
 7500 FORMAT(' ','DIMENSIONAL CHECK FAILS: ',I20,' NOT EQUAL TO',I20)   EF 00890
 7600 FORMAT(' ','DIMENSIONAL CHECK FINE: DIMENSION EQUAL TO',I20)      EF 00900
      END                                                               EF 00910
C                                                                       EF 00920
      SUBROUTINE PRDSU8(NP,IRREP,MXREP,NREP)                            EF 00930
C---- DECOMPOSING {NP1} {NP2} {NP3} IN CHAIN SU(8) --> SU(3) -----------EF 00940
      DIMENSION NP(3),IRREP(MXREP,2)                                    EF 00950
      PARAMETER (MXREP1=30000)                                          EF 00960
C     UP TO 30000 IRREPS CAN BE STORED IN TREE                          EF 00970
      DIMENSION IBTREE(-9:6*MXREP1)                                     EF 00980
      INTEGER IRREP1(MXREP1,2),IRREP2(MXREP1,2)                         EF 00990
      IDIM(LM,MU)=(LM+1)*(MU+1)*(LM+MU+2)/2                             EF 01000
      DATA IBIT16/Z'FFFF'/
C     STORING DECOMPOSITION OF SU(8) IRREP {NP1} IN TREE                EF 01020
      CALL SU8SYMM(NP(1),NODES,IBTREE)                                  EF 01030
C     STORING DECOMPOSITION FOR {NP1} IN ARRAY IRREP1                   EF 01040
      NREP1=0                                                           EF 01050
      DO 210 NCON=1,NODES                                               EF 01060
         CALL TOUT(0,0,NCON,NCON,0,IBTREE)                              EF 01070
         ILOC=IBTREE(-5)+1                                              EF 01080
         MULT=IBTREE(ILOC+2)                                            EF 01090
         IF(MULT.EQ.0) GO TO 210                                        EF 01100
         NREP1=NREP1+1                                                  EF 01110
         LMU=IBTREE(ILOC+1)                                             EF 01120
         IRREP1(NREP1,1)=LMU                                            EF 01130
         IRREP1(NREP1,2)=MULT                                           EF 01140
  210    CONTINUE                                                       EF 01150
C     STORING DECOMPOSITION OF SU(8) IRREP {NP2} IN TREE                EF 01160
      CALL SU8SYMM(NP(2),NODES,IBTREE)                                  EF 01170
C     STORING DECOMPOSITION FOR {NP2} IN ARRAY IRREP2                   EF 01180
      NREP2=0                                                           EF 01190
      DO 310 NCON=1,NODES                                               EF 01200
         CALL TOUT(0,0,NCON,NCON,0,IBTREE)                              EF 01210
         ILOC=IBTREE(-5)+1                                              EF 01220
         MULT=IBTREE(ILOC+2)                                            EF 01230
         IF(MULT.EQ.0) GO TO 310                                        EF 01240
         NREP2=NREP2+1                                                  EF 01250
         LMU=IBTREE(ILOC+1)                                             EF 01260
         IRREP2(NREP2,1)=LMU                                            EF 01270
         IRREP2(NREP2,2)=MULT                                           EF 01280
  310    CONTINUE                                                       EF 01290
C     STORING DECOMPOSITION FOR {NP1} {NP2} IN TREE                     EF 01300
      CALL TSET(IBTREE,30000,2,1)                                       EF 01310
      NODES=0                                                           EF 01320
      DO 410 NCON1=1,NREP1                                              EF 01330
         MULT1=IRREP1(NCON1,2)                                          EF 01340
         LMU=IRREP1(NCON1,1)                                            EF 01350
         LM1=ISHFT(LMU,-16)                                             EF 01360
         MU1=IAND(LMU,IBIT16)                                           EF 01370
         DO 420 NCON2=1,NREP2                                           EF 01380
            MULT2=IRREP2(NCON2,2)                                       EF 01390
            LMU=IRREP2(NCON2,1)                                         EF 01400
            LM2=ISHFT(LMU,-16)                                          EF 01410
            MU2=IAND(LMU,IBIT16)                                        EF 01420
            MULT=MULT1*MULT2                                            EF 01430
            CALL PRDSU3(LM1,MU1,LM2,MU2,MULT,NODES,IBTREE,+1)           EF 01440
  420       CONTINUE                                                    EF 01450
  410    CONTINUE                                                       EF 01460
C     STORING DECOMPOSITION FOR {NP1} {NP2} IN ARRAY IRREP1             EF 01470
      NREP1=NODES                                                       EF 01480
      DO 510 NCON=1,NODES                                               EF 01490
         CALL TOUT(0,0,NCON,NCON,0,IBTREE)                              EF 01500
         ILOC=IBTREE(-5)+1                                              EF 01510
         LMU=IBTREE(ILOC+1)                                             EF 01520
         MULT=IBTREE(ILOC+2)                                            EF 01530
         IRREP1(NCON,1)=LMU                                             EF 01540
         IRREP1(NCON,2)=MULT                                            EF 01550
  510    CONTINUE                                                       EF 01560
C     STORING DECOMPOSITION OF SU(8) IRREP {NP3} IN TREE                EF 01570
      CALL SU8SYMM(NP(3),NODES,IBTREE)                                  EF 01580
C     STORING DECOMPOSITION FOR {NP3} IN ARRAY IRREP2                   EF 01590
      NREP2=0                                                           EF 01600
      DO 610 NCON=1,NODES                                               EF 01610
         CALL TOUT(0,0,NCON,NCON,0,IBTREE)                              EF 01620
         ILOC=IBTREE(-5)+1                                              EF 01630
         MULT=IBTREE(ILOC+2)                                            EF 01640
         IF(MULT.EQ.0) GO TO 610                                        EF 01650
         NREP2=NREP2+1                                                  EF 01660
         LMU=IBTREE(ILOC+1)                                             EF 01670
         IRREP2(NREP2,1)=LMU                                            EF 01680
         IRREP2(NREP2,2)=MULT                                           EF 01690
  610    CONTINUE                                                       EF 01700
C     STORING DECOMPOSITION FOR ({NP1} {NP2}) {NP3} IN TREE             EF 01710
      CALL TSET(IBTREE,30000,2,1)                                       EF 01720
      NODES=0                                                           EF 01730
      DO 710 NCON1=1,NREP1                                              EF 01740
         MULT1=IRREP1(NCON1,2)                                          EF 01750
         LMU=IRREP1(NCON1,1)                                            EF 01760
         LM1=ISHFT(LMU,-16)                                             EF 01770
         MU1=IAND(LMU,IBIT16)                                           EF 01780
         DO 720 NCON2=1,NREP2                                           EF 01790
            MULT2=IRREP2(NCON2,2)                                       EF 01800
            LMU=IRREP2(NCON2,1)                                         EF 01810
            LM2=ISHFT(LMU,-16)                                          EF 01820
            MU2=IAND(LMU,IBIT16)                                        EF 01830
            MULT=MULT1*MULT2                                            EF 01840
            CALL PRDSU3(LM1,MU1,LM2,MU2,MULT,NODES,IBTREE,+1)           EF 01850
  720       CONTINUE                                                    EF 01860
  710    CONTINUE                                                       EF 01870
C     STORING DECOMPOSITION FOR ({NP1} {NP2}) {NP3} IN OUTPUT ARRAY     EF 01880
      NREP=NODES                                                        EF 01890
      DO 810 NCON=1,NREP                                                EF 01900
         CALL TOUT(0,0,NCON,NCON,0,IBTREE)                              EF 01910
         ILOC=IBTREE(-5)+1                                              EF 01920
         LMU=IBTREE(ILOC+1)                                             EF 01930
         MULT=IBTREE(ILOC+2)                                            EF 01940
         IRREP(NCON,1)=LMU                                              EF 01950
         IRREP(NCON,2)=MULT                                             EF 01960
  810    CONTINUE                                                       EF 01970
      IF(NREP.GT.MXREP) WRITE(6,*) ' OVERFLOW IN ARRAY IRREP'           EF 01980
      RETURN                                                            EF 01990
      END                                                               EF 02000
C                                                                       EF 02010
      SUBROUTINE SU8SYMM(NP,NODES,IBTREE)                               EF 02020
C---- DECOMPOSITION FOR TOTALLY SYMMETRIC IRREPS SU(8) GOING TO SU(3) --EF 02030
      INTEGER F1,F2,F3                                                  EF 02040
      DIMENSION IBTREE(-9:*)                                            EF 02050
      IDIM(LM,MU)=(LM+1)*(MU+1)*(LM+MU+2)/2                             EF 02060
      DATA IBIT16/Z'FFFF'/
C     INITIALING TREE                                                   EF 02080
      CALL TSET(IBTREE,30000,2,1)                                       EF 02090
      NODES=0                                                           EF 02100
C     CALCULATING PARTITIONS IN THREE NUMBERS (FIRST SUM)               EF 02110
      F1=NP                                                             EF 02120
  110 F2=MIN0(F1,NP-F1)                                                 EF 02130
  120 F3=NP-F1-F2                                                       EF 02140
      IF(F3.LE.F2)THEN                                                  EF 02150
         LM1=F1-F2                                                      EF 02160
         MU1=F2-F3                                                      EF 02170
C        STORING PRODUCT OF SU(3) IRREPS IN TREE                        EF 02180
         CALL PRDSU3(LM1,MU1,MU1,LM1,1,NODES,IBTREE,+1)                 EF 02190
      END IF                                                            EF 02200
      F2=F2-1                                                           EF 02210
      IF(F2.GE.0) GO TO 120                                             EF 02220
      F1=F1-1                                                           EF 02230
      IF(F1.GE.0) GO TO 110                                             EF 02240
C     CALCULATING PARTITIONS IN THREE NUMBERS (SECOND SUM)              EF 02250
      NPM1=NP-1                                                         EF 02260
      F1=NPM1                                                           EF 02270
  210 F2=MIN0(F1,NPM1-F1)                                               EF 02280
  220 F3=NPM1-F1-F2                                                     EF 02290
      IF(F3.LE.F2)THEN                                                  EF 02300
         LM1=F1-F2                                                      EF 02310
         MU1=F2-F3                                                      EF 02320
C        SUBSTRACTING PRODUCT OF SU(3) IRREPS IN TREE                   EF 02330
         CALL PRDSU3(LM1,MU1,MU1,LM1,1,NODES,IBTREE,-1)                 EF 02340
      END IF                                                            EF 02350
      F2=F2-1                                                           EF 02360
      IF(F2.GE.0) GO TO 220                                             EF 02370
      F1=F1-1                                                           EF 02380
      IF(F1.GE.0) GO TO 210                                             EF 02390
      RETURN                                                            EF 02400
 7100 FORMAT(' ',/T5,'CASIMIR',T19,'LM',T31,'MU',T43,'MULT / DIM'/)     EF 02410
 7200 FORMAT(' ',T3,I7,T15,I6,T27,I6,T40,I4,2X,I7)                      EF 02420
      END                                                               EF 02430
C                                                                       EF 02440
      SUBROUTINE PRDSU3(LM1,MU1,LM2,MU2,MULT,NODES,IBTREE,IOP)          EF 02450
C---- THE CLEBSCH-GORDAN SERIES FOR SU(3) ------------------------------EF 02460
C     (S. COLEMAN: JOUR. MATH. PHYS. 5 (1964), 1343-1344)               EF 02470
      INTEGER LABEL(2)                                                  EF 02480
      DIMENSION IBTREE(-9:*)                                            EF 02490
      IC2SU3(LM,MU)=LM*LM+LM*MU+MU*MU+3*LM+3*MU                         EF 02500
      IDIM(LM,MU)=(LM+1)*(MU+1)*(LM+MU+2)/2                             EF 02510
C                                                                       EF 02520
      NCON1=0                                                           EF 02530
      IPMAX=MIN0(LM1,MU2)                                               EF 02540
      IQMAX=MIN0(MU1,LM2)                                               EF 02550
      LMAUX1=LM1+LM2                                                    EF 02560
      MUAUX1=MU1+MU2                                                    EF 02570
      DO 110 IP=0,IPMAX                                                 EF 02580
         LMAUX2=LMAUX1                                                  EF 02590
         MUAUX2=MUAUX1                                                  EF 02600
         DO 120 IQ=0,IQMAX                                              EF 02610
C           LOWER INDICES +1, UPPER INDICES -2                          EF 02620
            IRMAX=MIN0(LM1-IP,LM2-IQ)                                   EF 02630
            LM=LMAUX2                                                   EF 02640
            MU=MUAUX2                                                   EF 02650
            DO 130 IR=0,IRMAX                                           EF 02660
               LABEL(1)=IC2SU3(LM,MU)                                   EF 02670
               LABEL(2)=IOR(ISHFT(LM,16),MU)                            EF 02680
               CALL TREE(1,LABEL,IBTREE,*140,*980)                      EF 02690
               NODES=NODES+1                                            EF 02700
  140          ILOC=IBTREE(-5)+3                                        EF 02710
               IF(IOP.EQ.+1)THEN                                        EF 02720
                  IBTREE(ILOC)=IBTREE(ILOC)+MULT                        EF 02730
                ELSEIF(IOP.EQ.-1)THEN                                   EF 02740
                  IBTREE(ILOC)=IBTREE(ILOC)-MULT                        EF 02750
               END IF                                                   EF 02760
               NCON1=NCON1+IDIM(LM,MU)                                  EF 02770
               LM=LM-2                                                  EF 02780
  130          MU=MU+1                                                  EF 02790
C           LOWER INDICES -2, UPPER INDICES +1                          EF 02800
            IRMAX=MIN0(MU1-IQ,MU2-IP)                                   EF 02810
            LM=LMAUX2+1                                                 EF 02820
            MU=MUAUX2-2                                                 EF 02830
            DO 150 IR=1,IRMAX                                           EF 02840
               LABEL(1)=IC2SU3(LM,MU)                                   EF 02850
               LABEL(2)=IOR(ISHFT(LM,16),MU)                            EF 02860
               CALL TREE(1,LABEL,IBTREE,*160,*980)                      EF 02870
               NODES=NODES+1                                            EF 02880
  160          ILOC=IBTREE(-5)+3                                        EF 02890
               IF(IOP.EQ.+1)THEN                                        EF 02900
                  IBTREE(ILOC)=IBTREE(ILOC)+MULT                        EF 02910
                ELSEIF(IOP.EQ.-1)THEN                                   EF 02920
                  IBTREE(ILOC)=IBTREE(ILOC)-MULT                        EF 02930
               END IF                                                   EF 02940
               NCON1=NCON1+IDIM(LM,MU)                                  EF 02950
               LM=LM+1                                                  EF 02960
  150          MU=MU-2                                                  EF 02970
            LMAUX2=LMAUX2-1                                             EF 02980
  120       MUAUX2=MUAUX2-1                                             EF 02990
         LMAUX1=LMAUX1-1                                                EF 03000
  110    MUAUX1=MUAUX1-1                                                EF 03010
C     DIMENSIONAL CHECK                                                 EF 03020
      NCON2=IDIM(LM1,MU1)*IDIM(LM2,MU2)                                 EF 03030
      IF(NCON1.NE.NCON2) WRITE(6,7300) NCON1,NCON2                      EF 03040
      RETURN                                                            EF 03050
  980 WRITE(6,7200)                                                     EF 03060
      RETURN                                                            EF 03070
 7100 FORMAT(4(10X,I10))                                                EF 03080
 7200 FORMAT(' ','OVERFLOW IN BINARY TREE')                             EF 03090
 7300 FORMAT(' ','DIMENSIONAL CHECK FAILS:',I7,' NOT EQUAL TO ',I7)     EF 03100
      END                                                               EF 03110
C                                                                       EF 03120
      FUNCTION IDIMUN(IH,N)                                             EF 03130
C---- DIMENSION OF AN U(N) IRREP LABELLED WITH IH(1),...,IH(N)          EF 03140
C     (M. HAMERMESH: GROUP THEORY AND ITS APPLICATION TO PHYSICAL       EF 03150
C                    PROBLEMS; ADDISON-WESLEY, 1962. CHAPTER 10)        EF 03160
C                                                                       EF 03170
      DIMENSION IH(N)                                                   EF 03180
      REAL*8 DIM                                                        EF 03190
C                                                                       EF 03200
      DIM=0.D0                                                          EF 03210
      DO 110 I=1,N                                                      EF 03220
         IM1=I-1                                                        EF 03230
         DO 110 J=1,IM1                                                 EF 03240
  110       DIM=DIM+DLOG(DFLOAT(IH(J)-J-IH(I)+I))-DLOG(DFLOAT(I-J))     EF 03250
      IDIMUN=IDNINT(DEXP(DIM))                                          EF 03260
      RETURN                                                            EF 03270
      END                                                               EF 03280
      SUBROUTINE TSET(ID,MAXITM,NKEY,NDAT)                              BBT00010
C --- INITIALING TREE --------------------------------------------------BBT00020
      INTEGER ID(-9:*)                                                  BBT00030
C     Fix all the tree parameters                                       BBT00040
      NSUM=NKEY+NDAT                                                    BBT00050
      ID(-9)=MAXITM                                                     BBT00060
      ID(-8)=NKEY                                                       BBT00070
      ID(-7)=NDAT                                                       BBT00080
      ID(-6)=NSUM                                                       BBT00090
      ID(-5)=-1                                                         BBT00100
      ID(-4)=NSUM+1                                                     BBT00110
      ID(-3)=NSUM+2                                                     BBT00120
      ID(-2)=NSUM+3                                                     BBT00130
      ID(-1)=0                                                          BBT00140
      ID(0)=-1                                                          BBT00150
C     Initialize all node elements                                      BBT00160
      NSUM=MAXITM*ID(-2)                                                BBT00170
      DO 100 N=1,NSUM                                                   BBT00180
 100     ID(N)=0                                                        BBT00190
      RETURN                                                            BBT00200
      END                                                               BBT00210
C                                                                       BBT00220
      SUBROUTINE TREE(NOADD,NEW,ID,*,*,*)                               BBT00230
C --- INSERTING DATA IN TREE -------------------------------------------BBT00240
      INTEGER NEW(*),ID(-9:*)                                           BBT00250
      NKEY=ID(-8)                                                       BBT00260
      NLC=ID(-4)                                                        BBT00270
      NRC=ID(-3)                                                        BBT00280
      NBF=ID(-2)                                                        BBT00290
C     Special case (empty tree)                                         BBT00300
      IF (ID(0).EQ.-1) THEN                                             BBT00310
C     Check for new node suppression                                    BBT00320
         IF (NOADD.EQ.0) GOTO 150                                       BBT00330
         INY=ID(-1)                                                     BBT00340
         ID(-1)=ID(-1)+1                                                BBT00350
         ID(0)=INY                                                      BBT00360
         NPOS=NBF*ID(0)                                                 BBT00370
C     Fix position of the first node                                    BBT00380
         ID(-5)=NPOS                                                    BBT00390
         ID(NPOS+NBF)=0                                                 BBT00400
         ID(NPOS+NRC)=-1                                                BBT00410
         ID(NPOS+NLC)=-1                                                BBT00420
C     Load the key of the first node                                    BBT00430
         DO 100 I=1,NKEY                                                BBT00440
  100       ID(NPOS+I)=NEW(I)                                           BBT00450
         GOTO 999                                                       BBT00460
      ENDIF                                                             BBT00470
C     Normal case (non-empty tree)                                      BBT00480
      INF=-1                                                            BBT00490
      INA=ID(0)                                                         BBT00500
      INP=ID(0)                                                         BBT00510
      INQ=-1                                                            BBT00520
  110 IF (INP.NE.-1) THEN                                               BBT00530
         NPOS=NBF*INP                                                   BBT00540
         IF (ID(NPOS+NBF).NE.0) THEN                                    BBT00550
            INA=INP                                                     BBT00560
            INF=INQ                                                     BBT00570
         ENDIF                                                          BBT00580
         DO 120 I=1,NKEY                                                BBT00590
            IF (NEW(I)-ID(NPOS+I)) 130,120,140                          BBT00600
  120    CONTINUE                                                       BBT00610
C     If a match is found, set pointer and RETURN 1                     BBT00620
         ID(-5)=NPOS                                                    BBT00630
         RETURN 1                                                       BBT00640
  130    INQ=INP                                                        BBT00650
         INP=ID(NPOS+NLC)                                               BBT00660
         GOTO 110                                                       BBT00670
  140    INQ=INP                                                        BBT00680
         INP=ID(NPOS+NRC)                                               BBT00690
         GOTO 110                                                       BBT00700
      ENDIF                                                             BBT00710
C     If a new node is not to be added to tree, RETURN 3                BBT00720
  150 IF (NOADD.EQ.0) RETURN 3                                          BBT00730
C     If adding a node generates an overflow condition, RETURN 2        BBT00740
      IF (ID(-1).GE.ID(-9)) RETURN 2                                    BBT00750
      INY=ID(-1)                                                        BBT00760
      ID(-1)=ID(-1)+1                                                   BBT00770
      NPOS=NBF*INY                                                      BBT00780
C     Set the pointer to the position of the new node and load the key  BBT00790
      ID(-5)=NPOS                                                       BBT00800
      DO 160 I=1,NKEY                                                   BBT00810
  160    ID(NPOS+I)=NEW(I)                                              BBT00820
      ID(NPOS+NLC)=-1                                                   BBT00830
      ID(NPOS+NRC)=-1                                                   BBT00840
      ID(NPOS+NBF)=0                                                    BBT00850
      NPOS=NBF*INQ                                                      BBT00860
      DO 170 I=1,NKEY                                                   BBT00870
         IF (NEW(I)-ID(NPOS+I)) 180,170,190                             BBT00880
  170 CONTINUE                                                          BBT00890
      GOTO 999                                                          BBT00900
  180    ID(NPOS+NLC)=INY                                               BBT00910
      GOTO 200                                                          BBT00920
  190    ID(NPOS+NRC)=INY                                               BBT00930
  200 NPOSA=NBF*INA                                                     BBT00940
      DO 210 I=1,NKEY                                                   BBT00950
         IF(NEW(I)-ID(NPOSA+I)) 220,210,230                             BBT00960
  210 CONTINUE                                                          BBT00970
      GOTO 999                                                          BBT00980
  220 INP=ID(NPOSA+NLC)                                                 BBT00990
      INB=INP                                                           BBT01000
      IND=1                                                             BBT01010
      GOTO 240                                                          BBT01020
  230 INP=ID(NPOSA+NRC)                                                 BBT01030
      INB=INP                                                           BBT01040
      IND=-1                                                            BBT01050
  240 IF (INP.NE.INY) THEN                                              BBT01060
         NPOS=NBF*INP                                                   BBT01070
         DO 250 I=1,NKEY                                                BBT01080
            IF(NEW(I)-ID(NPOS+I)) 260,250,270                           BBT01090
  250    CONTINUE                                                       BBT01100
         GOTO 999                                                       BBT01110
  260    ID(NPOS+NBF)=1                                                 BBT01120
         INP=ID(NPOS+NLC)                                               BBT01130
         GOTO 240                                                       BBT01140
  270    ID(NPOS+NBF)=-1                                                BBT01150
         INP=ID(NPOS+NRC)                                               BBT01160
         GOTO 240                                                       BBT01170
      ENDIF                                                             BBT01180
      IF (ID(NPOSA+NBF).EQ.0) THEN                                      BBT01190
         ID(NPOSA+NBF)=IND                                              BBT01200
         GOTO 999                                                       BBT01210
      ENDIF                                                             BBT01220
      IF ((ID(NPOSA+NBF)+IND).EQ.0) THEN                                BBT01230
         ID(NPOSA+NBF)=0                                                BBT01240
         GOTO 999                                                       BBT01250
      ENDIF                                                             BBT01260
      NPOSB=NBF*INB                                                     BBT01270
      IF (IND.EQ.1) THEN                                                BBT01280
         IF (ID(NPOSB+NBF).EQ.1) THEN                                   BBT01290
            ID(NPOSA+NLC)=ID(NPOSB+NRC)                                 BBT01300
            ID(NPOSB+NRC)=INA                                           BBT01310
            ID(NPOSA+NBF)=0                                             BBT01320
            ID(NPOSB+NBF)=0                                             BBT01330
         ELSE                                                           BBT01340
            INC=ID(NPOSB+NRC)                                           BBT01350
            NPOSC=NBF*INC                                               BBT01360
            ID(NPOSB+NRC)=ID(NPOSC+NLC)                                 BBT01370
            ID(NPOSA+NLC)=ID(NPOSC+NRC)                                 BBT01380
            ID(NPOSC+NLC)=INB                                           BBT01390
            ID(NPOSC+NRC)=INA                                           BBT01400
            IF (ID(NPOSC+NBF).EQ.1) THEN                                BBT01410
               ID(NPOSA+NBF)=-1                                         BBT01420
               ID(NPOSB+NBF)=0                                          BBT01430
            ELSEIF (ID(NPOSC+NBF).EQ.-1) THEN                           BBT01440
               ID(NPOSB+NBF)=1                                          BBT01450
               ID(NPOSA+NBF)=0                                          BBT01460
            ELSE                                                        BBT01470
               ID(NPOSB+NBF)=0                                          BBT01480
               ID(NPOSA+NBF)=0                                          BBT01490
            ENDIF                                                       BBT01500
            ID(NPOSC+NBF)=0                                             BBT01510
            INB=INC                                                     BBT01520
         ENDIF                                                          BBT01530
      ELSE                                                              BBT01540
         IF (ID(NPOSB+NBF).EQ.-1) THEN                                  BBT01550
            ID(NPOSA+NRC)=ID(NPOSB+NLC)                                 BBT01560
            ID(NPOSB+NLC)=INA                                           BBT01570
            ID(NPOSA+NBF)=0                                             BBT01580
            ID(NPOSB+NBF)=0                                             BBT01590
         ELSE                                                           BBT01600
            INC=ID(NPOSB+NLC)                                           BBT01610
            NPOSC=NBF*INC                                               BBT01620
            ID(NPOSB+NLC)=ID(NPOSC+NRC)                                 BBT01630
            ID(NPOSA+NRC)=ID(NPOSC+NLC)                                 BBT01640
            ID(NPOSC+NRC)=INB                                           BBT01650
            ID(NPOSC+NLC)=INA                                           BBT01660
            IF (ID(NPOSC+NBF).EQ.-1) THEN                               BBT01670
               ID(NPOSA+NBF)=1                                          BBT01680
               ID(NPOSB+NBF)=0                                          BBT01690
            ELSEIF (ID(NPOSC+NBF).EQ.1) THEN                            BBT01700
               ID(NPOSB+NBF)=-1                                         BBT01710
               ID(NPOSA+NBF)=0                                          BBT01720
            ELSE                                                        BBT01730
               ID(NPOSB+NBF)=0                                          BBT01740
               ID(NPOSA+NBF)=0                                          BBT01750
            ENDIF                                                       BBT01760
            ID(NPOSC+NBF)=0                                             BBT01770
            INB=INC                                                     BBT01780
         ENDIF                                                          BBT01790
      ENDIF                                                             BBT01800
      NPOS=NBF*INF                                                      BBT01810
      IF (INF.EQ.-1) THEN                                               BBT01820
         ID(0)=INB                                                      BBT01830
      ELSEIF (INA.EQ.ID(NPOS+NLC)) THEN                                 BBT01840
         ID(NPOS+NLC)=INB                                               BBT01850
      ELSEIF (INA.EQ.ID(NPOS+NRC)) THEN                                 BBT01860
         ID(NPOS+NRC)=INB                                               BBT01870
      ENDIF                                                             BBT01880
  999 RETURN                                                            BBT01890
      END                                                               BBT01900
C                                                                       BBT01910
      SUBROUTINE TOUT(NFILE,NAD,MIN,MAX,NSTEP,ID)                       BBT01920
C --- RECOVERING DATA STORED IN TREE -----------------------------------BBT01930
      INTEGER ID(-9:*),STACK(32)                                        BBT01940
      I=0                                                               BBT01950
      M=0                                                               BBT01960
      NUM=MIN                                                           BBT01970
      NODE=ID(0)                                                        BBT01980
  100 IF (NAD.EQ.1) THEN                                                BBT01990
         N1=-4                                                          BBT02000
         N2=-3                                                          BBT02010
      ELSE                                                              BBT02020
         N1=-3                                                          BBT02030
         N2=-4                                                          BBT02040
      ENDIF                                                             BBT02050
  200 IF (NODE.NE.-1) THEN                                              BBT02060
         I=I+1                                                          BBT02070
         STACK(I)=NODE                                                  BBT02080
         NPOS=ID(-2)*NODE                                               BBT02090
         NODE=ID(NPOS+ID(N1))                                           BBT02100
         GOTO 200                                                       BBT02110
  300    M=M+1                                                          BBT02120
         NPOS=ID(-2)*NODE                                               BBT02130
         ID(-5)=NPOS                                                    BBT02140
         IF (M.EQ.NUM.OR.M.EQ.MAX) THEN                                 BBT02150
            IF (NFILE.GT.0) WRITE(NFILE,1000)M,(ID(NPOS+II),II=1,ID(-6))BBT02160
            IF (M.EQ.MAX) GOTO 999                                      BBT02170
            NUM=NUM+NSTEP                                               BBT02180
         ENDIF                                                          BBT02190
  400    NODE=ID(NPOS+ID(N2))                                           BBT02200
         GOTO 200                                                       BBT02210
      ENDIF                                                             BBT02220
      IF (I.NE.0) THEN                                                  BBT02230
         NODE=STACK(I)                                                  BBT02240
         I=I-1                                                          BBT02250
         GOTO 300                                                       BBT02260
      ENDIF                                                             BBT02270
      WRITE(NFILE,*)' WARNING:  SEARCH IS OUT OF BOUNDS!'               BBT02280
  999 RETURN                                                            BBT02290
 1000 FORMAT(1X,I6,2X,14I5/(9X,14I5))                                   BBT02300
      END                                                               BBT02310

c
c ************************************************************
c multiplicity function for the product:
c (LX1,MX1) X (LX2,MX2) ---> (LX3,MX3)
c
      FUNCTION MULTU3(LX1,MX1,LX2,MX2,LX3,MX3)
C     ------------------------------------------------------------------
C     MULTIPLICITY IN U3 COUPLING (SEE MULTTEST FOR VARIOUS VERSIONS)
C     ... FASTER THAN THE DRAAYER ORIGINAL AND THE MILLENER KAS FUNCTION
C     ------------------------------------------------------------------
C     UPDATE/MOD: (LSU,11-78)  J.P.DRAAYER        ORIGINAL VERSION
C                 (BNL,06-87)  J.MILLENER         MILLENER VERSION
C                 (LSU,10-89)  J.P.DRAAYER        PROFILER OPTIMIZED
C     ------------------------------------------------------------------
      MULTU3=0
      NX=LX1+LX2-LX3-MX1-MX2+MX3
      MX=NX/3
      IF(3*MX.NE.NX)RETURN
      IF(MX.GE.0)THEN
         L1=LX1
         L2=LX2
         L3=LX3
         M1=MX1
         M2=MX2
         M3=MX3
      ELSE
         L1=MX1
         L2=MX2
         L3=MX3
         M1=LX1
         M2=LX2
         M3=LX3
         MX=-MX
      ENDIF
      NX=MX+M1+M2-M3
      MU=MIN0(L1-MX,M2)
      IF(MU.LT.0)RETURN
      NU=MIN0(L2-MX,M1)
      IF(NU.LT.0)RETURN
      MULTU3=MAX0(MIN0(NX,NU)-MAX0(NX-MU,0)+1,0)
      RETURN
      END
