      program ztot0fla
c*********************************************************************
c  Programa que usa energy para escribir en archivo eigenfla.out
c  el espectro del Hamiltoniano bosonico para toda J
c  Esa programa incluye el sabor hasta lamax (ver ztot.in) 
c
c  Autor          : Sergio Lerma
c
c  necesita       : enernewcutfla.o
c                   givens.o
c                   nv-allfla.dat
c  Eingabefile    : ztot.in
c  Ausgabefile    : eigenfla.out
c
c********************************************************************
      implicit real*8 (A-H,O-Z)
      REAL*8  MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8,xc
      real*8  mqest00,mqest01,mqest10,mqest11,mg0est,etop  !CORTE
      integer smin,smax,ng0max,nqmax,ndomega,ndj,ifit0,maxe,neigw
      integer ne0
      
c  programa principal lee parametros y varibales de entrada
      common /dat/ ndj,ndomega
      common /data2/mq,mg0,c1,c2,c3,c4,c5,c6,c7,c8,xc,ifit0
      common /datain/smin,smax,ng0max,nqmax,neigw,ne0
      common /corte/ mqest00,mqest01,mqest10,mqest11,mg0est,etop

      open(unit=1,file="ztot.in")
      open(unit=3,file="ztot0fla.out")
      open(unit=2,file="eigenfla.out")
      open(unit=10,file="expecfla.out")
      OPEN (UNIT=50,FILE='nv-allfla.dat')
      read(1,*)
      read(1,*) MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8
      read(1,*)
      read(1,*) mqest00,mqest01,mqest10,mqest11,mg0est,etop
      read(1,*)
      read(1,*) smin,smax,ng0max,nqmax,ndomega,lamax
      read(1,*)
      read(1,*) xc,ifit0
      read(1,*)
      read(1,*) neigw
   
      write(3,*) "MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8"
      write(3,*) MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8
      write(3,*) "mqest00,mqest01,mqest10,mqest11,mg0est,etop"
      write(3,*) mqest00,mqest01,mqest10,mqest11,mg0est,etop
      write(3,*) "smin,smax,ng0max,nqmax,ndomega"
      write(3,*) smin,smax,ng0max,nqmax,ndomega
      write(3,*) " xc,ifit0"
      write(3,*) xc,ifit0
      write(3,*) "neigw"
      write(3,*) neigw 
       maxe=neigw
       maxs=smax
 
      call ztotc (maxe,maxs,lamax)

      stop
      end 
c*****************SUBRUTINA PRINCIPAL*****************************
      subroutine ztotc(maxe,maxs,lamax)

      implicit real*8 (A-H,O-Z)
      REAL*8  MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8,xc
      real*8  mqest00,mqest01,mqest10,mqest11,mg0est,etop  !CORTE
      integer smin,smax,ng0max,nqmax,ndomega,ndj,ifit0,nmax,lam,mum
c      parameter(lamax=4)
      parameter(!maxe=10, !Numero de eigenvalores  
     &         ! maxs=8, ! max spin
     &          lmax=18,
     &          la=18, ! max. value of lamda
     &          mu=18,    ! max. value of mu 
     &          maxind=100) ! max. number of states N=seniority
c----eigenvalues for  each  spin,flavour and parity values.        
      real*8  ee(maxe,0:maxs,0:lamax,0:lamax,0:1),e0
c      real*8  eig(maxe,0:maxs,0:1,0:1,0:ndomega),eig0(0:ndomega)


c-----expectacion values of number of gluons and quarks  
      real*8  xnq00(maxe,0:maxs,0:lamax,0:lamax,0:1),nq00
      real*8   xnq01(maxe,0:maxs,0:lamax,0:lamax,0:1),nq01
      real*8  xnq10(maxe,0:maxs,0:lamax,0:lamax,0:1),nq10
      real*8  xnq11(maxe,0:maxs,0:lamax,0:lamax,0:1) ,nq11
      real*8    xng0(maxe,0:maxs,0:lamax,0:lamax,0:1),ng0  
c---- Seniorities of ee(...) states ----------
      integer nv00(maxe,0:maxs,0:lamax,0:lamax,0:1)
     & ,nv01(maxe,0:maxs,0:lamax,0:lamax,0:1)
     &,nv10(maxe,0:maxs,0:lamax,0:lamax,0:1)
     &,nv11(maxe,0:maxs,0:lamax,0:lamax,0:1)
     &,ndeg(maxe,0:maxs,0:lamax,0:lamax,0:1) 
c--number of eigenvalues of each J^p(lam,nu) sector (maxe or J^psector
c-- matrix size)
      integer ninxu(0:maxs,0:lamax,0:lamax,0:1)     
c--seniorities 
      dimension jl1(maxind,0:la,0:mu,0:1,0:lmax)
      dimension jv110(maxind,0:la,0:mu,0:1,0:lmax)
      dimension jla1(maxind,0:la,0:mu,0:1,0:lmax)
      dimension jn000(maxind,0:la,0:mu,0:1,0:lmax)
      dimension jv111(maxind,0:la,0:mu,0:1,0:lmax)
      dimension jla2(maxind,0:la,0:mu,0:1,0:lmax)
      dimension jmu1(maxind,0:la,0:mu,0:1,0:lmax)
      dimension jmu2(maxind,0:la,0:mu,0:1,0:lmax)
      dimension jl2(maxind,0:la,0:mu,0:1,0:lmax)
      dimension jmultot(maxind,0:la,0:mu,0:1,0:lmax)
      dimension jindex(0:la,0:mu,0:1,0:lmax)
     
      common /dat/ndj,ndomega
      common /data2/mq,mg0,c1,c2,c3,c4,c5,c6,c7,c8,xc,ifit0
      common /senior/jl1,jv110,jla1,jn000,jv111,jla2,jmu1,jmu2,jl2,
     &               jmultot,jindex     ! Senorities pasan aqui
      common /datain/smin,smax,ng0max,nqmax,neigw,ne0
      common /corte/ mqest00,mqest01,mqest10,mqest11,mg0est,etop

c      nmax=2    ! Achtung ist Eingabewert von nv-allfla.f 
      
      read(50,*) nmax,ispinmax
      if (ispinmax.lt.smax) then
         write(*,*) "spin from nv-allfla is less than smax."
         write(*,*) "run nv-allfla.exe again with spin greater"
         write(*,*) " or equal than", smax
         stop
      end if   
c
c read indices for the q-part: no. of pairs=seniority
c
      ne0=0
      do 90 L0=0,smax 

      do 91 iparity=0,1

      do 92 la0=0,2*nmax
      do 93 mu0=0,2*nmax
      read(50,*) inmax,lam,mum,mpar,lsp
      write(*,*) inmax," ",lam,mum,mpar,lsp," ",la0,mu0,iparity,L0
         jindex(la0,mu0,iparity,l0)=inmax
            do 94 index=1,inmax
c            read(50,*) n000,l1,iv110,la1,iv111,la2,mu1,mu2,l2,multot
            read(50,*) n000,l1,iv110,iv111,la1,mu1,la2,mu2,l2,multot

            jn000(index,la0,mu0,iparity,L0)=n000
            jl1(index,la0,mu0,iparity,L0)=l1
            jv110(index,la0,mu0,iparity,L0)=iv110
            jv111(index,la0,mu0,iparity,L0)=iv111
            jla1(index,la0,mu0,iparity,L0)=la1
            jmu1(index,la0,mu0,iparity,L0)=mu1
            jla2(index,la0,mu0,iparity,L0)=la2
            jmu2(index,la0,mu0,iparity,L0)=mu2
            jl2(index,la0,mu0,iparity,L0)=l2
            jmultot(index,la0,mu0,iparity,L0)=multot

 94    continue
 93    continue
 92    continue
 91    continue
 90    continue
       write(*,*) "2*om= ",ndomega



      do ndj=ndomega,0,-1
         write(*,*) "Calculando 2*j= ", ndj  
         call energy(ee,neigw,smax,lamax,
     &    xnq00,xnq01,xnq10,xnq11,xng0,! valores de expectacion
     &    nv00,nv01,nv10,nv11,ndeg,    !Seniorities de los edos ee(...)  
     &    e0,ninxu)  
         if (ndj.eq.ndomega) write(2,*) e0
         
         do npar=0,1
            do nmu0=0,lamax!2*nmax
            do nla0=0,lamax!  2*nmax   
               do nl=0,smax
                  nlim=ninxu(nl,nla0,nmu0,npar)
                write(2,*)ndj,nl,nla0,nmu0,npar,nlim !2J,spin,lambda,paridad,nueig
                if (ifit0.eq.0) then
                  write(10,*)ndj,nl,nla0,nmu0,npar,nlim !2J,spin,lambda,paridad,nueig   
 1              end if  
                 do nc=1,ninxu(nl,nla0,nmu0,npar)
        write(2,*) ee(nc,nl,nla0,nmu0,npar),ndeg(nc,nl,nla0,nmu0,npar)
        if (ifit0.eq.0) then           
         write(10,*) xnq00(nc,nl,nla0,nmu0,npar)+
     &               xnq01(nc,nl,nla0,nmu0,npar)+
     &         xnq10(nc,nl,nla0,nmu0,npar)+xnq11(nc,nl,nla0,nmu0,npar),
     &               xng0(nc,nl,nla0,nmu0,npar)
        end if     
                 end do  
                end do 
            end do
         end do   
         end do
      end do   
      
      return
      end

      












