      program ztotprobfla
c*******************************************************************
c Programa que usa eigenfla.out (eigenvalores para todo pseudoespin 
c y para sabor hasta lamax) para calcular la linea de transicion 
c para un dado presin de bag (ver linea 105) del Hamiltoniano 
c bosonico mientras se fija estranjeza (local) en 0.
c
c Eingabefile        : ztot.in
c necesita           : eigenfla.out
c                      u6s.o
c Ausgabefile        : mut1fla.out
c
c*******************************************************************
      implicit real*8 (A-H,O-Z)
      REAL*8  MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8,xc
      real*8  mqest00,mqest01,mqest10,mqest11,mg0est,etop  !CORTE
      real*8  y,I,iz,numbar,bagpr,radel
      real*8  glum(38)
      integer muglu(38)
      integer mtest,ntest,ktest
      integer smin,smax,ng0max,nqmax,ndomega,ndj,ifit0,maxe
    
c      programa principal lee parametros y varibales de entrada
      common /dat/ ndj,ndomega,ndjef,nfer
      common /data2/mq,mg0,c1,c2,c3,c4,c5,c6,c7,c8,xc,ifit0
      common /datain/smin,smax,ng0max,nqmax,neigw,ne0,lamax
      common /corte/ mqest00,mqest01,mqest10,mqest11,mg0est,etop
      common /temp/tmin,tmax,tdel
      common /mu/vbmin,vbmax,vbdel
      common /mum/vB,vS,vIz,numBar
      common /vsp/vsmin,vsmax,vsdel,bagpr,radel
      common /glue/glum,muglu,mtest,ntest,ktest
      open(unit=1,file="ztot.in")
      open(unit=9,file="gluespek.in")
c      open(unit=3,file="ztot1.out")
c      open(unit=10,file="ztot.out")
      open(unit=11,file="mut1fla.out")
      open(unit=2,file="eigenfla.out")

c      open(unit=13,file="tontfla.out")
    
      read(1,*)
      read(1,*) MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8
      read(1,*)
      read(1,*) mqest00,mqest01,mqest10,mqest11,mg0est,etop
      read(1,*)
      read(1,*) smin,smax,ng0max,nqmax,ndomega,lamax
      read(1,*)
      read(1,*) xc,ifit0
      read(1,*)
      read(1,*) neigw
      read(1,*) 
      read(1,*) tmin,tmax,tdel
      read(1,*) 
      read(1,*) vbmin,vbmax,vbdel
      read(1,*)
      read(1,*) tnix1,tnix2,tnix3
      read(1,*)
      read(1,*) vsmin,vsmax,vsdel
      read(1,*) 
      read(1,*) ntest
      read(1,*)
      read(1,*) mtest    
      read(1,*)
      read(1,*) ktest  
      read(1,*)
      read(1,*) unfug
      read(1,*) 
      read(1,*) bagpr,radel


      write(3,*) "MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8"
      write(3,*) MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8
      write(3,*) "mqest00,mqest01,mqest10,mqest11,mg0est,etop"
      write(3,*) mqest00,mqest01,mqest10,mqest11,mg0est,etop
      write(3,*) "smin,smax,ng0max,nqmax,ndomega"
      write(3,*) smin,smax,ng0max,nqmax,ndomega
      write(3,*) " xc,ifit0"
      write(3,*) xc,ifit0
      write(3,*) "neigw"
      write(3,*) neigw 
      call principal 
      stop
      end 

      subroutine principal
      implicit real*8 (A-H,O-Z)
      REAL*8  MQ,MG0,C1,C2,C3,C4,C5,C6,C7,C8,xc,dmea,dmeb,dme
      real*8  mqest00,mqest01,mqest10,mqest11,mg0est,etop  !CORTE
      integer smin,smax,ng0max,nqmax,ndomega,ndj,ifit0,maxe,dimu6
      integer h(12),mtest,ntest,ktest
      real*8  glum(38),bagpr,radel
      integer muglu(38)
      real*8 numbar,strange(2)
c      parameter(lamax=4)
      dimension  etj(neigw,0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      integer ndtj(neigw,0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      dimension numeig(0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      dimension zz(0:ndomega),vez(0:ndomega),veez(0:ndomega)
      dimension zzs(0:ndomega),vib(0:ndomega),vyb(0:ndomega)
      parameter(maxr=60)
      integer hu2a1(maxr),hu2a2(maxr), hu3a1(maxr),hu3a2(maxr)
     &       ,hu3a3(maxr)
      integer mult1(maxr),nra
      integer hu2b1(maxr),hu2b2(maxr), hu3b1(maxr),hu3b2(maxr)
     &        ,hu3b3(maxr)
      integer mult2(maxr),nrb
      integer ha(5),hb(5),lamb(maxr,0:3,0:3,0:3,0:3,0:3)
      integer mub(maxr,0:3,0:3,0:3,0:3,0:3)
      integer nds(maxr,0:3,0:3,0:3,0:3,0:3),ir(0:3,0:3,0:3,0:3,0:3)
      integer mult(maxr,0:3,0:3,0:3,0:3,0:3),h1,h2,h3,h4,h5
      

      common /dat/ ndj,ndomega,ndjef,nfer
      common /data2/mq,mg0,c1,c2,c3,c4,c5,c6,c7,c8,xc,ifit0
      common /datain/smin,smax,ng0max,nqmax,neigw,ne0,lamax
      common /corte/ mqest00,mqest01,mqest10,mqest11,mg0est,etop
      common /temp/tmin,tmax,tdel
      common /mu/vbmin,vbmax,vbdel
      common /mum/vB,vS,vIz,numBar
      common /vsp/vsmin,vsmax,vsdel,bagpr,radel
      common /glue/glum,muglu,mtest,ntest,ktest
c************!!!!!!!!!!!
c                p_B        radius       4*Pi/3
      enerbag=(bagpr)**4*  (radel*5)**3*   4.18879   
c!!!!!!!!!!!!!!!!!!!!!!!!
c LEER DATOS DEL GLUE-ESPECTRUM
         read(9,*) 
         read(9,*) glum
         read(9,*) muglu
c LEER DATOS DE eigenfla.out
      read(2,*) evac
      write(*,*) evac
      do ndj=ndomega,0,-1
        do npar=0,1
          do nmu0=0,lamax
          do nla0=0,lamax
            do nl=0,smax
             read(2,*) ndjd,nld,nlad,nmud,npard,nlimd !2J,spin,lambda,par,nueig
             write(*,*) ndjd,nld,nlad,nmud,npard,nlimd,"  ",
     & ndj,nl,nla0,nmu0,npar,nlimd
             if (ndj.ne.ndjd) write(*,*)"error reading 1"
             if (npar.ne. npard) write(*,*) "error reading eigenvalues2"
             if (nla0.ne.nlad) write(*,*) "error reading eigenvalues 3"
             if (nl.ne.nld) write(*,*) "error reading eigenvalues 4" 
             if(nmud.ne.nmu0)  write(*,*) "error reading eigenvalues 5" 
             numeig(nl,nla0,nmu0,npar,ndj)=nlimd
              do nco=1,nlimd
                  read(2,*) ev,ndeg
                  etj(nco,nl,nla0,nmu0,npar,ndj)=ev
                  ndtj(nco,nl,nla0,nmu0,npar,ndj)=ndeg
              end do
            end do
          end do
          end do
        end do 
      end do
c      write(*,*) etj(15,0,0,0,18)
c      write(*,*) numeig(0,0,0,0)

      do h1=0,3
      do h2=0,h1
      do h3=0,h2
      do h4=0,h3
      do h5=0,h4
     
      call  U6s(h1,h2,h3,h4,h5,0,
     &           hu2a1,hu2a2,    ! SU(2)
     &           hu3a1,hu3a2,hu3a3, !SU(3)
     &           mult1,             ! multiplicidad
     &           nra,maxr)          !maxima dimension de los campos               
       ir(h1,h2,h3,h4,h5)=nra
        do nq=1,nra
         lamb(nq,h1,h2,h3,h4,h5)=hu3a1(nq)-hu3a2(nq)
         mub(nq,h1,h2,h3,h4,h5)=hu3a2(nq)-hu3a3(nq)
         nds(nq,h1,h2,h3,h4,h5)=hu2a1(nq)-hu2a2(nq)
         mult(nq,h1,h2,h3,h4,h5)=mult1(nq)
        end do
      end do   
      end do
      end do
      end do
      end do

      write(*,*) "REDUCCIONES FINALIZADAS"
      if (tdel.eq.0.0) then 
         tmax=tmin+1.0
         tdel=2.0
      end if
      if (vbdel.eq.0.0) then 
         vbmax=vbmin+1.0
         vbdel=2.0
      end if
c DO LOOP DE TEMPERATURA Y MU

      Do t=tmin,tmax,tdel
           write(*,*) t
c ---------- Glueballspektrum ----------------------------
         zgb=1.0
         if (mtest.eq.1) then
           do nsum=1,38
         zgb=zgb*(1.0/(1.0-exp(-glum(nsum)/t)))**(2.0*muglu(nsum)+1.0)
           end do
c           write(*,*) zgb
         end if
c----------------------------------------------------------------
        Do vb=vbmin,vbmax,vbdel
         vst=vsmin+(vsmax-vsmin)/2.0
         vsmaxt=vsmax
         vsmint=vsmin
         itmin=1
         itmax=2
       
        do itg=1,15

          do it=itmin,itmax
             
           if (it.eq.1) then 
              vstr=vsmint
           end if
           if (it.eq.2) then 
              vstr=vst
           end if   

c_________________INICIA CALCULO DE FUNCIONES-
            do nel=ndomega,0,-1
             call part (zj,vid,vyd,ve,vee,t,nel,etj,ndtj,ktest
     &          ,numeig,neigw,smax,ndomega,vb,vstr,viz,lamax,zgb)

             zz(nel)=zj
             vib(nel)=vid           
             vyb(nel)=vyd
             vez(nel)=ve
             veez(nel)=vee
            end do 
         Z=0.0
         vbar=0.0
         vy1=0.0
         vy2=0.0
         vybo=0.0
         vi1=0.0
         vi2=0.0
         vibo=0.0
         vexe=0.0
         vexec=0.0
         vexn=0.0
         vcolor=0.0
         vexndt=0.0
         vexns=0.0
         vexg=0.0 
c         combinatoria (analogo a Kuriyama-Suma) 

*************************************************************
         do nh1t=0,12
         do nh2t=0,nh1t
         do nh3t=0,nh2t 

c Asignar h(1),...,h(12) para un dado h1~,...,h3~
           do k1=1,nh3t
                  h(k1)=3
           end do
           do k2=nh3t+1,nh2t
                  h(k2)=2
           end do
           do k3=nh2t+1,nh1t
                  h(k3)=1
           end do
           do k4=nh1t+1,12
                  h(k4)=0
           end do
c-------------------------------------------------------------
         ndjef=h(1)+h(2)+h(3)+h(4)+h(5)+h(6)
     &       -( h(7)+h(8)+ h(9)+h(10)+h(11)+h(12) ) 
 
         nfer=h(1)+h(2)+h(3)+h(4)+h(5)+h(6)
     &       +( h(7)+h(8)+ h(9)+h(10)+h(11)+h(12) ) 

         numBar=(nfer-ndomega)/3.0 !omega cancela 

          ha(1)=h(1)-h(6)
          ha(2)=h(2)-h(6)
          ha(3)=h(3)-h(6)
          ha(4)=h(4)-h(6)
          ha(5)=h(5)-h(6)


          hb(1)=h(7)-h(12)
          hb(2)=h(8)-h(12)
          hb(3)=h(9)-h(12)
          hb(4)=h(10)-h(12)
          hb(5)=h(11)-h(12)
c****DIMENSION U(6) DEL EDO DE MINIMO PESO
          dmealt=dimu6(h(1),h(2),h(3),h(4),h(5),h(6))*
     &     dimu6(h(7),h(8),h(9),h(10),h(11),h(12))
cLO SIGUIENTE SUSTITUYE LAS 2 LINEAS PREVIAS. 
c---------- antiquarks
      dmea=0.0
      zy1=0.0
      zi1=0.0
      do l=1,ir(ha(1),ha(2),ha(3),ha(4),ha(5))  ! nrb 
         lam=lamb(l,ha(1),ha(2),ha(3),ha(4),ha(5))!(hu3a1(l)-hu3a2(l))
         mu=mub(l,ha(1),ha(2),ha(3),ha(4),ha(5))!(hu3a2(l)-hu3a3(l))
         dmeao=0.0
         zi1o=0.0
         zy1o=0.0  
         do np=0,lam              ! Sabor         
            do nq=0,mu            ! Sabor
               da=0.0
               zya=0.0             
               zia=0.0
               Y= -(2.0*lam+mu-3.0*(np+nq))/3.0
               tI=(mu+np-nq)/2.0                    
             do tiz=-tI,tI           ! Sabor
              da=da+exp((vIz*tIz)/t)
              zia=zia+tiz*exp((vIz*tIz)/t)
             end do               ! Sabor
             dmeao=dmeao+da*exp(vstr*Y/t)    !  Z
             zi1o=zi1o+zia*exp(vstr*Y/t)     !  <I_z>
             zy1o=zy1o+da*Y*exp(vstr*Y/t)    !  <Y>   
            end do                ! Sabor
         end do                   ! Sabor
  
        dmea=dmea+dmeao*(nds(l,ha(1),ha(2),ha(3),ha(4),ha(5))+1)
     &    *mult(l,ha(1),ha(2),ha(3),ha(4),ha(5))  !(hu2a1(l)-hu2a2(l)+1)   ! Spin       
        zi1=zi1+zi1o*(nds(l,ha(1),ha(2),ha(3),ha(4),ha(5))+1)
     &    *mult(l,ha(1),ha(2),ha(3),ha(4),ha(5))  !(hu2a1(l)-hu2a2(l)+1)   ! Spin       
        zy1=zy1+zy1o*(nds(l,ha(1),ha(2),ha(3),ha(4),ha(5))+1)
     &    *mult(l,ha(1),ha(2),ha(3),ha(4),ha(5))  !(hu2a1(l)-hu2a2(l)+1)   ! Spin       
      end do                                      ! nrb
C------------ quarks

      dmeb=0.0
      zy2=0.0
      zi2=0.0
      do l=1,ir(hb(1),hb(2),hb(3),hb(4),hb(5))  !nrb
 
         lam=lamb(l,hb(1),hb(2),hb(3),hb(4),hb(5))!(hu3b1(l)-hu3b2(l))
         mu=mub(l,hb(1),hb(2),hb(3),hb(4),hb(5))!(hu3b2(l)-hu3b3(l))
         dmebo=0.0
         zi2o=0.0
         zy2o=0.0
         do np=0,lam
            do nq=0,mu
               db=0.0
               zyb=0.0             
               zib=0.0
               Y= -(2.0*lam+mu-3.0*(np+nq))/3.0
               tI=(mu+np-nq)/2.0                           
             do tiz=-tI,tI
              db=db+exp((vIz*tIz)/t)
              zib=zib+tiz*exp((vIz*tIz)/t)
             end do              

              dmebo=dmebo+db*exp(vstr*Y/t)    !  Z
              zi2o=zi2o+zib*exp(vstr*Y/t)     !  <I_z>
              zy2o=zy2o+db*Y*exp(vstr*Y/t)    !  <Y>
            end do
         end do   
         
        dmeb=dmeb+dmebo*(nds(l,hb(1),hb(2),hb(3),hb(4),hb(5))+1)
     &    *mult(l,hb(1),hb(2),hb(3),hb(4),hb(5)) !(hu2b1(l)-hu2b2(l)+1)   ! Spin  
        zi2=zi2+zi2o*(nds(l,hb(1),hb(2),hb(3),hb(4),hb(5))+1)
     &    *mult(l,hb(1),hb(2),hb(3),hb(4),hb(5))! (hu2b1(l)-hu2b2(l)+1)   ! Spin       
        zy2=zy2+zy2o*(nds(l,hb(1),hb(2),hb(3),hb(4),hb(5))+1)
     &    *mult(l,hb(1),hb(2),hb(3),hb(4),hb(5))!(hu2b1(l)-hu2b2(l)+1)   ! Spin       
      end do   
 
c----------------
      dme=dmea*dmeb
      zi1=zi1*dmeb
      zi2=dmea*zi2
      zy1=zy1*dmeb
      zy2=dmea*zy2
c*************************************************


c****DIMENSION DE COLOR
           du3=0.5*(nh1t-nh2t+1)*(nh2t-nh3t+1)*(nh1t-nh3t+2)  
c****POTENCIAL QUIMICO
           fmu=exp((vB-vstr)*numBar/t)  !exp(-v*ndomega/t)

                vcolor=vcolor+( (nh1t-nh2t)**2+(nh1t-nh2t)*(nh2t-nh3t)
     &          +(nh2t-nh3t)**2+3*(nh1t-nh3t) )*du3*dme*zz(ndjef)*fmu  
                Z    =    Z+du3*dme*fmu*zz(ndjef)
                vbar = vbar+du3*dme*fmu*zz(ndjef)*numbar  
                vY1  =  vY1+du3*zy1*fmu*zz(ndjef)
                vy2  =  vy2+du3*zy2*fmu*zz(ndjef)
                vybo = vybo+du3*dme*fmu*vyb(ndjef)
c                vi1  = vi1 +du3*zi1*fmu*zz(ndjef)
c                vi2  = vi2 +du3*zi2*fmu*zz(ndjef)
c                vibo = vibo+du3*dme*fmu*vib(ndjef)
                vexe = vexe+du3*dme*fmu*vez(ndjef)
c                vexec=vexec+du3*dme*fmu*veez(ndjef)  
         end do   ! h3t
         end do   ! h2t
         end do   ! h1t  
            
C TEMP,MU,<E>, C         

         pressurev=T*Log(Z)
         energia=VEXE/Z + 1.0*etj(1,0,0,0,0,18)  
c         calor=(1.0/T**2)*(VEXEC/Z-(VEXE/Z)**2)
         barion=vbar/Z
         thyp=(vy1+vy2+vybo)/Z
c         tIsoz=(vi1+vi2+vibo)/Z
         strange(it)=thyp-barion
         strang=thyp-barion 
c         carga=tisoz+thyp/2
c         color=   vcolor/Z
c Checando si de milagro o al inicio le dimos...
         if( abs(strange(it)) .lt. 10.0**(-13.0) ) then
            vst=vstr
            go to 342
         end if   
c___
            
        end do       ! it
 
           if (strange(1)*strange(2).gt.0) then          
             vsmint=vst
             dvst=(vsmaxt-vsmint)/2.0
             vst=vsmint+dvst
             strange(1)=strange(2)
             itmin=2
             itmax=2
          else
             vsmaxt=vst
             dvst=(vsmint-vsmaxt)/2.0
             vst=vsmaxt+dvst
             itmin=2  
             itmin=2   
           end if
         
          end do       ! itg

 342      continue         

         if (vb.eq.vbmin) then
            gmin=abs(pressurev-Enerbag)!!abs(energia-Enerbag)
            vbsol=vb
            vssol=vst

         else
cc          if(abs(energia-Enerbag).lt.gmin) then
          if (abs(pressurev-Enerbag).lt.gmin) then 
           gmin=abs(pressurev-Enerbag)!!abs(energia -Enerbag)
           vbsol=vb
           vssol=vst
          end if
         end if
        END DO !(potencial quimico) 

        volt=5.0**3*(200.0/(vbar/Z))  
        write(13,*)
        write(13,*)        
c                      1    2     3     4     5      6      7      8
c       if (energia.eq.energia)
c     & WRITE(10,234) T,energia,tisoz,thyp,barion,carga,color,strang
        WRITE(11,*) T,vbsol,vssol!,vbar/Z,volt

      END DO  !(temperatura)
 234  format (7(1x,f9.6),1x,f18.16)
 300  return
      end

c---------------------------------------------------------------------
  

      subroutine part(zj,vib,vyb,vee,veec,t,ndj,etj,ndtj,ktest,
     &                numeig,neigw,smax,ndomega,vb,vs,viz,lamax,zgb)
      implicit real*8(a-H,O-Z)
      integer smax
c      parameter(lamax=4)
      dimension  etj(neigw,0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      integer ndtj(neigw,0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      dimension numeig(0:smax,0:lamax,0:lamax,0:1,0:ndomega)
      
      zj=0.0
      vee=0.0
      veec=0.0
      vib=0.0
      vyb=0.0

      deltmp=-0.238
      tetap=-23.7*2*3.1415/360.0
      hachtp=0.15

      deltmv=-0.0833
      tetav=0.61548
      hachtv=-0.0565685

    
      do npar=0,1        ! Paridad
        do nla=0,lamax       ! Sabor lamabda
           do nmu=0,lamax    !Sabor mu
          lam=nla
          mu=nmu
          vfi=0.0
          vfy=0.0
          ffl=0.0
          do np=0,lam    ! Sabor p 
            do nq=0,mu   ! Sabor q
               d=0.0                            
               vi=0.0
               Y=-(2.0*lam+mu-3.0*(np+nq))/3.0
               TI=(mu+np-nq)/2.0                           
             do tiz=-TI,TI  ! Sabor isoespin_Z
              d=d+exp((vIz*tIz)/t)
              vi=vi+tiz*exp((vIz*tIz)/t)
             end do         ! Sabor isoespin_Z
             ffl=d*exp(vs*Y/t)      ! ffl+   Z
             vfi=vi*exp(vs*Y/t)     ! vfi+  <I_z>
             vfy=d*Y*exp(vs*Y/t)    ! vfy+  <Y>
c            end do       ! Sabor q      
c          end do         ! Sabor p
c             write(*,*) ffl,vfi,vfy
c             read(*,*) werder
          do ns=0,smax                            ! Spin
             do nraiz=1,numeig(ns,nla,nmu,npar,ndj)    ! Eigenvalores
               fd=1.0*ndtj(nraiz,ns,nla,nmu,npar,ndj) !DEGENERACION
     &               *(2*ns+1)                     !SPIN
ccc     &              0.5*(nla+1)*(nla+1)*(nla+nmu+2)  !FLAVOUR
            hcc=1.0   
cGELL-MANN OKUBO FORMULA!!!!!!!!!!

            if (ktest.eq.1) then
            if ((nraiz.eq.1).and.(ns.eq.0).and.(nla.eq.1).and.
     &      (npar.eq.1).and.(ndj.eq.18).and.(nmu.eq.1)) then! Pion-Oktett
            hcc=(1.0+deltmp/(etj(1,0,1,1,1,18)-etj(1,0,0,0,0,18))*
     &                      (TI*(TI+1.0)-Y**2/4.0)+
     &          2.0*(abs(TI)-1.0)*(abs(TI)-1.0/2.0)*hachtp*tan(tetap)) 
            else if ((nraiz.eq.1).and.(ns.eq.1).and.(nla.eq.1).and.
     &      (npar.eq.1).and.(ndj.eq.18).and.(nmu.eq.1) ) then   ! Rho-Oktett
               hcc=(1.0+deltmv/(etj(1,1,1,1,1,18)-etj(1,0,0,0,0,18))*
     &                     (TI*(TI+1.0)-Y**2/4.0)+
     &          2.0*(abs(TI)-1.0)*(abs(TI)-1.0/2.0)*hachtv*tan(tetav))
            else if ((nraiz.eq.1).and.(ns.eq.0).and.(nla.eq.0).and.
     &      (npar.eq.1).and.(ndj.eq.18).and.(nla.eq.0)) then! Eta'-Singlett
               hcc=(1.0+deltmp/(etj(1,0,0,0,1,18)-etj(1,0,0,0,0,18))*
     &                    (TI*(TI+1.0)-Y**2/4.0)+
     &          2.0*(abs(TI)-1.0)*(abs(TI)-1.0/2.0)*hachtp*tan(tetap)) 
            else if ((nraiz.eq.1).and.(ns.eq.1).and.(nla.eq.0).and.
     &      (npar.eq.1).and.(ndj.eq.18).and. (nla.eq.0)) then! Phi-Singlett
               hcc=(1.0+deltmv/(etj(1,1,0,0,1,18)-etj(1,0,0,0,0,18))*
     &                     (TI*(TI+1.0)-Y**2/4.0)+
     &          2.0*(abs(TI)-1.0)*(abs(TI)-1.0/2.0)*hachtv*tan(tetav)) 
            end if
            end if

c FIN DE G-M-O

c               if (hcc.ne.1.0)  write(*,*) hcc                   
            zj=zj+zgb*fd*ffl*exp(-(1/t)*hcc*
     &    (etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18)) )  !Z

            vib=vib+zgb*fd*vfi*exp(-(1/t)*hcc*
     &     (etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18)) )  !<I_z>

            vyb=vyb+zgb*fd*vfy*exp(-(1/t)*hcc*
     &    (etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18)) )  !<Y>

            vee=vee+fd*ffl*hcc*
     &     (etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18) )* !<E>
     &      exp(-(1/t)*hcc*
     &      (etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18)) ) 

c            veec=veec+zgb*fd*ffl*((hcc*
c     &   (etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18)) )**2)*  !<E^2>
c     &     exp(-(1/t)*hcc*
c     &     etj(nraiz,ns,nla,nmu,npar,ndj)-1.0*etj(1,0,0,0,0,18)) 
                 
             end do     ! Eigenvalores 
           end do       ! Spin
            end do       ! Sabor q      
          end do         ! Sabor p
        end do           !Sabor mu
        end do           ! Sabor lamabda
      end do             ! Paridad
  
      return 
      end

      function dimu6(h1,h2,h3,h4,h5,h6)
       integer dimu6,h1,h2,h3,h4,h5,h6
       dimu6=( (h1-h2+1)*(h1-h3+2)*(h1-h4+3)*(h1-h5+4)*(h1-h6+5)
     &*(h2-h3+1)*(h2-h4+2)*(h2-h5+3)*(h2-h6+4)*(h3-h4+1)*(h3-h5+2)
     &*(h3-h6+3)*(h4-h5+1)*(h4-h6+2)*(h5-h6+1) )
     &  / (5*4*3*2*4*3*2*3*2*2) 

        end


